{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module
  Ceta_ITS(Num, Lia_hints, LIA_op, LIA_type, Xmldoc, Lts_impl, Sum(..),
            Sum_bot(..), LIA_value, Termination_proof, Termination_cert_problem,
            check_termination)
  where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;
import qualified Uint;
import qualified Array;
import qualified Uint32;
import qualified Data_Bits;

newtype Int = Int_of_integer Integer;

integer_of_int :: Int -> Integer;
integer_of_int (Int_of_integer k) = k;

equal_int :: Int -> Int -> Bool;
equal_int k l = integer_of_int k == integer_of_int l;

instance Eq Int where {
  a == b = equal_int a b;
};

plus_int :: Int -> Int -> Int;
plus_int k l = Int_of_integer (integer_of_int k + integer_of_int l);

class Plus a where {
  plus :: a -> a -> a;
};

instance Plus Int where {
  plus = plus_int;
};

zero_int :: Int;
zero_int = Int_of_integer (0 :: Integer);

class Zero a where {
  zeroa :: a;
};

instance Zero Int where {
  zeroa = zero_int;
};

less_eq_int :: Int -> Int -> Bool;
less_eq_int k l = integer_of_int k <= integer_of_int l;

class Ord a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

less_int :: Int -> Int -> Bool;
less_int k l = integer_of_int k < integer_of_int l;

instance Ord Int where {
  less_eq = less_eq_int;
  less = less_int;
};

class (Ord a) => Quasi_order a where {
};

class (Quasi_order a) => Weak_order a where {
};

class (Ord a) => Preorder a where {
};

class (Weak_order a, Preorder a) => Order a where {
};

instance Quasi_order Int where {
};

instance Weak_order Int where {
};

instance Preorder Int where {
};

instance Order Int where {
};

class (Plus a) => Semigroup_add a where {
};

class (Semigroup_add a, Zero a) => Monoid_add a where {
};

instance Semigroup_add Int where {
};

instance Monoid_add Int where {
};

class (Order a) => Linorder a where {
};

instance Linorder Int where {
};

newtype Nat = Nat Integer;

integer_of_nat :: Nat -> Integer;
integer_of_nat (Nat x) = x;

equal_nat :: Nat -> Nat -> Bool;
equal_nat m n = integer_of_nat m == integer_of_nat n;

instance Eq Nat where {
  a == b = equal_nat a b;
};

data Num = One | Bit0 Num | Bit1 Num;

one_nat :: Nat;
one_nat = Nat (1 :: Integer);

class One a where {
  one :: a;
};

instance One Nat where {
  one = one_nat;
};

zero_nat :: Nat;
zero_nat = Nat (0 :: Integer);

instance Zero Nat where {
  zeroa = zero_nat;
};

less_eq_nat :: Nat -> Nat -> Bool;
less_eq_nat m n = integer_of_nat m <= integer_of_nat n;

less_nat :: Nat -> Nat -> Bool;
less_nat m n = integer_of_nat m < integer_of_nat n;

instance Ord Nat where {
  less_eq = less_eq_nat;
  less = less_nat;
};

data Ordera = Eqa | Lt | Gt;

comparator_of :: forall a. (Eq a, Linorder a) => a -> a -> Ordera;
comparator_of x y = (if less x y then Lt else (if x == y then Eqa else Gt));

instance Quasi_order Nat where {
};

instance Weak_order Nat where {
};

instance Preorder Nat where {
};

instance Order Nat where {
};

instance Linorder Nat where {
};

compare_nat :: Nat -> Nat -> Ordera;
compare_nat = comparator_of;

class Compare a where {
  compare :: a -> a -> Ordera;
};

instance Compare Nat where {
  compare = compare_nat;
};

class (Compare a, Linorder a) => Compare_order a where {
};

instance Compare_order Nat where {
};

times_int :: Int -> Int -> Int;
times_int k l = Int_of_integer (integer_of_int k * integer_of_int l);

newtype Rat = Frct (Int, Int);

quotient_of :: Rat -> (Int, Int);
quotient_of (Frct x) = x;

less_eq_rat :: Rat -> Rat -> Bool;
less_eq_rat p q = let {
                    a = quotient_of p;
                    (aa, c) = a;
                    b = quotient_of q;
                    (ba, d) = b;
                  } in less_eq_int (times_int aa d) (times_int c ba);

less_rat :: Rat -> Rat -> Bool;
less_rat p q = let {
                 a = quotient_of p;
                 (aa, c) = a;
                 b = quotient_of q;
                 (ba, d) = b;
               } in less_int (times_int aa d) (times_int c ba);

instance Ord Rat where {
  less_eq = less_eq_rat;
  less = less_rat;
};

max :: forall a. (Ord a) => a -> a -> a;
max a b = (if less_eq a b then b else a);

instance Ord Integer where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

nat_of_integer :: Integer -> Nat;
nat_of_integer k = Nat (max (0 :: Integer) k);

class Showa a where {
  shows_prec :: Nat -> a -> [Prelude.Char] -> [Prelude.Char];
  shows_list :: [a] -> [Prelude.Char] -> [Prelude.Char];
};

shows_prec_list ::
  forall a. (Showa a) => Nat -> [a] -> [Prelude.Char] -> [Prelude.Char];
shows_prec_list p xs = shows_list xs;

shows_string :: [Prelude.Char] -> [Prelude.Char] -> [Prelude.Char];
shows_string = (\ a b -> a ++ b);

data Xml = XML [Prelude.Char] [([Prelude.Char], [Prelude.Char])] [Xml]
  | XML_text [Prelude.Char];

shows_prec_char :: Nat -> Prelude.Char -> [Prelude.Char] -> [Prelude.Char];
shows_prec_char p c = (\ a -> c : a);

shows_list_char :: [Prelude.Char] -> [Prelude.Char] -> [Prelude.Char];
shows_list_char cs = shows_string cs;

instance Showa Prelude.Char where {
  shows_prec = shows_prec_char;
  shows_list = shows_list_char;
};

shows_attr ::
  ([Prelude.Char], [Prelude.Char]) -> [Prelude.Char] -> [Prelude.Char];
shows_attr av =
  shows_prec_list zero_nat (fst av) .
    shows_string (['=', '\"'] ++ snd av ++ ['\"']);

foldr :: forall a b. (a -> b -> b) -> [a] -> b -> b;
foldr f [] = id;
foldr f (x : xs) = f x . foldr f xs;

shows_attrs ::
  [([Prelude.Char], [Prelude.Char])] -> [Prelude.Char] -> [Prelude.Char];
shows_attrs asa = foldr (\ a -> shows_string [' '] . shows_attr a) asa;

minus_nat :: Nat -> Nat -> Nat;
minus_nat m n = Nat (max (0 :: Integer) (integer_of_nat m - integer_of_nat n));

replicate :: forall a. Nat -> a -> [a];
replicate n x =
  (if equal_nat n zero_nat then [] else x : replicate (minus_nat n one_nat) x);

shows_XML_indent ::
  [Prelude.Char] -> Nat -> Xml -> [Prelude.Char] -> [Prelude.Char];
shows_XML_indent ind i (XML n a c) =
  shows_string ['\n'] .
    shows_string ind .
      shows_string ['<'] .
        shows_prec_list zero_nat n .
          shows_attrs a .
            (if null c then shows_string ['/', '>']
              else shows_string ['>'] .
                     foldr (shows_XML_indent (replicate i ' ' ++ ind) i) c .
                       shows_string ['\n'] .
                         shows_string ind .
                           shows_string ['<', '/'] .
                             shows_prec_list zero_nat n . shows_string ['>']);
shows_XML_indent ind i (XML_text t) = shows_string t;

shows_prec_xml :: Nat -> Xml -> [Prelude.Char] -> [Prelude.Char];
shows_prec_xml d xml = shows_XML_indent [] (nat_of_integer (2 :: Integer)) xml;

shows_sep ::
  forall a.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      ([Prelude.Char] -> [Prelude.Char]) ->
        [a] -> [Prelude.Char] -> [Prelude.Char];
shows_sep s sep [] = shows_string [];
shows_sep s sep [x] = s x;
shows_sep s sep (x : v : va) = (s x . sep) . shows_sep s sep (v : va);

shows_list_gen ::
  forall a.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      [Prelude.Char] ->
        [Prelude.Char] ->
          [Prelude.Char] ->
            [Prelude.Char] -> [a] -> [Prelude.Char] -> [Prelude.Char];
shows_list_gen showsx e l s r xs =
  (if null xs then shows_string e
    else (shows_string l . shows_sep showsx (shows_string s) xs) .
           shows_string r);

showsp_list ::
  forall a.
    (Nat -> a -> [Prelude.Char] -> [Prelude.Char]) ->
      Nat -> [a] -> [Prelude.Char] -> [Prelude.Char];
showsp_list s p xs =
  shows_list_gen (s zero_nat) ['[', ']'] ['['] [',', ' '] [']'] xs;

shows_list_xml :: [Xml] -> [Prelude.Char] -> [Prelude.Char];
shows_list_xml xs = showsp_list shows_prec_xml zero_nat xs;

instance Showa Xml where {
  shows_prec = shows_prec_xml;
  shows_list = shows_list_xml;
};

shows_list_list ::
  forall a. (Showa a) => [[a]] -> [Prelude.Char] -> [Prelude.Char];
shows_list_list xss = showsp_list shows_prec_list zero_nat xss;

instance (Showa a) => Showa [a] where {
  shows_prec = shows_prec_list;
  shows_list = shows_list_list;
};

less_eq_list :: forall a. (Eq a, Order a) => [a] -> [a] -> Bool;
less_eq_list (x : xs) (y : ys) = less x y || x == y && less_eq_list xs ys;
less_eq_list [] xs = True;
less_eq_list (x : xs) [] = False;

less_list :: forall a. (Eq a, Order a) => [a] -> [a] -> Bool;
less_list (x : xs) (y : ys) = less x y || x == y && less_list xs ys;
less_list [] (x : xs) = True;
less_list xs [] = False;

instance (Eq a, Order a) => Ord [a] where {
  less_eq = less_eq_list;
  less = less_list;
};

comparator_list :: forall a. (a -> a -> Ordera) -> [a] -> [a] -> Ordera;
comparator_list comp_a (x : xa) (y : ya) =
  (case comp_a x y of {
    Eqa -> comparator_list comp_a xa ya;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_list comp_a (x : xa) [] = Gt;
comparator_list comp_a [] (y : ya) = Lt;
comparator_list comp_a [] [] = Eqa;

compare_list :: forall a. (Compare a) => [a] -> [a] -> Ordera;
compare_list = comparator_list compare;

class (Compare_order a) => Key a where {
};

instance (Eq a, Order a) => Quasi_order [a] where {
};

instance (Eq a, Order a) => Weak_order [a] where {
};

instance (Eq a, Order a) => Preorder [a] where {
};

instance (Eq a, Order a) => Order [a] where {
};

instance (Eq a, Linorder a) => Linorder [a] where {
};

instance (Compare a) => Compare [a] where {
  compare = compare_list;
};

instance (Compare_order a, Eq a) => Compare_order [a] where {
};

instance (Eq a, Key a) => Key [a] where {
};

data Term a b = Var b | Fun a [Term a b];

instance (Eq a, Eq b) => Eq (Term a b) where {
  a == b = equal_term a b;
};

equal_term :: forall a b. (Eq a, Eq b) => Term a b -> Term a b -> Bool;
equal_term (Var x1) (Fun x21 x22) = False;
equal_term (Fun x21 x22) (Var x1) = False;
equal_term (Fun x21 x22) (Fun y21 y22) = x21 == y21 && x22 == y22;
equal_term (Var x1) (Var y1) = x1 == y1;

shows_term ::
  forall a b.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      (b -> [Prelude.Char] -> [Prelude.Char]) ->
        Term a b -> [Prelude.Char] -> [Prelude.Char];
shows_term fun var (Var x) = var x;
shows_term fun var (Fun f ts) =
  fun f .
    shows_list_gen id [] ['('] [',', ' '] [')'] (map (shows_term fun var) ts);

shows_prec_term ::
  forall a b.
    (Showa a, Showa b) => Nat -> Term a b -> [Prelude.Char] -> [Prelude.Char];
shows_prec_term d t = shows_term (shows_prec zero_nat) (shows_prec zero_nat) t;

shows_list_term ::
  forall a b.
    (Showa a, Showa b) => [Term a b] -> [Prelude.Char] -> [Prelude.Char];
shows_list_term ts = showsp_list shows_prec_term zero_nat ts;

instance (Showa a, Showa b) => Showa (Term a b) where {
  shows_prec = shows_prec_term;
  shows_list = shows_list_term;
};

instance Ord Prelude.Char where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

instance Quasi_order Prelude.Char where {
};

instance Weak_order Prelude.Char where {
};

instance Preorder Prelude.Char where {
};

instance Order Prelude.Char where {
};

instance Linorder Prelude.Char where {
};

compare_char :: Prelude.Char -> Prelude.Char -> Ordera;
compare_char = comparator_of;

instance Compare Prelude.Char where {
  compare = compare_char;
};

instance Compare_order Prelude.Char where {
};

instance Key Prelude.Char where {
};

data Hint a = Default | Base a | Conjunction [Hint a];

class Default a where {
  defaulta :: a;
};

default_hint :: forall a. (Default a) => Hint a;
default_hint = Default;

instance (Default a) => Default (Hint a) where {
  defaulta = default_hint;
};

data Trans_var a = Pre a | Post a | Intermediate a;

equal_trans_var :: forall a. (Eq a) => Trans_var a -> Trans_var a -> Bool;
equal_trans_var (Post x2) (Intermediate x3) = False;
equal_trans_var (Intermediate x3) (Post x2) = False;
equal_trans_var (Pre x1) (Intermediate x3) = False;
equal_trans_var (Intermediate x3) (Pre x1) = False;
equal_trans_var (Pre x1) (Post x2) = False;
equal_trans_var (Post x2) (Pre x1) = False;
equal_trans_var (Intermediate x3) (Intermediate y3) = x3 == y3;
equal_trans_var (Post x2) (Post y2) = x2 == y2;
equal_trans_var (Pre x1) (Pre y1) = x1 == y1;

instance (Eq a) => Eq (Trans_var a) where {
  a == b = equal_trans_var a b;
};

shows_space :: [Prelude.Char] -> [Prelude.Char];
shows_space = shows_prec_char zero_nat ' ';

shows_pr :: Nat -> [Prelude.Char] -> [Prelude.Char];
shows_pr p = (if less_nat zero_nat p then shows_prec_char zero_nat ')' else id);

shows_pl :: Nat -> [Prelude.Char] -> [Prelude.Char];
shows_pl p = (if less_nat zero_nat p then shows_prec_char zero_nat '(' else id);

showsp_trans_var ::
  forall a.
    (Nat -> a -> [Prelude.Char] -> [Prelude.Char]) ->
      Nat -> Trans_var a -> [Prelude.Char] -> [Prelude.Char];
showsp_trans_var show_v p (Intermediate x) =
  (((shows_pl p .
      shows_string
        ['I', 'n', 't', 'e', 'r', 'm', 'e', 'd', 'i', 'a', 't', 'e']) .
     shows_space) .
    show_v one_nat x) .
    shows_pr p;
showsp_trans_var show_v p (Post x) =
  (((shows_pl p . shows_string ['P', 'o', 's', 't']) . shows_space) .
    show_v one_nat x) .
    shows_pr p;
showsp_trans_var show_v p (Pre x) =
  (((shows_pl p . shows_string ['P', 'r', 'e']) . shows_space) .
    show_v one_nat x) .
    shows_pr p;

shows_prec_trans_var ::
  forall a. (Showa a) => Nat -> Trans_var a -> [Prelude.Char] -> [Prelude.Char];
shows_prec_trans_var = showsp_trans_var shows_prec;

shows_list_trans_var ::
  forall a. (Showa a) => [Trans_var a] -> [Prelude.Char] -> [Prelude.Char];
shows_list_trans_var = showsp_list shows_prec_trans_var zero_nat;

instance (Showa a) => Showa (Trans_var a) where {
  shows_prec = shows_prec_trans_var;
  shows_list = shows_list_trans_var;
};

comparator_trans_var ::
  forall a. (a -> a -> Ordera) -> Trans_var a -> Trans_var a -> Ordera;
comparator_trans_var comp_v (Intermediate x) (Intermediate yb) = comp_v x yb;
comparator_trans_var comp_v (Intermediate x) (Post ya) = Gt;
comparator_trans_var comp_v (Intermediate x) (Pre y) = Gt;
comparator_trans_var comp_v (Post x) (Intermediate yb) = Lt;
comparator_trans_var comp_v (Post x) (Post ya) = comp_v x ya;
comparator_trans_var comp_v (Post x) (Pre y) = Gt;
comparator_trans_var comp_v (Pre x) (Intermediate yb) = Lt;
comparator_trans_var comp_v (Pre x) (Post ya) = Lt;
comparator_trans_var comp_v (Pre x) (Pre y) = comp_v x y;

compare_trans_var ::
  forall a. (Compare a) => Trans_var a -> Trans_var a -> Ordera;
compare_trans_var = comparator_trans_var compare;

le_of_comp :: forall a. (a -> a -> Ordera) -> a -> a -> Bool;
le_of_comp acomp x y = (case acomp x y of {
                         Eqa -> True;
                         Lt -> True;
                         Gt -> False;
                       });

less_eq_trans_var ::
  forall a. (Compare a) => Trans_var a -> Trans_var a -> Bool;
less_eq_trans_var = le_of_comp compare_trans_var;

lt_of_comp :: forall a. (a -> a -> Ordera) -> a -> a -> Bool;
lt_of_comp acomp x y = (case acomp x y of {
                         Eqa -> False;
                         Lt -> True;
                         Gt -> False;
                       });

less_trans_var :: forall a. (Compare a) => Trans_var a -> Trans_var a -> Bool;
less_trans_var = lt_of_comp compare_trans_var;

instance (Compare a) => Ord (Trans_var a) where {
  less_eq = less_eq_trans_var;
  less = less_trans_var;
};

instance (Compare a) => Compare (Trans_var a) where {
  compare = compare_trans_var;
};

instance (Compare a) => Quasi_order (Trans_var a) where {
};

instance (Compare a) => Weak_order (Trans_var a) where {
};

instance (Compare a) => Preorder (Trans_var a) where {
};

instance (Compare a) => Order (Trans_var a) where {
};

instance (Compare a) => Linorder (Trans_var a) where {
};

instance (Compare a) => Compare_order (Trans_var a) where {
};

equal_rat :: Rat -> Rat -> Bool;
equal_rat a b = quotient_of a == quotient_of b;

data QDelta = QDelta Rat Rat;

equal_QDelta :: QDelta -> QDelta -> Bool;
equal_QDelta (QDelta x1 x2) (QDelta y1 y2) = equal_rat x1 y1 && equal_rat x2 y2;

instance Eq QDelta where {
  a == b = equal_QDelta a b;
};

zero_rat :: Rat;
zero_rat = Frct (zero_int, Int_of_integer (1 :: Integer));

one_rat :: Rat;
one_rat = Frct (Int_of_integer (1 :: Integer), Int_of_integer (1 :: Integer));

one_QDelta :: QDelta;
one_QDelta = QDelta one_rat zero_rat;

instance One QDelta where {
  one = one_QDelta;
};

sgn_integer :: Integer -> Integer;
sgn_integer k =
  (if k == (0 :: Integer) then (0 :: Integer)
    else (if k < (0 :: Integer) then (-1 :: Integer) else (1 :: Integer)));

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

divmod_integer :: Integer -> Integer -> (Integer, Integer);
divmod_integer k l =
  (if k == (0 :: Integer) then ((0 :: Integer), (0 :: Integer))
    else (if l == (0 :: Integer) then ((0 :: Integer), k)
           else ((apsnd . (\ a b -> a * b)) . sgn_integer) l
                  (if sgn_integer k == sgn_integer l then divMod (abs k) (abs l)
                    else let {
                           (r, s) = divMod (abs k) (abs l);
                         } in (if s == (0 :: Integer)
                                then (negate r, (0 :: Integer))
                                else (negate r - (1 :: Integer),
                                       Prelude.abs l - s)))));

divide_integer :: Integer -> Integer -> Integer;
divide_integer k l = fst (divmod_integer k l);

divide_int :: Int -> Int -> Int;
divide_int k l =
  Int_of_integer (divide_integer (integer_of_int k) (integer_of_int l));

uminus_int :: Int -> Int;
uminus_int k = Int_of_integer (negate (integer_of_int k));

gcd_int :: Int -> Int -> Int;
gcd_int (Int_of_integer x) (Int_of_integer y) =
  Int_of_integer (Prelude.gcd x y);

normalize :: (Int, Int) -> (Int, Int);
normalize p =
  (if less_int zero_int (snd p)
    then let {
           a = gcd_int (fst p) (snd p);
         } in (divide_int (fst p) a, divide_int (snd p) a)
    else (if equal_int (snd p) zero_int
           then (zero_int, Int_of_integer (1 :: Integer))
           else let {
                  a = uminus_int (gcd_int (fst p) (snd p));
                } in (divide_int (fst p) a, divide_int (snd p) a)));

times_rat :: Rat -> Rat -> Rat;
times_rat p q = Frct (let {
                        a = quotient_of p;
                        (aa, c) = a;
                        b = quotient_of q;
                        (ba, d) = b;
                      } in normalize (times_int aa ba, times_int c d));

qdsnd :: QDelta -> Rat;
qdsnd (QDelta a b) = b;

qdfst :: QDelta -> Rat;
qdfst (QDelta a b) = a;

scaleRat_QDelta :: Rat -> QDelta -> QDelta;
scaleRat_QDelta r qd = QDelta (times_rat r (qdfst qd)) (times_rat r (qdsnd qd));

uminus_rat :: Rat -> Rat;
uminus_rat p = Frct (let {
                       a = quotient_of p;
                       (aa, b) = a;
                     } in (uminus_int aa, b));

uminus_QDelta :: QDelta -> QDelta;
uminus_QDelta qd = QDelta (uminus_rat (qdfst qd)) (uminus_rat (qdsnd qd));

less_eq_QDelta :: QDelta -> QDelta -> Bool;
less_eq_QDelta qd1 qd2 =
  less_rat (qdfst qd1) (qdfst qd2) ||
    equal_rat (qdfst qd1) (qdfst qd2) && less_eq_rat (qdsnd qd1) (qdsnd qd2);

minus_int :: Int -> Int -> Int;
minus_int k l = Int_of_integer (integer_of_int k - integer_of_int l);

minus_rat :: Rat -> Rat -> Rat;
minus_rat p q =
  Frct (let {
          a = quotient_of p;
          (aa, c) = a;
          b = quotient_of q;
          (ba, d) = b;
        } in normalize
               (minus_int (times_int aa d) (times_int ba c), times_int c d));

minus_QDelta :: QDelta -> QDelta -> QDelta;
minus_QDelta qd1 qd2 =
  QDelta (minus_rat (qdfst qd1) (qdfst qd2))
    (minus_rat (qdsnd qd1) (qdsnd qd2));

zero_QDelta :: QDelta;
zero_QDelta = QDelta zero_rat zero_rat;

plus_rat :: Rat -> Rat -> Rat;
plus_rat p q =
  Frct (let {
          a = quotient_of p;
          (aa, c) = a;
          b = quotient_of q;
          (ba, d) = b;
        } in normalize
               (plus_int (times_int aa d) (times_int ba c), times_int c d));

plus_QDelta :: QDelta -> QDelta -> QDelta;
plus_QDelta qd1 qd2 =
  QDelta (plus_rat (qdfst qd1) (qdfst qd2)) (plus_rat (qdsnd qd1) (qdsnd qd2));

less_QDelta :: QDelta -> QDelta -> Bool;
less_QDelta qd1 qd2 =
  less_rat (qdfst qd1) (qdfst qd2) ||
    equal_rat (qdfst qd1) (qdfst qd2) && less_rat (qdsnd qd1) (qdsnd qd2);

class ScaleRat a where {
  scaleRat :: Rat -> a -> a;
};

class Uminus a where {
  uminus :: a -> a;
};

class Minus a where {
  minus :: a -> a -> a;
};

class (Semigroup_add a) => Ab_semigroup_add a where {
};

class (Ab_semigroup_add a, Order a) => Ordered_ab_semigroup_add a where {
};

class (Semigroup_add a) => Cancel_semigroup_add a where {
};

class (Ab_semigroup_add a, Cancel_semigroup_add a,
        Minus a) => Cancel_ab_semigroup_add a where {
};

class (Ab_semigroup_add a, Monoid_add a) => Comm_monoid_add a where {
};

class (Cancel_ab_semigroup_add a,
        Comm_monoid_add a) => Cancel_comm_monoid_add a where {
};

class (Cancel_semigroup_add a, Minus a, Monoid_add a,
        Uminus a) => Group_add a where {
};

class (Cancel_comm_monoid_add a, Group_add a) => Ab_group_add a where {
};

class (ScaleRat a, Ab_group_add a) => Rational_vector a where {
};

class (Rational_vector a, Order a) => Ordered_rational_vector a where {
};

class (Ordered_rational_vector a, Ordered_ab_semigroup_add a,
        Linorder a) => Linordered_rational_vector a where {
};

class (Linordered_rational_vector a, One a) => Lrv a where {
};

instance Plus QDelta where {
  plus = plus_QDelta;
};

instance Semigroup_add QDelta where {
};

instance Ab_semigroup_add QDelta where {
};

instance Ord QDelta where {
  less_eq = less_eq_QDelta;
  less = less_QDelta;
};

instance Quasi_order QDelta where {
};

instance Weak_order QDelta where {
};

instance Preorder QDelta where {
};

instance Order QDelta where {
};

instance Ordered_ab_semigroup_add QDelta where {
};

instance Cancel_semigroup_add QDelta where {
};

instance Minus QDelta where {
  minus = minus_QDelta;
};

instance Cancel_ab_semigroup_add QDelta where {
};

instance Zero QDelta where {
  zeroa = zero_QDelta;
};

instance Monoid_add QDelta where {
};

instance Comm_monoid_add QDelta where {
};

instance Cancel_comm_monoid_add QDelta where {
};

instance Uminus QDelta where {
  uminus = uminus_QDelta;
};

instance Group_add QDelta where {
};

instance Ab_group_add QDelta where {
};

instance ScaleRat QDelta where {
  scaleRat = scaleRat_QDelta;
};

instance Rational_vector QDelta where {
};

instance Ordered_rational_vector QDelta where {
};

instance Linorder QDelta where {
};

instance Linordered_rational_vector QDelta where {
};

instance Lrv QDelta where {
};

data Formula a = Atom a | NegAtom a | Conjunctiona [Formula a]
  | Disjunction [Formula a];

instance (Eq a) => Eq (Formula a) where {
  a == b = equal_formula a b;
};

equal_formula :: forall a. (Eq a) => Formula a -> Formula a -> Bool;
equal_formula (Conjunctiona x3) (Disjunction x4) = False;
equal_formula (Disjunction x4) (Conjunctiona x3) = False;
equal_formula (NegAtom x2) (Disjunction x4) = False;
equal_formula (Disjunction x4) (NegAtom x2) = False;
equal_formula (NegAtom x2) (Conjunctiona x3) = False;
equal_formula (Conjunctiona x3) (NegAtom x2) = False;
equal_formula (Atom x1) (Disjunction x4) = False;
equal_formula (Disjunction x4) (Atom x1) = False;
equal_formula (Atom x1) (Conjunctiona x3) = False;
equal_formula (Conjunctiona x3) (Atom x1) = False;
equal_formula (Atom x1) (NegAtom x2) = False;
equal_formula (NegAtom x2) (Atom x1) = False;
equal_formula (Disjunction x4) (Disjunction y4) = x4 == y4;
equal_formula (Conjunctiona x3) (Conjunctiona y3) = x3 == y3;
equal_formula (NegAtom x2) (NegAtom y2) = x2 == y2;
equal_formula (Atom x1) (Atom y1) = x1 == y1;

showsp_prod ::
  forall a b.
    (Nat -> a -> [Prelude.Char] -> [Prelude.Char]) ->
      (Nat -> b -> [Prelude.Char] -> [Prelude.Char]) ->
        Nat -> (a, b) -> [Prelude.Char] -> [Prelude.Char];
showsp_prod s1 s2 p (x, y) =
  (((shows_string ['('] . s1 one_nat x) . shows_string [',', ' ']) .
    s2 one_nat y) .
    shows_string [')'];

shows_prec_prod ::
  forall a b.
    (Showa a, Showa b) => Nat -> (a, b) -> [Prelude.Char] -> [Prelude.Char];
shows_prec_prod = showsp_prod shows_prec shows_prec;

shows_list_prod ::
  forall a b.
    (Showa a, Showa b) => [(a, b)] -> [Prelude.Char] -> [Prelude.Char];
shows_list_prod = showsp_list shows_prec_prod zero_nat;

instance (Showa a, Showa b) => Showa (a, b) where {
  shows_prec = shows_prec_prod;
  shows_list = shows_list_prod;
};

less_eq_prod :: forall a b. (Ord a, Ord b) => (a, b) -> (a, b) -> Bool;
less_eq_prod (x1, y1) (x2, y2) = less x1 x2 || less_eq x1 x2 && less_eq y1 y2;

less_prod :: forall a b. (Ord a, Ord b) => (a, b) -> (a, b) -> Bool;
less_prod (x1, y1) (x2, y2) = less x1 x2 || less_eq x1 x2 && less y1 y2;

instance (Ord a, Ord b) => Ord (a, b) where {
  less_eq = less_eq_prod;
  less = less_prod;
};

instance (Order a, Order b) => Quasi_order (a, b) where {
};

instance (Order a, Order b) => Weak_order (a, b) where {
};

instance (Preorder a, Preorder b) => Preorder (a, b) where {
};

instance (Order a, Order b) => Order (a, b) where {
};

instance (Linorder a, Linorder b) => Linorder (a, b) where {
};

data Sharp a = Flat a | Sharp a;

equal_sharp :: forall a. (Eq a) => Sharp a -> Sharp a -> Bool;
equal_sharp (Flat x1) (Sharp x2) = False;
equal_sharp (Sharp x2) (Flat x1) = False;
equal_sharp (Sharp x2) (Sharp y2) = x2 == y2;
equal_sharp (Flat x1) (Flat y1) = x1 == y1;

instance (Eq a) => Eq (Sharp a) where {
  a == b = equal_sharp a b;
};

showsp_sharp ::
  forall a.
    (Nat -> a -> [Prelude.Char] -> [Prelude.Char]) ->
      Nat -> Sharp a -> [Prelude.Char] -> [Prelude.Char];
showsp_sharp show_l p (Sharp x) =
  (((shows_pl p . shows_string ['S', 'h', 'a', 'r', 'p']) . shows_space) .
    show_l one_nat x) .
    shows_pr p;
showsp_sharp show_l p (Flat x) =
  (((shows_pl p . shows_string ['F', 'l', 'a', 't']) . shows_space) .
    show_l one_nat x) .
    shows_pr p;

shows_prec_sharp ::
  forall a. (Showa a) => Nat -> Sharp a -> [Prelude.Char] -> [Prelude.Char];
shows_prec_sharp = showsp_sharp shows_prec;

shows_list_sharp ::
  forall a. (Showa a) => [Sharp a] -> [Prelude.Char] -> [Prelude.Char];
shows_list_sharp = showsp_list shows_prec_sharp zero_nat;

instance (Showa a) => Showa (Sharp a) where {
  shows_prec = shows_prec_sharp;
  shows_list = shows_list_sharp;
};

comparator_sharp ::
  forall a. (a -> a -> Ordera) -> Sharp a -> Sharp a -> Ordera;
comparator_sharp comp_l (Sharp x) (Sharp ya) = comp_l x ya;
comparator_sharp comp_l (Sharp x) (Flat y) = Gt;
comparator_sharp comp_l (Flat x) (Sharp ya) = Lt;
comparator_sharp comp_l (Flat x) (Flat y) = comp_l x y;

compare_sharp :: forall a. (Compare a) => Sharp a -> Sharp a -> Ordera;
compare_sharp = comparator_sharp compare;

less_eq_sharp :: forall a. (Compare a) => Sharp a -> Sharp a -> Bool;
less_eq_sharp = le_of_comp compare_sharp;

less_sharp :: forall a. (Compare a) => Sharp a -> Sharp a -> Bool;
less_sharp = lt_of_comp compare_sharp;

instance (Compare a) => Ord (Sharp a) where {
  less_eq = less_eq_sharp;
  less = less_sharp;
};

instance (Compare a) => Quasi_order (Sharp a) where {
};

instance (Compare a) => Weak_order (Sharp a) where {
};

instance (Compare a) => Preorder (Sharp a) where {
};

instance (Compare a) => Order (Sharp a) where {
};

instance (Compare a) => Linorder (Sharp a) where {
};

instance (Compare a) => Compare (Sharp a) where {
  compare = compare_sharp;
};

instance (Compare a) => Compare_order (Sharp a) where {
};

instance (Compare a) => Key (Sharp a) where {
};

data Lia_hints = LIA_Hints [Nat] | LIA_Simplex;

modulo_integer :: Integer -> Integer -> Integer;
modulo_integer k l = snd (divmod_integer k l);

modulo_nat :: Nat -> Nat -> Nat;
modulo_nat m n = Nat (modulo_integer (integer_of_nat m) (integer_of_nat n));

divide_nat :: Nat -> Nat -> Nat;
divide_nat m n = Nat (divide_integer (integer_of_nat m) (integer_of_nat n));

string_of_digit :: Nat -> [Prelude.Char];
string_of_digit n =
  (if equal_nat n zero_nat then ['0']
    else (if equal_nat n one_nat then ['1']
           else (if equal_nat n (nat_of_integer (2 :: Integer)) then ['2']
                  else (if equal_nat n (nat_of_integer (3 :: Integer))
                         then ['3']
                         else (if equal_nat n (nat_of_integer (4 :: Integer))
                                then ['4']
                                else (if equal_nat n
   (nat_of_integer (5 :: Integer))
                                       then ['5']
                                       else (if equal_nat n
          (nat_of_integer (6 :: Integer))
      then ['6']
      else (if equal_nat n (nat_of_integer (7 :: Integer)) then ['7']
             else (if equal_nat n (nat_of_integer (8 :: Integer)) then ['8']
                    else ['9'])))))))));

showsp_nat :: Nat -> Nat -> [Prelude.Char] -> [Prelude.Char];
showsp_nat p n =
  (if less_nat n (nat_of_integer (10 :: Integer))
    then shows_string (string_of_digit n)
    else showsp_nat p (divide_nat n (nat_of_integer (10 :: Integer))) .
           shows_string
             (string_of_digit (modulo_nat n (nat_of_integer (10 :: Integer)))));

showsp_lia_hints :: Nat -> Lia_hints -> [Prelude.Char] -> [Prelude.Char];
showsp_lia_hints p LIA_Simplex =
  shows_string ['L', 'I', 'A', '_', 'S', 'i', 'm', 'p', 'l', 'e', 'x'];
showsp_lia_hints p (LIA_Hints x) =
  (((shows_pl p . shows_string ['L', 'I', 'A', '_', 'H', 'i', 'n', 't', 's']) .
     shows_space) .
    showsp_list showsp_nat one_nat x) .
    shows_pr p;

shows_prec_lia_hints :: Nat -> Lia_hints -> [Prelude.Char] -> [Prelude.Char];
shows_prec_lia_hints = showsp_lia_hints;

shows_list_lia_hints :: [Lia_hints] -> [Prelude.Char] -> [Prelude.Char];
shows_list_lia_hints = showsp_list shows_prec_lia_hints zero_nat;

instance Showa Lia_hints where {
  shows_prec = shows_prec_lia_hints;
  shows_list = shows_list_lia_hints;
};

default_lia_hints :: Lia_hints;
default_lia_hints = LIA_Simplex;

instance Default Lia_hints where {
  defaulta = default_lia_hints;
};

data LIA_op = Less | Lesseq | Sum | Const Int | Cmult Int;

equal_LIA_op :: LIA_op -> LIA_op -> Bool;
equal_LIA_op (Const x4) (Cmult x5) = False;
equal_LIA_op (Cmult x5) (Const x4) = False;
equal_LIA_op Sum (Cmult x5) = False;
equal_LIA_op (Cmult x5) Sum = False;
equal_LIA_op Sum (Const x4) = False;
equal_LIA_op (Const x4) Sum = False;
equal_LIA_op Lesseq (Cmult x5) = False;
equal_LIA_op (Cmult x5) Lesseq = False;
equal_LIA_op Lesseq (Const x4) = False;
equal_LIA_op (Const x4) Lesseq = False;
equal_LIA_op Lesseq Sum = False;
equal_LIA_op Sum Lesseq = False;
equal_LIA_op Less (Cmult x5) = False;
equal_LIA_op (Cmult x5) Less = False;
equal_LIA_op Less (Const x4) = False;
equal_LIA_op (Const x4) Less = False;
equal_LIA_op Less Sum = False;
equal_LIA_op Sum Less = False;
equal_LIA_op Less Lesseq = False;
equal_LIA_op Lesseq Less = False;
equal_LIA_op (Cmult x5) (Cmult y5) = equal_int x5 y5;
equal_LIA_op (Const x4) (Const y4) = equal_int x4 y4;
equal_LIA_op Sum Sum = True;
equal_LIA_op Lesseq Lesseq = True;
equal_LIA_op Less Less = True;

instance Eq LIA_op where {
  a == b = equal_LIA_op a b;
};

nat :: Int -> Nat;
nat k = Nat (max (0 :: Integer) (integer_of_int k));

showsp_int :: Nat -> Int -> [Prelude.Char] -> [Prelude.Char];
showsp_int p i =
  (if less_int i zero_int
    then shows_string ['-'] . showsp_nat p (nat (uminus_int i))
    else showsp_nat p (nat i));

showsp_LIA_op :: Nat -> LIA_op -> [Prelude.Char] -> [Prelude.Char];
showsp_LIA_op p (Cmult x) =
  (((shows_pl p . shows_string ['C', 'm', 'u', 'l', 't']) . shows_space) .
    showsp_int one_nat x) .
    shows_pr p;
showsp_LIA_op p (Const x) =
  (((shows_pl p . shows_string ['C', 'o', 'n', 's', 't']) . shows_space) .
    showsp_int one_nat x) .
    shows_pr p;
showsp_LIA_op p Sum = shows_string ['S', 'u', 'm'];
showsp_LIA_op p Lesseq = shows_string ['L', 'e', 's', 's', 'e', 'q'];
showsp_LIA_op p Less = shows_string ['L', 'e', 's', 's'];

shows_prec_LIA_op :: Nat -> LIA_op -> [Prelude.Char] -> [Prelude.Char];
shows_prec_LIA_op = showsp_LIA_op;

shows_list_LIA_op :: [LIA_op] -> [Prelude.Char] -> [Prelude.Char];
shows_list_LIA_op = showsp_list shows_prec_LIA_op zero_nat;

instance Showa LIA_op where {
  shows_prec = shows_prec_LIA_op;
  shows_list = shows_list_LIA_op;
};

data LIA_type = BoolT | IntegerT;

equal_LIA_type :: LIA_type -> LIA_type -> Bool;
equal_LIA_type BoolT IntegerT = False;
equal_LIA_type IntegerT BoolT = False;
equal_LIA_type IntegerT IntegerT = True;
equal_LIA_type BoolT BoolT = True;

instance Eq LIA_type where {
  a == b = equal_LIA_type a b;
};

showsp_LIA_type :: Nat -> LIA_type -> [Prelude.Char] -> [Prelude.Char];
showsp_LIA_type p IntegerT =
  shows_string ['I', 'n', 't', 'e', 'g', 'e', 'r', 'T'];
showsp_LIA_type p BoolT = shows_string ['B', 'o', 'o', 'l', 'T'];

shows_prec_LIA_type :: Nat -> LIA_type -> [Prelude.Char] -> [Prelude.Char];
shows_prec_LIA_type = showsp_LIA_type;

shows_list_LIA_type :: [LIA_type] -> [Prelude.Char] -> [Prelude.Char];
shows_list_LIA_type = showsp_list shows_prec_LIA_type zero_nat;

instance Showa LIA_type where {
  shows_prec = shows_prec_LIA_type;
  shows_list = shows_list_LIA_type;
};

data Color = R | B;

data Rbta a b = Empty | Branch Color (Rbta a b) a b (Rbta a b);

newtype Rbt b a = RBT (Rbta b a);

data Set a = Set [a] | Coset [a];

newtype Fset a = Abs_fset (Set a);

data Xmldoc = XMLDOC [[Prelude.Char]] Xml;

data Transition_rule a b c d =
  Transition d d (Formula (Term a (Trans_var b, c)));

data Lts_impl a b c d e =
  Lts_Impl d [(e, Transition_rule a b c d)] [(d, Formula (Term a (b, c)))];

data Atom a = Leq Nat a | Geq Nat a;

data Sum a b = Inl a | Inr b;

newtype Fmap a b = Fmap_of_list [(a, b)];

data Lts_ext a b c d e =
  Lts_ext d (Set (Transition_rule a b c d)) (d -> Formula (Term a (b, c))) e;

newtype Mapping a b = Mapping (Rbt a b);

data Comp_res = LESS | EQUAL | GREATER;

newtype Linear_poly = LinearPoly (Fmap Nat Rat);

data Constraint = LT Linear_poly Rat | GT Linear_poly Rat | LEQ Linear_poly Rat
  | GEQ Linear_poly Rat | EQ Linear_poly Rat | LTPP Linear_poly Linear_poly
  | GTPP Linear_poly Linear_poly | LEQPP Linear_poly Linear_poly
  | GEQPP Linear_poly Linear_poly | EQPP Linear_poly Linear_poly;

newtype Sum_bot a b = Sumbot (Sum a b);

data Ns_constraint a = LEQ_ns Linear_poly a | GEQ_ns Linear_poly a;

data Logic_ext a b c d =
  Logic_ext (a -> ([b], b)) (b -> Set c) (Set b) (c -> Bool) (a -> [c] -> c) d;

data State_ext a b =
  State_ext [(Nat, Linear_poly)] (Nat -> Maybe a) (Nat -> Maybe a)
    (Mapping Nat a) Bool b;

data Istate_ext a = Istate_ext Nat [(Nat, Linear_poly)] [Atom QDelta] a;

data Art_edge a b c d e = Cover e | Children [(Transition_rule a b c d, e)];

data Art_ext a b c d e f =
  Art_ext e [e] (e -> Art_edge a b c d e) (e -> d)
    (e -> Formula (Term a (b, c))) f;

data Art_edge_impl a b c = Cover_Edge a c | Children_Edge [(b, (a, c))];

data Art_node_impl a b c d e f g =
  Art_Node e (Formula (Term a (b, c))) d (Art_edge_impl e f g);

data Direction_ext a b =
  Direction_ext (a -> a -> Bool) (State_ext a () -> Nat -> Maybe a)
    (State_ext a () -> Nat -> Maybe a)
    (((Nat -> Maybe a) -> Nat -> Maybe a) -> State_ext a () -> State_ext a ())
    (Nat -> a -> Atom a) b;

data Hinter_ext a b c d e =
  Hinter_ext [c] (b -> [d]) (c -> a) (c -> Maybe [a]) e;

data Lin_exp a = Lin_Exp Int [(a, Int)];

data LIA_value = Integera Int | Boolean Bool;

data Gen_g_impl_ext a b c d = Gen_g_impl_ext a b c d;

data Art_impl_ext a b c d e f g h =
  Art_impl_ext e [Art_node_impl a b c d e f g] h;

data Invariant_proof a b c d e f g =
  Impact [(d, Formula (Term a (b, c)))] (Art_impl_ext a b c d e f (Hint g) ());

data Fresh_variable_addition_info a b c d =
  Fresh_Variable_Addition_Info b c [(d, Formula (Term a (Trans_var b, c)))];

data Transition_removal_info a b c d e f =
  Transition_removal_info (Sharp d -> a) [e] c b (e -> Hint f);

data Location_addition_info a b c d e =
  Location_Addition_Info d d e (Transition_rule a b c d);

data Cooperation_proof a b c d e f g = Trivial
  | Invariants_Update (Invariant_proof a b c (Sharp e) [Prelude.Char] f g)
      (Cooperation_proof a b c d e f g)
  | Location_Addition (Location_addition_info a b c (Sharp e) f)
      (Cooperation_proof a b c d e f g)
  | Fresh_Variable_Addition (Fresh_variable_addition_info a b c f)
      (Cooperation_proof a b c d e f g)
  | Transition_Removal (Transition_removal_info [Term a (b, c)] [d] c e f g)
      (Cooperation_proof a b c d e f g)
  | Scc_Decomp [([Sharp e], Cooperation_proof a b c d e f g)]
  | Cut_Transition_Split [([f], Cooperation_proof a b c d e f g)];

data Termination_proof a b c d e f g = Triviala
  | Via_Cooperation
      [([(Sharp f, Transition_rule a b c (Sharp e))],
         Cooperation_proof a b c d e (Sharp f) g)];

newtype Cut_transition_split_info a = Cut_Transition_Split_Info [[a]];

data Termination_cert_problem a b c d e f g =
  Termination_Cert_Problem (Lts_impl a b c e f)
    (Termination_proof a b c d e f g);

plus_nat :: Nat -> Nat -> Nat;
plus_nat m n = Nat (integer_of_nat m + integer_of_nat n);

suc :: Nat -> Nat;
suc n = plus_nat n one_nat;

tag :: Xml -> [Prelude.Char];
tag (XML name uu uv) = name;
tag (XML_text uw) = [];

nth :: forall a. [a] -> Nat -> a;
nth (x : xs) n =
  (if equal_nat n zero_nat then x else nth xs (minus_nat n one_nat));

upt :: Nat -> Nat -> [Nat];
upt i j = (if less_nat i j then i : upt (suc i) j else []);

returna :: forall a b. a -> Sum_bot b a;
returna x = Sumbot (Inr x);

errora :: forall a b. a -> Sum_bot a b;
errora x = Sumbot (Inl x);

int_of_digit :: Prelude.Char -> Sum_bot [Prelude.Char] Int;
int_of_digit x =
  (if x == '0' then returna zero_int
    else (if x == '1' then returna (Int_of_integer (1 :: Integer))
           else (if x == '2' then returna (Int_of_integer (2 :: Integer))
                  else (if x == '3' then returna (Int_of_integer (3 :: Integer))
                         else (if x == '4'
                                then returna (Int_of_integer (4 :: Integer))
                                else (if x == '5'
                                       then returna
      (Int_of_integer (5 :: Integer))
                                       else (if x == '6'
      then returna (Int_of_integer (6 :: Integer))
      else (if x == '7' then returna (Int_of_integer (7 :: Integer))
             else (if x == '8' then returna (Int_of_integer (8 :: Integer))
                    else (if x == '9'
                           then returna (Int_of_integer (9 :: Integer))
                           else errora
                                  [x, ' ', 'i', 's', ' ', 'n', 'o', 't', ' ',
                                    'a', ' ', 'd', 'i', 'g', 'i',
                                    't']))))))))));

binda :: forall a b c. Sum_bot a b -> (b -> Sum_bot a c) -> Sum_bot a c;
binda (Sumbot a) f = (case a of {
                       Inl b -> Sumbot (Inl b);
                       Inr aa -> f aa;
                     });

int_of_string_aux :: Int -> [Prelude.Char] -> Sum_bot [Prelude.Char] Int;
int_of_string_aux n [] = returna n;
int_of_string_aux n (d : s) =
  binda (int_of_digit d)
    (\ m ->
      int_of_string_aux
        (plus_int (times_int (Int_of_integer (10 :: Integer)) n) m) s);

tl :: forall a. [a] -> [a];
tl [] = [];
tl (x21 : x22) = x22;

take :: forall a. Nat -> [a] -> [a];
take n [] = [];
take n (x : xs) =
  (if equal_nat n zero_nat then [] else x : take (minus_nat n one_nat) xs);

int_of_string :: [Prelude.Char] -> Sum_bot [Prelude.Char] Int;
int_of_string s =
  (if null s
    then errora
           ['c', 'a', 'n', 'n', 'o', 't', ' ', 'c', 'o', 'n', 'v', 'e', 'r',
             't', ' ', 'e', 'm', 'p', 't', 'y', ' ', 's', 't', 'r', 'i', 'n',
             'g', ' ', 'i', 'n', 't', 'o', ' ', 'n', 'u', 'm', 'b', 'e', 'r']
    else (if take one_nat s == ['-']
           then binda (int_of_string_aux zero_int (tl s))
                  (\ i -> returna (minus_int zero_int i))
           else int_of_string_aux zero_int s));

text :: [Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] [Prelude.Char];
text tag (XML n atts [XML_text t]) =
  (if n == tag && null atts then returna t
    else errora
           (concat
             [['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'x', 't',
                'r', 'a', 'c', 't', ' ', 't', 'e', 'x', 't', ' ', 'f', 'o', 'r',
                ' '],
               tag, [' ', 'f', 'r', 'o', 'm', ' '], ['\n'],
               shows_prec_xml zero_nat (XML n atts [XML_text t]) []]));
text tag (XML v va []) =
  errora
    (concat
      [['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'x', 't', 'r',
         'a', 'c', 't', ' ', 't', 'e', 'x', 't', ' ', 'f', 'o', 'r', ' '],
        tag, [' ', 'f', 'r', 'o', 'm', ' '], ['\n'],
        shows_prec_xml zero_nat (XML v va []) []]);
text tag (XML v va (XML ve vf vg : vd)) =
  errora
    (concat
      [['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'x', 't', 'r',
         'a', 'c', 't', ' ', 't', 'e', 'x', 't', ' ', 'f', 'o', 'r', ' '],
        tag, [' ', 'f', 'r', 'o', 'm', ' '], ['\n'],
        shows_prec_xml zero_nat (XML v va (XML ve vf vg : vd)) []]);
text tag (XML v va (vc : ve : vf)) =
  errora
    (concat
      [['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'x', 't', 'r',
         'a', 'c', 't', ' ', 't', 'e', 'x', 't', ' ', 'f', 'o', 'r', ' '],
        tag, [' ', 'f', 'r', 'o', 'm', ' '], ['\n'],
        shows_prec_xml zero_nat (XML v va (vc : ve : vf)) []]);
text tag (XML_text v) =
  errora
    (concat
      [['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'x', 't', 'r',
         'a', 'c', 't', ' ', 't', 'e', 'x', 't', ' ', 'f', 'o', 'r', ' '],
        tag, [' ', 'f', 'r', 'o', 'm', ' '], ['\n'],
        shows_prec_xml zero_nat (XML_text v) []]);

int :: [Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] Int;
int tag x = binda (text tag x) int_of_string;

drop :: forall a. Nat -> [a] -> [a];
drop n [] = [];
drop n (x : xs) =
  (if equal_nat n zero_nat then x : xs else drop (minus_nat n one_nat) xs);

fold :: forall a b. (a -> b -> b) -> [a] -> b -> b;
fold f (x : xs) s = fold f xs (f x s);
fold f [] s = s;

empty :: forall a b. (Linorder a) => Rbt a b;
empty = RBT Empty;

image :: forall a b. (a -> b) -> Set a -> Set b;
image f (Set xs) = Set (map f xs);

gen_length :: forall a. Nat -> [a] -> Nat;
gen_length n (x : xs) = gen_length (suc n) xs;
gen_length n [] = n;

size_list :: forall a. [a] -> Nat;
size_list = gen_length zero_nat;

root :: forall a b. Term a b -> Maybe (a, Nat);
root (Var x) = Nothing;
root (Fun f ts) = Just (f, size_list ts);

fail :: forall a. [Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] a;
fail tag xml =
  errora
    (concat
      [['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 't', 'r', 'a', 'n',
         's', 'f', 'o', 'r', 'm', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l', 'l',
         'o', 'w', 'i', 'n', 'g', ' ', 'x', 'm', 'l', ' ', 'e', 'l', 'e', 'm',
         'e', 'n', 't', ' ', '(', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' '],
        tag, [')'], ['\n'], shows_prec_xml zero_nat xml []]);

leaf :: forall a. [Prelude.Char] -> a -> Xml -> Sum_bot [Prelude.Char] a;
leaf tag x (XML name atts cs) =
  (if name == tag && null atts && null cs then returna x
    else fail tag (XML name atts cs));
leaf tag x (XML_text v) = fail tag (XML_text v);

map_sum_bot :: forall a b c. (a -> Sum_bot b c) -> [a] -> Sum_bot b [c];
map_sum_bot f [] = returna [];
map_sum_bot f (x : xs) =
  binda (f x) (\ y -> binda (map_sum_bot f xs) (\ ys -> returna (y : ys)));

many ::
  forall a b.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        ([a] -> b) -> Xml -> Sum_bot [Prelude.Char] b;
many tag p f (XML name atts cs) =
  (if name == tag && null atts then binda (map_sum_bot p cs) (returna . f)
    else fail tag (XML name atts cs));
many tag p f (XML_text v) = fail tag (XML_text v);

list2elements :: forall a. [a] -> Maybe (a, a);
list2elements [x, y] = Just (x, y);
list2elements [] = Nothing;
list2elements [v] = Nothing;
list2elements (v : vb : vd : ve) = Nothing;

pair ::
  forall a b c.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (a -> b -> c) -> Xml -> Sum_bot [Prelude.Char] c;
pair tag p1 p2 f xml =
  (case xml of {
    XML name atts cs ->
      (if name == tag && null atts
        then (case list2elements cs of {
               Nothing -> fail tag xml;
               Just (cs1, cs2) ->
                 binda (p1 cs1)
                   (\ a -> binda (p2 cs2) (\ b -> returna (f a b)));
             })
        else fail tag xml);
    XML_text _ -> fail tag xml;
  });

transitions_impl ::
  forall a b c d e. Lts_impl a b c d e -> [(e, Transition_rule a b c d)];
transitions_impl (Lts_Impl x1 x2 x3) = x2;

initiala :: forall a b c d e. Lts_impl a b c d e -> d;
initiala (Lts_Impl x1 x2 x3) = x1;

assertion_impl ::
  forall a b c d e. Lts_impl a b c d e -> [(d, Formula (Term a (b, c)))];
assertion_impl (Lts_Impl x1 x2 x3) = x3;

rbt_lookupa :: forall a b. (Compare_order a) => Rbta a b -> a -> Maybe b;
rbt_lookupa (Branch uu l x y r) k = (case compare k x of {
                                      Eqa -> Just y;
                                      Lt -> rbt_lookupa l k;
                                      Gt -> rbt_lookupa r k;
                                    });
rbt_lookupa Empty k = Nothing;

impl_of :: forall b a. (Linorder b) => Rbt b a -> Rbta b a;
impl_of (RBT x) = x;

lookup :: forall a b. (Compare_order a) => Rbt a b -> a -> Maybe b;
lookup x = rbt_lookupa (impl_of x);

lookupa :: forall a b. (Compare_order a) => Mapping a b -> a -> Maybe b;
lookupa (Mapping t) = lookup t;

lookup_default :: forall a b. (Compare_order b) => a -> Mapping b a -> b -> a;
lookup_default d m k = (case lookupa m k of {
                         Nothing -> d;
                         Just v -> v;
                       });

balance :: forall a b. Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
balance (Branch R a w x b) s t (Branch R c y z d) =
  Branch R (Branch B a w x b) s t (Branch B c y z d);
balance (Branch R (Branch R a w x b) s t c) y z Empty =
  Branch R (Branch B a w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch R a w x b) s t c) y z (Branch B va vb vc vd) =
  Branch R (Branch B a w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R Empty w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch B va vb vc vd) w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch R Empty w x (Branch R b s t c)) y z (Branch B va vb vc vd) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R (Branch B ve vf vg vh) w x (Branch R b s t c)) y z
  (Branch B va vb vc vd) =
  Branch R (Branch B (Branch B ve vf vg vh) w x b) s t
    (Branch B c y z (Branch B va vb vc vd));
balance Empty w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z d);
balance (Branch B va vb vc vd) w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z d);
balance Empty w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance Empty w x (Branch R (Branch R b s t c) y z (Branch B va vb vc vd)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch B va vb vc vd) w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch B va vb vc vd) w x
  (Branch R (Branch R b s t c) y z (Branch B ve vf vg vh)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t
    (Branch B c y z (Branch B ve vf vg vh));
balance Empty s t Empty = Branch B Empty s t Empty;
balance Empty s t (Branch B va vb vc vd) =
  Branch B Empty s t (Branch B va vb vc vd);
balance Empty s t (Branch v Empty vb vc Empty) =
  Branch B Empty s t (Branch v Empty vb vc Empty);
balance Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty) =
  Branch B Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty);
balance Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi)) =
  Branch B Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi));
balance Empty s t (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi))
  = Branch B Empty s t
      (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi));
balance (Branch B va vb vc vd) s t Empty =
  Branch B (Branch B va vb vc vd) s t Empty;
balance (Branch B va vb vc vd) s t (Branch B ve vf vg vh) =
  Branch B (Branch B va vb vc vd) s t (Branch B ve vf vg vh);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty) =
  Branch B (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v (Branch B vi vj vk vl) vf vg Empty)
  = Branch B (Branch B va vb vc vd) s t
      (Branch v (Branch B vi vj vk vl) vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg (Branch B vj vk vl vm))
  = Branch B (Branch B va vb vc vd) s t
      (Branch v Empty vf vg (Branch B vj vk vl vm));
balance (Branch B va vb vc vd) s t
  (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm)) =
  Branch B (Branch B va vb vc vd) s t
    (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm));
balance (Branch v Empty vb vc Empty) s t Empty =
  Branch B (Branch v Empty vb vc Empty) s t Empty;
balance (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty =
  Branch B (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty =
  Branch B (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t Empty
  = Branch B (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t
      Empty;
balance (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd) =
  Branch B (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd);
balance (Branch v Empty vf vg (Branch B vi vj vk vl)) s t (Branch B va vb vc vd)
  = Branch B (Branch v Empty vf vg (Branch B vi vj vk vl)) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg Empty) s t (Branch B va vb vc vd)
  = Branch B (Branch v (Branch B vj vk vl vm) vf vg Empty) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
  (Branch B va vb vc vd) =
  Branch B (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
    (Branch B va vb vc vd);

rbt_ins ::
  forall a b.
    (Compare_order a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_ins f k v (Branch R l x y r) = (case compare k x of {
                                     Eqa -> Branch R l x (f k y v) r;
                                     Lt -> Branch R (rbt_ins f k v l) x y r;
                                     Gt -> Branch R l x y (rbt_ins f k v r);
                                   });
rbt_ins f k v (Branch B l x y r) = (case compare k x of {
                                     Eqa -> Branch B l x (f k y v) r;
                                     Lt -> balance (rbt_ins f k v l) x y r;
                                     Gt -> balance l x y (rbt_ins f k v r);
                                   });
rbt_ins f k v Empty = Branch R Empty k v Empty;

paint :: forall a b. Color -> Rbta a b -> Rbta a b;
paint c Empty = Empty;
paint c (Branch uu l k v r) = Branch c l k v r;

rbt_insert_with_key ::
  forall a b.
    (Compare_order a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_insert_with_key f k v t = paint B (rbt_ins f k v t);

rbt_insert :: forall a b. (Compare_order a) => a -> b -> Rbta a b -> Rbta a b;
rbt_insert = rbt_insert_with_key (\ _ _ nv -> nv);

insert :: forall a b. (Compare_order a) => a -> b -> Rbt a b -> Rbt a b;
insert xc xd xe = RBT (rbt_insert xc xd (impl_of xe));

updatea ::
  forall a b. (Compare_order a) => a -> b -> Mapping a b -> Mapping a b;
updatea k v (Mapping t) = Mapping (insert k v t);

emptya :: forall a b. (Linorder a) => Mapping a b;
emptya = Mapping empty;

of_alist :: forall a b. (Compare_order a) => [(a, b)] -> Mapping a b;
of_alist xs = foldr (\ (a, b) -> updatea a b) xs emptya;

map_of_default :: forall a b. (Compare_order b) => a -> [(b, a)] -> b -> a;
map_of_default d xs = lookup_default d (of_alist xs);

assertion_of ::
  forall a b c d e.
    (Compare_order d) => Lts_impl a b c d e -> d -> Formula (Term a (b, c));
assertion_of pi = map_of_default (Conjunctiona []) (assertion_impl pi);

lts_of ::
  forall a b c d e.
    (Compare_order d) => Lts_impl a b c d e -> Lts_ext a b c d ();
lts_of pi =
  Lts_ext (initiala pi) (image snd (Set (transitions_impl pi)))
    (assertion_of pi) ();

source :: forall a b c d. Transition_rule a b c d -> d;
source (Transition l uu uv) = l;

target :: forall a b c d. Transition_rule a b c d -> d;
target (Transition uu r uv) = r;

foldl :: forall a b. (a -> b -> a) -> a -> [b] -> a;
foldl f a [] = a;
foldl f a (x : xs) = foldl f (f a x) xs;

map_of :: forall a b. (Eq a) => [(a, b)] -> a -> Maybe b;
map_of ((l, v) : ps) k = (if l == k then Just v else map_of ps k);
map_of [] k = Nothing;

val :: QDelta -> Rat -> Rat;
val qd delta = plus_rat (qdfst qd) (times_rat delta (qdsnd qd));

of_int :: Int -> Rat;
of_int a = Frct (a, Int_of_integer (1 :: Integer));

removeAll :: forall a. (Eq a) => a -> [a] -> [a];
removeAll x [] = [];
removeAll x (y : xs) = (if x == y then removeAll x xs else y : removeAll x xs);

membera :: forall a. (Eq a) => [a] -> a -> Bool;
membera [] y = False;
membera (x : xs) y = x == y || membera xs y;

insertb :: forall a. (Eq a) => a -> [a] -> [a];
insertb x xs = (if membera xs x then xs else x : xs);

inserta :: forall a. (Eq a) => a -> Set a -> Set a;
inserta x (Coset xs) = Coset (removeAll x xs);
inserta x (Set xs) = Set (insertb x xs);

member :: forall a. (Eq a) => a -> Set a -> Bool;
member x (Coset xs) = not (membera xs x);
member x (Set xs) = membera xs x;

const :: forall a b. a -> b -> a;
const = (\ x _ -> x);

many1_gen ::
  forall a b c.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (a -> Xml -> Sum_bot [Prelude.Char] b) ->
          (a -> [b] -> c) -> Xml -> Sum_bot [Prelude.Char] c;
many1_gen tag p1 p2 f (XML name atts cs) =
  (if name == tag && null atts && not (null cs)
    then let {
           (h : t) = cs;
         } in binda (p1 h)
                (\ x -> binda (map_sum_bot (p2 x) t) (\ xs -> returna (f x xs)))
    else fail tag (XML name atts cs));
many1_gen tag p1 p2 f (XML_text v) = fail tag (XML_text v);

many1 ::
  forall a b c.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (a -> [b] -> c) -> Xml -> Sum_bot [Prelude.Char] c;
many1 tag p1 p2 = many1_gen tag p1 (\ _ -> p2);

update :: forall a b. (Eq a) => a -> b -> [(a, b)] -> [(a, b)];
update k v [] = [(k, v)];
update k v (p : ps) = (if fst p == k then (k, v) : ps else p : update k v ps);

merge :: forall a b. (Eq a) => [(a, b)] -> [(a, b)] -> [(a, b)];
merge qs ps = foldr (\ (a, b) -> update a b) ps qs;

fset :: forall a. Fset a -> Set a;
fset (Abs_fset x) = x;

fimage :: forall b a. (b -> a) -> Fset b -> Fset a;
fimage xb xc = Abs_fset (image xb (fset xc));

fun_upd :: forall a b. (Eq a) => (a -> b) -> a -> b -> a -> b;
fun_upd f a b = (\ x -> (if x == a then b else f x));

bind :: forall a b. Maybe a -> (a -> Maybe b) -> Maybe b;
bind Nothing f = Nothing;
bind (Just x) f = f x;

lhs :: (Nat, Linear_poly) -> Nat;
lhs (l, r) = l;

rhs :: (Nat, Linear_poly) -> Linear_poly;
rhs (l, r) = r;

letters :: [Prelude.Char];
letters =
  ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
    'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D',
    'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S',
    'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '_', '0', '1', '2', '3', '4', '5', '6',
    '7', '8', '9', '&', ';', ':', '-'];

change ::
  forall a b.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      (a -> b) -> Xml -> Sum_bot [Prelude.Char] b;
change p f x = binda (p x) (returna . f);

list3elements :: forall a. [a] -> Maybe (a, (a, a));
list3elements [x, y, z] = Just (x, (y, z));
list3elements [] = Nothing;
list3elements [v] = Nothing;
list3elements [v, vb] = Nothing;
list3elements (v : vb : vd : vf : vg) = Nothing;

triple ::
  forall a b c d.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (a -> b -> c -> d) -> Xml -> Sum_bot [Prelude.Char] d;
triple tag p1 p2 p3 f xml =
  (case xml of {
    XML name atts cs ->
      (if name == tag && null atts
        then (case list3elements cs of {
               Nothing -> fail tag xml;
               Just (cs1, (cs2, cs3)) ->
                 binda (p1 cs1)
                   (\ a ->
                     binda (p2 cs2)
                       (\ b -> binda (p3 cs3) (\ c -> returna (f a b c))));
             })
        else fail tag xml);
    XML_text _ -> fail tag xml;
  });

list4elements :: forall a. [a] -> Maybe (a, (a, (a, a)));
list4elements [x, y, z, u] = Just (x, (y, (z, u)));
list4elements [] = Nothing;
list4elements [v] = Nothing;
list4elements [v, vb] = Nothing;
list4elements [v, vb, vd] = Nothing;
list4elements (v : vb : vd : vf : vh : vi) = Nothing;

tuple4 ::
  forall a b c d e.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (Xml -> Sum_bot [Prelude.Char] d) ->
              (a -> b -> c -> d -> e) -> Xml -> Sum_bot [Prelude.Char] e;
tuple4 tag p1 p2 p3 p4 f xml =
  (case xml of {
    XML name atts cs ->
      (if name == tag && null atts
        then (case list4elements cs of {
               Nothing -> fail tag xml;
               Just (cs1, (cs2, (cs3, cs4))) ->
                 binda (p1 cs1)
                   (\ a ->
                     binda (p2 cs2)
                       (\ b ->
                         binda (p3 cs3)
                           (\ c ->
                             binda (p4 cs4) (\ d -> returna (f a b c d)))));
             })
        else fail tag xml);
    XML_text _ -> fail tag xml;
  });

list5elements :: forall a. [a] -> Maybe (a, (a, (a, (a, a))));
list5elements [x, y, z, u, v] = Just (x, (y, (z, (u, v))));
list5elements [] = Nothing;
list5elements [v] = Nothing;
list5elements [v, vb] = Nothing;
list5elements [v, vb, vd] = Nothing;
list5elements [v, vb, vd, vf] = Nothing;
list5elements (v : vb : vd : vf : vh : vj : vk) = Nothing;

tuple5 ::
  forall a b c d e f.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (Xml -> Sum_bot [Prelude.Char] d) ->
              (Xml -> Sum_bot [Prelude.Char] e) ->
                (a -> b -> c -> d -> e -> f) -> Xml -> Sum_bot [Prelude.Char] f;
tuple5 tag p1 p2 p3 p4 p5 f xml =
  (case xml of {
    XML name atts cs ->
      (if name == tag && null atts
        then (case list5elements cs of {
               Nothing -> fail tag xml;
               Just (cs1, (cs2, (cs3, (cs4, cs5)))) ->
                 binda (p1 cs1)
                   (\ a ->
                     binda (p2 cs2)
                       (\ b ->
                         binda (p3 cs3)
                           (\ c ->
                             binda (p4 cs4)
                               (\ d ->
                                 binda (p5 cs5)
                                   (\ e -> returna (f a b c d e))))));
             })
        else fail tag xml);
    XML_text _ -> fail tag xml;
  });

foldli :: forall a b. [a] -> (b -> Bool) -> (a -> b -> b) -> b -> b;
foldli [] c f sigma = sigma;
foldli (x : xs) c f sigma =
  (if c sigma then foldli xs c f (f x sigma) else sigma);

hd :: forall a. [a] -> a;
hd (x21 : x22) = x21;

remdups :: forall a. (Eq a) => [a] -> [a];
remdups [] = [];
remdups (x : xs) = (if membera xs x then remdups xs else x : remdups xs);

rbt_bulkload :: forall a b. (Compare_order a) => [(a, b)] -> Rbta a b;
rbt_bulkload xs = foldr (\ (a, b) -> rbt_insert a b) xs Empty;

bulkload :: forall a b. (Compare_order a) => [(a, b)] -> Rbt a b;
bulkload xa = RBT (rbt_bulkload xa);

gelb :: forall a. (Eq a) => (a -> a -> Bool) -> a -> Maybe a -> Bool;
gelb lt c b = (case b of {
                Nothing -> True;
                Just ba -> lt ba c || ba == c;
              });

geub :: forall a. (Eq a) => (a -> a -> Bool) -> a -> Maybe a -> Bool;
geub lt c b = (case b of {
                Nothing -> False;
                Just ba -> lt ba c || ba == c;
              });

gtlb :: forall a b. (a -> b -> Bool) -> b -> Maybe a -> Bool;
gtlb lt c b = (case b of {
                Nothing -> True;
                Just ba -> lt ba c;
              });

leub :: forall a. (Eq a) => (a -> a -> Bool) -> a -> Maybe a -> Bool;
leub lt c b = (case b of {
                Nothing -> True;
                Just ba -> lt c ba || c == ba;
              });

ltlb :: forall a b. (a -> b -> Bool) -> a -> Maybe b -> Bool;
ltlb lt c b = (case b of {
                Nothing -> False;
                Just a -> lt c a;
              });

ltub :: forall a b. (a -> b -> Bool) -> a -> Maybe b -> Bool;
ltub lt c b = (case b of {
                Nothing -> True;
                Just a -> lt c a;
              });

poly :: forall a. Ns_constraint a -> Linear_poly;
poly (LEQ_ns p a) = p;
poly (GEQ_ns p a) = p;

options ::
  forall a.
    [([Prelude.Char], Xml -> Sum_bot [Prelude.Char] a)] ->
      Xml -> Sum_bot [Prelude.Char] a;
options ps x =
  (case map_of ps (tag x) of {
    Nothing ->
      errora
        (concat
          [['e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'o', 'n', 'e', ' ',
             'o', 'f', ':', ' '],
            concatMap (\ p -> fst p ++ [' ']) ps, ['\n'],
            ['b', 'u', 't', ' ', 'f', 'o', 'u', 'n', 'd'], ['\n'],
            shows_prec_xml zero_nat x []]);
    Just p -> p x;
  });

isLit :: forall a. Formula a -> Bool;
isLit (Atom uu) = True;
isLit (NegAtom uv) = True;
isLit (Conjunctiona v) = False;
isLit (Disjunction v) = False;

or_ok :: forall a. Sum a () -> Sum a () -> Sum a ();
or_ok (Inl a) b = b;
or_ok (Inr a) b = Inr a;

distinct :: forall a. (Eq a) => [a] -> Bool;
distinct [] = True;
distinct (x : xs) = not (membera xs x) && distinct xs;

shows_nl :: [Prelude.Char] -> [Prelude.Char];
shows_nl = shows_prec_char zero_nat '\n';

lvars :: [(Nat, Linear_poly)] -> Set Nat;
lvars t = Set (map lhs t);

linear_poly_map :: Linear_poly -> Fmap Nat Rat;
linear_poly_map (LinearPoly x) = x;

fmmap :: forall a b c. (a -> b) -> Fmap c a -> Fmap c b;
fmmap f (Fmap_of_list m) = Fmap_of_list (map (apsnd f) m);

fmempty :: forall a b. Fmap a b;
fmempty = Fmap_of_list [];

scale :: Rat -> Fmap Nat Rat -> Fmap Nat Rat;
scale r lp = (if equal_rat r zero_rat then fmempty else fmmap (times_rat r) lp);

scaleRat_linear_poly :: Rat -> Linear_poly -> Linear_poly;
scaleRat_linear_poly r p = LinearPoly (scale r (linear_poly_map p));

uminus_linear_poly :: Linear_poly -> Linear_poly;
uminus_linear_poly lp = scaleRat_linear_poly (uminus_rat one_rat) lp;

fmlookup :: forall a b. (Eq a) => Fmap a b -> a -> Maybe b;
fmlookup (Fmap_of_list m) = map_of m;

get_var_coeff :: Fmap Nat Rat -> Nat -> Rat;
get_var_coeff lp v = (case fmlookup lp v of {
                       Nothing -> zero_rat;
                       Just c -> c;
                     });

part :: forall a b. (Linorder b) => (a -> b) -> b -> [a] -> ([a], ([a], [a]));
part f pivot (x : xs) =
  let {
    (lts, (eqs, gts)) = part f pivot xs;
    xa = f x;
  } in (if less xa pivot then (x : lts, (eqs, gts))
         else (if less pivot xa then (lts, (eqs, x : gts))
                else (lts, (x : eqs, gts))));
part f pivot [] = ([], ([], []));

sort_key :: forall a b. (Linorder b) => (a -> b) -> [a] -> [a];
sort_key f xs =
  (case xs of {
    [] -> [];
    [_] -> xs;
    [x, y] -> (if less_eq (f x) (f y) then xs else [y, x]);
    _ : _ : _ : _ ->
      let {
        (lts, (eqs, gts)) =
          part f
            (f (nth xs
                 (divide_nat (size_list xs) (nat_of_integer (2 :: Integer)))))
            xs;
      } in sort_key f lts ++ eqs ++ sort_key f gts;
  });

sorted_list_of_set :: forall a. (Eq a, Linorder a) => Set a -> [a];
sorted_list_of_set (Set xs) = sort_key (\ x -> x) (remdups xs);

fset_of_list :: forall a. [a] -> Fset a;
fset_of_list xa = Abs_fset (Set xa);

fmdom :: forall a b. Fmap a b -> Fset a;
fmdom (Fmap_of_list m) = fimage fst (fset_of_list m);

ordered_keys :: forall a b. (Eq a, Linorder a) => Fmap a b -> [a];
ordered_keys m = sorted_list_of_set (fset (fmdom m));

fmfilter :: forall a b. (a -> Bool) -> Fmap a b -> Fmap a b;
fmfilter p (Fmap_of_list m) = Fmap_of_list (filter (\ (k, _) -> p k) m);

fmdrop :: forall a b. (Eq a) => a -> Fmap a b -> Fmap a b;
fmdrop a = fmfilter (\ aa -> not (aa == a));

fmadd :: forall a b. (Eq a) => Fmap a b -> Fmap a b -> Fmap a b;
fmadd (Fmap_of_list m) (Fmap_of_list n) = Fmap_of_list (merge m n);

fmupd :: forall a b. (Eq a) => a -> b -> Fmap a b -> Fmap a b;
fmupd k v m = fmadd m (Fmap_of_list [(k, v)]);

set_var_coeff :: Nat -> Rat -> Fmap Nat Rat -> Fmap Nat Rat;
set_var_coeff v c lp =
  (if equal_rat c zero_rat then fmdrop v lp else fmupd v c lp);

add_monom :: Rat -> Nat -> Fmap Nat Rat -> Fmap Nat Rat;
add_monom c v lp = set_var_coeff v (plus_rat c (get_var_coeff lp v)) lp;

add :: Fmap Nat Rat -> Fmap Nat Rat -> Fmap Nat Rat;
add lp1 lp2 =
  foldl (\ lp v -> add_monom (get_var_coeff lp1 v) v lp) lp2 (ordered_keys lp1);

plus_linear_poly :: Linear_poly -> Linear_poly -> Linear_poly;
plus_linear_poly p1 p2 =
  LinearPoly (add (linear_poly_map p1) (linear_poly_map p2));

minus_linear_poly :: Linear_poly -> Linear_poly -> Linear_poly;
minus_linear_poly lp1 lp2 = plus_linear_poly lp1 (uminus_linear_poly lp2);

constraint_to_qdelta_constraint :: Constraint -> [Ns_constraint QDelta];
constraint_to_qdelta_constraint (LT l r) =
  [LEQ_ns l (QDelta r (uminus_rat one_rat))];
constraint_to_qdelta_constraint (GT l r) = [GEQ_ns l (QDelta r one_rat)];
constraint_to_qdelta_constraint (LEQ l r) = [LEQ_ns l (QDelta r zero_rat)];
constraint_to_qdelta_constraint (GEQ l r) = [GEQ_ns l (QDelta r zero_rat)];
constraint_to_qdelta_constraint (EQ l r) =
  [LEQ_ns l (QDelta r zero_rat), GEQ_ns l (QDelta r zero_rat)];
constraint_to_qdelta_constraint (LTPP l1 l2) =
  [LEQ_ns (minus_linear_poly l1 l2) (QDelta zero_rat (uminus_rat one_rat))];
constraint_to_qdelta_constraint (GTPP l1 l2) =
  [GEQ_ns (minus_linear_poly l1 l2) (QDelta zero_rat one_rat)];
constraint_to_qdelta_constraint (LEQPP l1 l2) =
  [LEQ_ns (minus_linear_poly l1 l2) zero_QDelta];
constraint_to_qdelta_constraint (GEQPP l1 l2) =
  [GEQ_ns (minus_linear_poly l1 l2) zero_QDelta];
constraint_to_qdelta_constraint (EQPP l1 l2) =
  [LEQ_ns (minus_linear_poly l1 l2) zero_QDelta,
    GEQ_ns (minus_linear_poly l1 l2) zero_QDelta];

to_ns :: [Constraint] -> [Ns_constraint QDelta];
to_ns l = concatMap constraint_to_qdelta_constraint l;

is_letter :: Prelude.Char -> Bool;
is_letter c =
  'a' <= c && c <= 'z' ||
    ('A' <= c && c <= 'Z' ||
      ('0' <= c && c <= '9' || membera ['_', '&', ';', ':', '-'] c));

update_tokens :: forall a. ([a] -> [a]) -> [a] -> Sum [Prelude.Char] ([a], [a]);
update_tokens f ts = Inr (ts, f ts);

remove_comments_aux_acc ::
  [Prelude.Char] -> Bool -> [Prelude.Char] -> [Prelude.Char];
remove_comments_aux_acc a False (c : cs) =
  (if c == '<' && take (nat_of_integer (3 :: Integer)) cs == ['!', '-', '-']
    then remove_comments_aux_acc a True (tl cs)
    else remove_comments_aux_acc (c : a) False cs);
remove_comments_aux_acc a True (c : cs) =
  (if c == '-' && take (nat_of_integer (2 :: Integer)) cs == ['-', '>']
    then remove_comments_aux_acc a False
           (drop (nat_of_integer (2 :: Integer)) cs)
    else remove_comments_aux_acc a True cs);
remove_comments_aux_acc a uu [] = a;

remove_comments_aux :: Bool -> [Prelude.Char] -> [Prelude.Char];
remove_comments_aux False (c : cs) =
  (if c == '<' && take (nat_of_integer (3 :: Integer)) cs == ['!', '-', '-']
    then remove_comments_aux True (tl cs)
    else c : remove_comments_aux False cs);
remove_comments_aux True (c : cs) =
  (if c == '-' && take (nat_of_integer (2 :: Integer)) cs == ['-', '>']
    then remove_comments_aux False (drop (nat_of_integer (2 :: Integer)) cs)
    else remove_comments_aux True cs);
remove_comments_aux uu [] = [];

remove_comments :: [Prelude.Char] -> [Prelude.Char];
remove_comments =
  (if False then reverse . remove_comments_aux_acc [] False
    else remove_comments_aux False);

returnb :: forall a b. a -> [b] -> Sum [Prelude.Char] (a, [b]);
returnb x = (\ ts -> Inr (x, ts));

bindb :: forall a b c. Sum a b -> (b -> Sum a c) -> Sum a c;
bindb m f = (case m of {
              Inl a -> Inl a;
              Inr a -> f a;
            });

bindc ::
  forall a b c.
    ([a] -> Sum [Prelude.Char] (b, [a])) ->
      (b -> [a] -> Sum [Prelude.Char] (c, [a])) ->
        [a] -> Sum [Prelude.Char] (c, [a]);
bindc m f ts = bindb (m ts) (\ (a, b) -> f a b);

shows_quote ::
  ([Prelude.Char] -> [Prelude.Char]) -> [Prelude.Char] -> [Prelude.Char];
shows_quote s =
  (shows_prec_char zero_nat '\'' . s) . shows_prec_char zero_nat '\'';

scan_upto ::
  [Prelude.Char] ->
    [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
scan_upto end (t : ts) =
  (if map snd (zip end (t : ts)) == end
    then Inr (end, drop (size_list end) (t : ts))
    else bindb (scan_upto end ts) (\ (res, tsa) -> Inr (t : res, tsa)));
scan_upto end [] =
  Inl (['d', 'i', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i', 'n', 'd', ' ', 'e',
         'n', 'd', '-', 'm', 'a', 'r', 'k', 'e', 'r', ' '] ++
        shows_quote (shows_prec_list zero_nat end) []);

trim :: [Prelude.Char] -> [Prelude.Char];
trim = dropWhile (membera [' ', '\n', '\t', '\r']);

manya ::
  (Prelude.Char -> Bool) ->
    [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
manya p (t : ts) =
  (if p t then bindb (manya p ts) (\ (rs, tsa) -> Inr (t : rs, tsa))
    else Inr ([], t : ts));
manya p [] = Inr ([], []);

parse_header ::
  [Prelude.Char] -> Sum [Prelude.Char] ([[Prelude.Char]], [Prelude.Char]);
parse_header ts =
  (if take (nat_of_integer (2 :: Integer)) (trim ts) == ['<', '?']
    then bindc (scan_upto ['?', '>'])
           (\ h -> bindc parse_header (\ hs -> returnb (h : hs))) ts
    else bindc (bindc (manya (membera [' ', '\n', '\t', '\r']))
                 (\ _ -> returnb ()))
           (\ _ -> returnb []) ts);

err_expecting ::
  forall a b. (Showa a) => [Prelude.Char] -> [a] -> Sum [Prelude.Char] (b, [a]);
err_expecting msg ts =
  Inl (['e', 'x', 'p', 'e', 'c', 't', 'i', 'n', 'g', ' '] ++
        msg ++
          [',', ' ', 'b', 'u', 't', ' ', 'f', 'o', 'u', 'n', 'd', ':', ' '] ++
            shows_quote
              (shows_prec_list zero_nat
                (take (nat_of_integer (30 :: Integer)) ts))
              []);

eoi :: forall a. (Showa a) => [a] -> Sum [Prelude.Char] ((), [a]);
eoi [] = Inr ((), []);
eoi (v : va) =
  err_expecting ['e', 'n', 'd', ' ', 'o', 'f', ' ', 'i', 'n', 'p', 'u', 't']
    (v : va);

exactly_aux ::
  [Prelude.Char] ->
    [Prelude.Char] ->
      [Prelude.Char] ->
        [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
exactly_aux s i (x : xs) (y : ys) =
  (if x == y then exactly_aux s i xs ys
    else err_expecting (['\"'] ++ s ++ ['\"']) i);
exactly_aux s i [] xs = Inr (s, trim xs);
exactly_aux s i (x : xs) [] = err_expecting (['\"'] ++ s ++ ['\"']) i;

exactly ::
  [Prelude.Char] ->
    [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
exactly s x = exactly_aux s x s x;

parse_attribute_value ::
  [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
parse_attribute_value =
  bindc (exactly ['\"'])
    (\ _ ->
      bindc (manya (\ y -> not ('\"' == y)))
        (\ v -> bindc (exactly ['\"']) (\ _ -> returnb v)));

errorb :: forall a b. [Prelude.Char] -> [a] -> Sum [Prelude.Char] (b, [a]);
errorb e = (\ _ -> Inl e);

parse_name ::
  [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
parse_name s =
  bindc (manya is_letter)
    (\ n ->
      bindc (bindc (manya (membera [' ', '\n', '\t', '\r']))
              (\ _ -> returnb ()))
        (\ _ ->
          (if null n
            then errorb
                   (['e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'l', 'e', 't',
                      't', 'e', 'r', ' '] ++
                     letters ++
                       [' ', 'b', 'u', 't', ' ', 'f', 'i', 'r', 's', 't', ' ',
                         's', 'y', 'm', 'b', 'o', 'l', ' ', 'i', 's', ' ',
                         '\"'] ++
                         take one_nat s ++ ['\"'])
            else returnb n)))
    s;

parse_attributes ::
  [Prelude.Char] ->
    Sum [Prelude.Char] ([([Prelude.Char], [Prelude.Char])], [Prelude.Char]);
parse_attributes [] = Inr ([], []);
parse_attributes (c : s) =
  (if membera ['/', '>'] c then Inr ([], c : s)
    else bindc parse_name
           (\ k ->
             bindc (exactly ['='])
               (\ _ ->
                 bindc parse_attribute_value
                   (\ v ->
                     bindc parse_attributes
                       (\ atts -> returnb ((k, v) : atts)))))
           (c : s));

oneof_closed ::
  [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
oneof_closed (x : xs) =
  (if x == '>' then Inr (['>'], trim xs)
    else (if x == '/' && (case xs of {
                           [] -> False;
                           y : _ -> y == '>';
                         })
           then Inr (['/', '>'], trim (tl xs))
           else err_expecting
                  ['o', 'n', 'e', ' ', 'o', 'f', ' ', '[', '/', '>', ',', ' ',
                    '>', ']']
                  (x : xs)));
oneof_closed [] =
  err_expecting
    ['o', 'n', 'e', ' ', 'o', 'f', ' ', '[', '/', '>', ',', ' ', '>', ']'] [];

the :: forall a. Maybe a -> a;
the (Just x2) = x2;

parse_text ::
  [Prelude.Char] -> Sum [Prelude.Char] (Maybe [Prelude.Char], [Prelude.Char]);
parse_text =
  bindc (manya (\ y -> not ('<' == y)))
    (\ ts ->
      let {
        text = trim ts;
      } in (if null text then returnb Nothing
             else returnb (Just (reverse (trim (reverse text))))));

parse_nodes :: [Prelude.Char] -> Sum [Prelude.Char] ([Xml], [Prelude.Char]);
parse_nodes ts =
  (if null ts || take (nat_of_integer (2 :: Integer)) ts == ['<', '/']
    then returnb [] ts
    else (if not (hd ts == '<')
           then bindc parse_text
                  (\ t ->
                    bindc parse_nodes (\ ns -> returnb (XML_text (the t) : ns)))
                  ts
           else bindc (exactly ['<'])
                  (\ _ ->
                    bindc parse_name
                      (\ n ->
                        bindc parse_attributes
                          (\ atts ->
                            bindc oneof_closed
                              (\ e ->
                                (if e == ['/', '>']
                                  then bindc parse_nodes
 (\ cs -> returnb (XML n atts [] : cs))
                                  else bindc parse_nodes
 (\ cs ->
   bindc (exactly ['<', '/'])
     (\ _ ->
       bindc (exactly n)
         (\ _ ->
           bindc (exactly ['>'])
             (\ _ ->
               bindc parse_nodes (\ ns -> returnb (XML n atts cs : ns)))))))))))
                  ts));

parse_node :: [Prelude.Char] -> Sum [Prelude.Char] (Xml, [Prelude.Char]);
parse_node =
  bindc (exactly ['<'])
    (\ _ ->
      bindc parse_name
        (\ n ->
          bindc parse_attributes
            (\ atts ->
              bindc oneof_closed
                (\ e ->
                  (if e == ['/', '>'] then returnb (XML n atts [])
                    else bindc parse_nodes
                           (\ cs ->
                             bindc (exactly ['<', '/'])
                               (\ _ ->
                                 bindc (exactly n)
                                   (\ _ ->
                                     bindc (exactly ['>'])
                                       (\ _ -> returnb (XML n atts cs))))))))));

parse_doc :: [Prelude.Char] -> Sum [Prelude.Char] (Xmldoc, [Prelude.Char]);
parse_doc =
  bindc (update_tokens remove_comments)
    (\ _ ->
      bindc parse_header
        (\ h ->
          bindc parse_node
            (\ xml -> bindc eoi (\ _ -> returnb (XMLDOC h xml)))));

partition :: forall a. (a -> Bool) -> [a] -> ([a], [a]);
partition p [] = ([], []);
partition p (x : xs) = let {
                         (yes, no) = partition p xs;
                       } in (if p x then (x : yes, no) else (yes, x : no));

is_none :: forall a. Maybe a -> Bool;
is_none (Just x) = False;
is_none Nothing = True;

list1element :: forall a. [a] -> Maybe a;
list1element [x] = Just x;
list1element [] = Nothing;
list1element (v : vb : vc) = Nothing;

singleton ::
  forall a b.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (a -> b) -> Xml -> Sum_bot [Prelude.Char] b;
singleton tag p1 f xml =
  (case xml of {
    XML name atts cs ->
      (if name == tag && null atts
        then (case list1element cs of {
               Nothing -> fail tag xml;
               Just cs1 -> binda (p1 cs1) (returna . f);
             })
        else fail tag xml);
    XML_text _ -> fail tag xml;
  });

form_or :: forall a. Formula a -> Formula a -> Formula a;
form_or (Disjunction phi_s) (Disjunction psi_s) = Disjunction (phi_s ++ psi_s);
form_or (Disjunction phi_s) (Atom v) = Disjunction (phi_s ++ [Atom v]);
form_or (Disjunction phi_s) (NegAtom v) = Disjunction (phi_s ++ [NegAtom v]);
form_or (Disjunction phi_s) (Conjunctiona v) =
  Disjunction (phi_s ++ [Conjunctiona v]);
form_or (Atom v) (Disjunction psi_s) = Disjunction (Atom v : psi_s);
form_or (NegAtom v) (Disjunction psi_s) = Disjunction (NegAtom v : psi_s);
form_or (Conjunctiona v) (Disjunction psi_s) =
  Disjunction (Conjunctiona v : psi_s);
form_or (Atom v) (Atom va) = Disjunction [Atom v, Atom va];
form_or (Atom v) (NegAtom va) = Disjunction [Atom v, NegAtom va];
form_or (Atom v) (Conjunctiona va) = Disjunction [Atom v, Conjunctiona va];
form_or (NegAtom v) (Atom va) = Disjunction [NegAtom v, Atom va];
form_or (NegAtom v) (NegAtom va) = Disjunction [NegAtom v, NegAtom va];
form_or (NegAtom v) (Conjunctiona va) =
  Disjunction [NegAtom v, Conjunctiona va];
form_or (Conjunctiona v) (Atom va) = Disjunction [Conjunctiona v, Atom va];
form_or (Conjunctiona v) (NegAtom va) =
  Disjunction [Conjunctiona v, NegAtom va];
form_or (Conjunctiona v) (Conjunctiona va) =
  Disjunction [Conjunctiona v, Conjunctiona va];

cnf_form_or :: forall a. Formula a -> Formula a -> Formula a;
cnf_form_or (Conjunctiona phi_s) (Conjunctiona psi_s) =
  Conjunctiona (concatMap (\ phi -> map (form_or phi) psi_s) phi_s);
cnf_form_or (Atom v) psi = form_or (Atom v) psi;
cnf_form_or (NegAtom v) psi = form_or (NegAtom v) psi;
cnf_form_or (Disjunction v) psi = form_or (Disjunction v) psi;
cnf_form_or phi (Atom v) = form_or phi (Atom v);
cnf_form_or phi (NegAtom v) = form_or phi (NegAtom v);
cnf_form_or phi (Disjunction v) = form_or phi (Disjunction v);

form_cnf_ex :: forall a. [Formula a] -> Formula a;
form_cnf_ex [] = Conjunctiona [Disjunction []];
form_cnf_ex (phi : phi_s) = cnf_form_or phi (form_cnf_ex phi_s);

form_and :: forall a. Formula a -> Formula a -> Formula a;
form_and (Conjunctiona phi_s) (Conjunctiona psi_s) =
  Conjunctiona (phi_s ++ psi_s);
form_and (Conjunctiona phi_s) (Atom v) = Conjunctiona (phi_s ++ [Atom v]);
form_and (Conjunctiona phi_s) (NegAtom v) = Conjunctiona (phi_s ++ [NegAtom v]);
form_and (Conjunctiona phi_s) (Disjunction v) =
  Conjunctiona (phi_s ++ [Disjunction v]);
form_and (Atom v) (Conjunctiona psi_s) = Conjunctiona (Atom v : psi_s);
form_and (NegAtom v) (Conjunctiona psi_s) = Conjunctiona (NegAtom v : psi_s);
form_and (Disjunction v) (Conjunctiona psi_s) =
  Conjunctiona (Disjunction v : psi_s);
form_and (Atom v) (Atom va) = Conjunctiona [Atom v, Atom va];
form_and (Atom v) (NegAtom va) = Conjunctiona [Atom v, NegAtom va];
form_and (Atom v) (Disjunction va) = Conjunctiona [Atom v, Disjunction va];
form_and (NegAtom v) (Atom va) = Conjunctiona [NegAtom v, Atom va];
form_and (NegAtom v) (NegAtom va) = Conjunctiona [NegAtom v, NegAtom va];
form_and (NegAtom v) (Disjunction va) =
  Conjunctiona [NegAtom v, Disjunction va];
form_and (Disjunction v) (Atom va) = Conjunctiona [Disjunction v, Atom va];
form_and (Disjunction v) (NegAtom va) =
  Conjunctiona [Disjunction v, NegAtom va];
form_and (Disjunction v) (Disjunction va) =
  Conjunctiona [Disjunction v, Disjunction va];

form_all :: forall a. [Formula a] -> Formula a;
form_all [] = Conjunctiona [];
form_all (phi : phi_s) = form_and phi (form_all phi_s);

flatten :: forall a. Formula a -> Formula a;
flatten (Conjunctiona phi_s) = form_all (map flatten phi_s);
flatten (Disjunction phi_s) = form_cnf_ex (map flatten phi_s);
flatten (Atom v) = Conjunctiona [Disjunction [Atom v]];
flatten (NegAtom v) = Conjunctiona [Disjunction [NegAtom v]];

form_ex :: forall a. [Formula a] -> Formula a;
form_ex [] = Disjunction [];
form_ex (phi : phi_s) = form_or phi (form_ex phi_s);

initial :: forall a b c d e. Lts_ext a b c d e -> d;
initial (Lts_ext initial transition_rules assertion more) = initial;

untrans_var :: forall a. Trans_var a -> a;
untrans_var (Pre x) = x;
untrans_var (Post x) = x;
untrans_var (Intermediate x) = x;

map_filter :: forall a b. (a -> Maybe b) -> [a] -> [b];
map_filter f [] = [];
map_filter f (x : xs) = (case f x of {
                          Nothing -> map_filter f xs;
                          Just y -> y : map_filter f xs;
                        });

vars_list :: Linear_poly -> [Nat];
vars_list lp = ordered_keys (linear_poly_map lp);

min :: forall a. (Ord a) => a -> a -> a;
min a b = (if less_eq a b then a else b);

sum_list :: forall a. (Monoid_add a) => [a] -> a;
sum_list xs = foldr plus xs zeroa;

valuate :: forall a. (Rational_vector a) => Linear_poly -> (Nat -> a) -> a;
valuate lp val =
  let {
    lpm = linear_poly_map lp;
  } in sum_list
         (map (\ x -> scaleRat (the (fmlookup lpm x)) (val x)) (vars_list lp));

divide_rat :: Rat -> Rat -> Rat;
divide_rat p q = Frct (let {
                         a = quotient_of p;
                         (aa, c) = a;
                         b = quotient_of q;
                         (ba, d) = b;
                       } in normalize (times_int aa d, times_int c ba));

delta_0 :: QDelta -> QDelta -> Rat;
delta_0 qd1 qd2 =
  let {
    c1 = qdfst qd1;
    c2 = qdfst qd2;
    k1 = qdsnd qd1;
    k2 = qdsnd qd2;
  } in (if less_rat c1 c2 && less_rat k2 k1
         then divide_rat (minus_rat c2 c1) (minus_rat k1 k2) else one_rat);

delta_0_val :: Ns_constraint QDelta -> (Nat -> QDelta) -> Rat;
delta_0_val (LEQ_ns lll rrr) vl = delta_0 (valuate lll vl) rrr;
delta_0_val (GEQ_ns lll rrr) vl = delta_0 rrr (valuate lll vl);

delta_0_val_min :: [Ns_constraint QDelta] -> (Nat -> QDelta) -> Rat;
delta_0_val_min [] vl = one_rat;
delta_0_val_min (h : t) vl = min (delta_0_val_min t vl) (delta_0_val h vl);

tabulate :: forall a b. (Compare_order a) => [a] -> (a -> b) -> Mapping a b;
tabulate ks f = Mapping (bulkload (map (\ k -> (k, f k)) ks));

map2fun :: forall a. (Zero a) => Mapping Nat a -> Nat -> a;
map2fun v = (\ x -> (case lookupa v x of {
                      Nothing -> zeroa;
                      Just y -> y;
                    }));

from_ns :: Mapping Nat QDelta -> [Ns_constraint QDelta] -> Mapping Nat Rat;
from_ns vl cs =
  let {
    delta = delta_0_val_min cs (map2fun vl);
  } in tabulate (remdups (concatMap vars_list (map poly cs)))
         (\ var -> val (map2fun vl var) delta);

u_update :: forall a b. (Bool -> Bool) -> State_ext a b -> State_ext a b;
u_update ua (State_ext t b_l b_u v u more) = State_ext t b_l b_u v (ua u) more;

uB_upd ::
  forall a b.
    (Linorder a) => Direction_ext a b ->
                      ((Nat -> Maybe a) -> Nat -> Maybe a) ->
                        State_ext a () -> State_ext a ();
uB_upd (Direction_ext lt lb ub uB_upd le more) = uB_upd;

lt :: forall a b. (Linorder a) => Direction_ext a b -> a -> a -> Bool;
lt (Direction_ext lt lb ub uB_upd le more) = lt;

ub :: forall a b.
        (Linorder a) => Direction_ext a b -> State_ext a () -> Nat -> Maybe a;
ub (Direction_ext lt lb ub uB_upd le more) = ub;

lb :: forall a b.
        (Linorder a) => Direction_ext a b -> State_ext a () -> Nat -> Maybe a;
lb (Direction_ext lt lb ub uB_upd le more) = lb;

v_update ::
  forall a b.
    (Mapping Nat a -> Mapping Nat a) -> State_ext a b -> State_ext a b;
v_update va (State_ext t b_l b_u v u more) = State_ext t b_l b_u (va v) u more;

v :: forall a b. State_ext a b -> Mapping Nat a;
v (State_ext t b_l b_u v u more) = v;

t :: forall a b. State_ext a b -> [(Nat, Linear_poly)];
t (State_ext t b_l b_u v u more) = t;

coeff :: Linear_poly -> Nat -> Rat;
coeff lp = get_var_coeff (linear_poly_map lp);

rhs_eq_val ::
  forall a.
    (ScaleRat a, Minus a, Plus a,
      Zero a) => Mapping Nat a -> Nat -> a -> (Nat, Linear_poly) -> a;
rhs_eq_val v x_i c e =
  let {
    x_j = lhs e;
    a_i_j = coeff (rhs e) x_i;
  } in plus (map2fun v x_j) (scaleRat a_i_j (minus c (map2fun v x_i)));

update_code ::
  forall a. (Lrv a) => Nat -> a -> State_ext a () -> State_ext a ();
update_code x c s =
  v_update
    (\ _ ->
      updatea x c
        (foldl (\ va e -> updatea (lhs e) (rhs_eq_val (v s) x c e) va) (v s)
          (t s)))
    s;

update_B ::
  forall a b c d.
    (Eq a) => (((a -> Maybe b) -> a -> Maybe b) -> c -> d) -> a -> b -> c -> d;
update_B field_update x c s = field_update (\ b -> fun_upd b x (Just c)) s;

assert_bound_codea ::
  forall a b.
    (Lrv a,
      Eq a) => Direction_ext a b ->
                 Nat -> a -> State_ext a () -> State_ext a ();
assert_bound_codea dir x c s =
  (if geub (lt dir) c (ub dir s x) then s
    else let {
           sa = update_B (uB_upd dir) x c s;
         } in (if ltlb (lt dir) c (lb dir s x) then u_update (\ _ -> True) sa
                else (if not (member x (lvars (t sa))) &&
                           lt dir c (map2fun (v s) x)
                       then update_code x c sa else sa)));

b_u_update ::
  forall a b.
    ((Nat -> Maybe a) -> Nat -> Maybe a) -> State_ext a b -> State_ext a b;
b_u_update b_ua (State_ext t b_l b_u v u more) =
  State_ext t b_l (b_ua b_u) v u more;

b_u :: forall a b. State_ext a b -> Nat -> Maybe a;
b_u (State_ext t b_l b_u v u more) = b_u;

b_l :: forall a b. State_ext a b -> Nat -> Maybe a;
b_l (State_ext t b_l b_u v u more) = b_l;

positive :: forall a. (Linorder a) => Direction_ext a ();
positive = Direction_ext less b_l b_u b_u_update Leq ();

b_l_update ::
  forall a b.
    ((Nat -> Maybe a) -> Nat -> Maybe a) -> State_ext a b -> State_ext a b;
b_l_update b_la (State_ext t b_l b_u v u more) =
  State_ext t (b_la b_l) b_u v u more;

negative :: forall a. (Linorder a) => Direction_ext a ();
negative = Direction_ext (\ x y -> less y x) b_u b_l b_l_update Geq ();

assert_bound_code ::
  forall a. (Lrv a, Eq a) => Atom a -> State_ext a () -> State_ext a ();
assert_bound_code (Leq x c) s = assert_bound_codea positive x c s;
assert_bound_code (Geq x c) s = assert_bound_codea negative x c s;

u :: forall a b. State_ext a b -> Bool;
u (State_ext t b_l b_u v u more) = u;

assert_bound_loop_code ::
  forall a. (Lrv a, Eq a) => [Atom a] -> State_ext a () -> State_ext a ();
assert_bound_loop_code ats s =
  foldl (\ sa a -> (if u sa then sa else assert_bound_code a sa)) s ats;

init_state :: forall a. (Zero a) => [(Nat, Linear_poly)] -> State_ext a ();
init_state t =
  State_ext t (\ _ -> Nothing) (\ _ -> Nothing)
    (tabulate (remdups (map lhs t ++ concatMap (vars_list . rhs) t))
      (\ _ -> zeroa))
    False ();

min_satisfying :: forall a. (Linorder a) => (a -> Bool) -> [a] -> Maybe a;
min_satisfying p l =
  let {
    xs = filter p l;
  } in (if null xs then Nothing else Just (foldl min (hd xs) (tl xs)));

le_ubound :: forall a. (Eq a, Linorder a) => a -> Maybe a -> Bool;
le_ubound c b = leub less c b;

ge_lbound :: forall a. (Eq a, Linorder a) => a -> Maybe a -> Bool;
ge_lbound c b = gelb less c b;

in_bounds ::
  forall a b.
    (Eq b, Linorder b) => a -> (a -> b) -> (a -> Maybe b, a -> Maybe b) -> Bool;
in_bounds x v (lb, ub) = ge_lbound (v x) (lb x) && le_ubound (v x) (ub x);

min_lvar_not_in_bounds ::
  forall a. (Zero a, Eq a, Linorder a) => State_ext a () -> Maybe Nat;
min_lvar_not_in_bounds s =
  min_satisfying (\ x -> not (in_bounds x (map2fun (v s)) (b_l s, b_u s)))
    (map lhs (t s));

var :: Nat -> Linear_poly;
var x = LinearPoly (set_var_coeff x one_rat fmempty);

subst_var :: Nat -> Linear_poly -> Linear_poly -> Linear_poly;
subst_var v lpa lp =
  minus_linear_poly
    (plus_linear_poly lp (scaleRat_linear_poly (coeff lp v) lpa))
    (scaleRat_linear_poly (coeff lp v) (var v));

subst_var_eq_code ::
  Nat -> Linear_poly -> (Nat, Linear_poly) -> (Nat, Linear_poly);
subst_var_eq_code v lp eq = (lhs eq, subst_var v lp (rhs eq));

eq_idx_for_lvar_aux :: [(Nat, Linear_poly)] -> Nat -> Nat -> Nat;
eq_idx_for_lvar_aux [] x i = i;
eq_idx_for_lvar_aux (eq : t) x i =
  (if equal_nat (lhs eq) x then i
    else eq_idx_for_lvar_aux t x (plus_nat i one_nat));

eq_idx_for_lvar :: [(Nat, Linear_poly)] -> Nat -> Nat;
eq_idx_for_lvar t x = eq_idx_for_lvar_aux t x zero_nat;

eq_for_lvar_code :: [(Nat, Linear_poly)] -> Nat -> (Nat, Linear_poly);
eq_for_lvar_code t v = nth t (eq_idx_for_lvar t v);

pivot_eq :: (Nat, Linear_poly) -> Nat -> (Nat, Linear_poly);
pivot_eq e y =
  let {
    cy = coeff (rhs e) y;
  } in (y, plus_linear_poly
             (scaleRat_linear_poly (divide_rat (uminus_rat one_rat) cy)
               (minus_linear_poly (rhs e) (scaleRat_linear_poly cy (var y))))
             (scaleRat_linear_poly (divide_rat one_rat cy) (var (lhs e))));

pivot_tableau_code ::
  Nat -> Nat -> [(Nat, Linear_poly)] -> [(Nat, Linear_poly)];
pivot_tableau_code x_i x_j t =
  let {
    eq = eq_for_lvar_code t x_i;
    eqa = pivot_eq eq x_j;
  } in map (\ e ->
             (if equal_nat (lhs e) (lhs eq) then eqa
               else subst_var_eq_code x_j (rhs eqa) e))
         t;

t_update ::
  forall a b.
    ([(Nat, Linear_poly)] -> [(Nat, Linear_poly)]) ->
      State_ext a b -> State_ext a b;
t_update ta (State_ext t b_l b_u v u more) = State_ext (ta t) b_l b_u v u more;

pivot_code ::
  forall a. (Lrv a) => Nat -> Nat -> State_ext a () -> State_ext a ();
pivot_code x_i x_j s = t_update (\ _ -> pivot_tableau_code x_i x_j (t s)) s;

pivot_and_update_code ::
  forall a. (Lrv a) => Nat -> Nat -> a -> State_ext a () -> State_ext a ();
pivot_and_update_code x_i x_j c s = update_code x_i c (pivot_code x_i x_j s);

min_rvar_incdec_eq ::
  forall a.
    (Lrv a) => Direction_ext a () ->
                 State_ext a () -> (Nat, Linear_poly) -> Maybe Nat;
min_rvar_incdec_eq dir s eq =
  min_satisfying
    (\ x ->
      less_rat zero_rat (coeff (rhs eq) x) &&
        ltub (lt dir) (map2fun (v s) x) (ub dir s x) ||
        less_rat (coeff (rhs eq) x) zero_rat &&
          gtlb (lt dir) (map2fun (v s) x) (lb dir s x))
    (vars_list (rhs eq));

check_codea ::
  forall a.
    (Lrv a) => Direction_ext a () -> Nat -> State_ext a () -> State_ext a ();
check_codea dir x_i s =
  let {
    l_i = the (lb dir s x_i);
  } in (case min_rvar_incdec_eq dir s (eq_for_lvar_code (t s) x_i) of {
         Nothing -> u_update (\ _ -> True) s;
         Just x_j -> pivot_and_update_code x_i x_j l_i s;
       });

lt_lbound :: forall a. (Linorder a) => a -> Maybe a -> Bool;
lt_lbound c b = ltlb less c b;

check_code :: forall a. (Lrv a, Eq a) => State_ext a () -> State_ext a ();
check_code s =
  (if u s then s
    else (case min_lvar_not_in_bounds s of {
           Nothing -> s;
           Just x_i ->
             let {
               dir = (if lt_lbound (map2fun (v s) x_i) (b_l s x_i) then positive
                       else negative);
             } in check_code (check_codea dir x_i s);
         }));

assert_all_state_code ::
  forall a. (Lrv a, Eq a) => [(Nat, Linear_poly)] -> [Atom a] -> State_ext a ();
assert_all_state_code t ats =
  check_code (assert_bound_loop_code ats (init_state t));

assert_all_code ::
  forall a.
    (Lrv a,
      Eq a) => [(Nat, Linear_poly)] ->
                 [Atom a] -> (Bool, Maybe (Mapping Nat a));
assert_all_code t asa =
  let {
    s = assert_all_state_code t asa;
  } in (if u s then (False, Nothing) else (True, Just (v s)));

max_var :: Linear_poly -> Nat;
max_var lp = let {
               vl = vars_list lp;
             } in (if null vl then zero_nat else foldl max (hd vl) (tl vl));

start_fresh_variable :: [Ns_constraint QDelta] -> Nat;
start_fresh_variable [] = zero_nat;
start_fresh_variable (h : t) =
  max (plus_nat (max_var (poly h)) one_nat) (start_fresh_variable t);

tableau :: forall a. Istate_ext a -> [(Nat, Linear_poly)];
tableau (Istate_ext firstFreshVariable tableau atoms more) = tableau;

atoms :: forall a. Istate_ext a -> [Atom QDelta];
atoms (Istate_ext firstFreshVariable tableau atoms more) = atoms;

is_monom :: Linear_poly -> Bool;
is_monom l = equal_nat (size_list (vars_list l)) one_nat;

sgn_int :: Int -> Int;
sgn_int i =
  (if equal_int i zero_int then zero_int
    else (if less_int zero_int i then Int_of_integer (1 :: Integer)
           else uminus_int (Int_of_integer (1 :: Integer))));

abs_int :: Int -> Int;
abs_int i = (if less_int i zero_int then uminus_int i else i);

inverse_rat :: Rat -> Rat;
inverse_rat p =
  Frct (let {
          a = quotient_of p;
          (aa, b) = a;
        } in (if equal_int aa zero_int
               then (zero_int, Int_of_integer (1 :: Integer))
               else (times_int (sgn_int aa) b, abs_int aa)));

monom_var :: Linear_poly -> Nat;
monom_var l = max_var l;

monom_coeff :: Linear_poly -> Rat;
monom_coeff l = coeff l (monom_var l);

monom_to_atom :: Ns_constraint QDelta -> Atom QDelta;
monom_to_atom (LEQ_ns l r) =
  (if less_rat (monom_coeff l) zero_rat
    then Geq (monom_var l) (scaleRat_QDelta (inverse_rat (monom_coeff l)) r)
    else Leq (monom_var l) (scaleRat_QDelta (inverse_rat (monom_coeff l)) r));
monom_to_atom (GEQ_ns l r) =
  (if less_rat (monom_coeff l) zero_rat
    then Leq (monom_var l) (scaleRat_QDelta (inverse_rat (monom_coeff l)) r)
    else Geq (monom_var l) (scaleRat_QDelta (inverse_rat (monom_coeff l)) r));

qdelta_constraint_to_atom :: Ns_constraint QDelta -> Nat -> Atom QDelta;
qdelta_constraint_to_atom (LEQ_ns l r) v =
  (if is_monom l then monom_to_atom (LEQ_ns l r) else Leq v r);
qdelta_constraint_to_atom (GEQ_ns l r) v =
  (if is_monom l then monom_to_atom (GEQ_ns l r) else Geq v r);

firstFreshVariable :: forall a. Istate_ext a -> Nat;
firstFreshVariable (Istate_ext firstFreshVariable tableau atoms more) =
  firstFreshVariable;

qdelta_constraint_to_eq :: Ns_constraint QDelta -> Nat -> (Nat, Linear_poly);
qdelta_constraint_to_eq (LEQ_ns l r) v = (v, l);
qdelta_constraint_to_eq (GEQ_ns l r) v = (v, l);

preprocessa :: [Ns_constraint QDelta] -> Nat -> Istate_ext ();
preprocessa [] v = Istate_ext v [] [] ();
preprocessa (h : t) v =
  let {
    s = preprocessa t v;
    va = firstFreshVariable s;
    ta = tableau s;
    a = atoms s;
  } in Istate_ext (if is_monom (poly h) then va else plus_nat va one_nat)
         (if is_monom (poly h) then ta else qdelta_constraint_to_eq h va : ta)
         (qdelta_constraint_to_atom h va : a) ();

preprocess :: [Ns_constraint QDelta] -> ([(Nat, Linear_poly)], [Atom QDelta]);
preprocess l = let {
                 start = start_fresh_variable l;
                 is = preprocessa l start;
               } in (tableau is, atoms is);

solve_exec_ns_code ::
  [Ns_constraint QDelta] -> (Bool, Maybe (Mapping Nat QDelta));
solve_exec_ns_code s = let {
                         a = preprocess s;
                         (aa, b) = a;
                       } in assert_all_code aa b;

solve_exec_code :: [Constraint] -> (Bool, Maybe (Mapping Nat Rat));
solve_exec_code cs = let {
                       csa = to_ns cs;
                     } in (case solve_exec_ns_code csa of {
                            (True, v) -> (True, Just (from_ns (the v) csa));
                            (False, _) -> (False, Nothing);
                          });

simplex :: [Constraint] -> Maybe (Mapping Nat Rat);
simplex cs = snd (solve_exec_code cs);

isOK :: forall a b. Sum a b -> Bool;
isOK m = (case m of {
           Inl _ -> False;
           Inr _ -> True;
         });

form_not :: forall a. Formula a -> Formula a;
form_not (Atom a) = NegAtom a;
form_not (NegAtom a) = Atom a;
form_not (Conjunctiona phi_s) = Disjunction (map form_not phi_s);
form_not (Disjunction phi_s) = Conjunctiona (map form_not phi_s);

gen_pick ::
  forall a b c d e f.
    (a -> (Maybe b -> Bool) -> (c -> d -> Maybe c) -> Maybe e -> Maybe f) ->
      a -> f;
gen_pick it s =
  the (it s (\ a -> (case a of {
                      Nothing -> True;
                      Just _ -> False;
                    }))
         (\ x _ -> Just x)
        Nothing);

list_update :: forall a. [a] -> Nat -> a -> [a];
list_update [] i y = [];
list_update (x : xs) i y =
  (if equal_nat i zero_nat then y : xs
    else x : list_update xs (minus_nat i one_nat) y);

shows_paren ::
  ([Prelude.Char] -> [Prelude.Char]) -> [Prelude.Char] -> [Prelude.Char];
shows_paren s =
  (shows_prec_char zero_nat '(' . s) . shows_prec_char zero_nat ')';

lp_monom :: Rat -> Nat -> Linear_poly;
lp_monom c x =
  LinearPoly (if equal_rat c zero_rat then fmempty else fmupd x c fmempty);

is_Var :: forall a b. Term a b -> Bool;
is_Var (Var x1) = True;
is_Var (Fun x21 x22) = False;

check :: forall a. Bool -> a -> Sum a ();
check b e = (if b then Inr () else Inl e);

is_clause :: forall a. Formula a -> Bool;
is_clause (NegAtom a) = False;
is_clause (Atom a) = False;
is_clause (Conjunctiona xs) = False;
is_clause (Disjunction ls) = all isLit ls;

comp2eq :: forall a b. (a -> b -> Comp_res) -> a -> b -> Bool;
comp2eq cmp a b = (case cmp a b of {
                    LESS -> False;
                    EQUAL -> True;
                    GREATER -> False;
                  });

assertion ::
  forall a b c d e. Lts_ext a b c d e -> d -> Formula (Term a (b, c));
assertion (Lts_ext initial transition_rules assertion more) = assertion;

map_of_total ::
  forall a b. (Compare_order a) => (a -> [Prelude.Char]) -> [(a, b)] -> a -> b;
map_of_total err xys =
  let {
    m = of_alist xys;
  } in (\ x ->
         (case lookupa m x of {
           Nothing ->
             (error :: forall a. String -> (() -> a) -> a) (err x)
               (\ _ -> the Nothing);
           Just y -> y;
         }));

transition_of ::
  forall a b c d e.
    (Compare_order e,
      Showa e) => Lts_impl a b c d e -> e -> Transition_rule a b c d;
transition_of pi =
  map_of_total
    (\ a ->
      ['a', 'c', 'c', 'e', 's', 's', ' ', 't', 'o', ' ', 'n', 'o', 'n', '-',
        'e', 'x', 'i', 's', 't', 'i', 'n', 'g', ' ', 't', 'r', 'a', 'n', 's',
        'i', 't', 'i', 'o', 'n', ' '] ++
        shows_prec zero_nat a [] ++
          ['\n', 'a', 'v', 'a', 'i', 'l', 'a', 'b', 'l', 'e', ' ', 't', 'r',
            'a', 'n', 's', 'i', 't', 'i', 'o', 'n', 's', ':', '\n'] ++
            shows_prec_list zero_nat (map fst (transitions_impl pi)) [])
    (transitions_impl pi);

xml_if ::
  forall a.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] a) -> Xml -> Sum_bot [Prelude.Char] a;
xml_if tag p1 p2 xml =
  (case xml of {
    XML nam _ _ -> (if nam == tag then p1 xml else p2 xml);
    XML_text _ -> fail tag xml;
  });

mapM :: forall a b. (a -> Maybe b) -> [a] -> Maybe [b];
mapM f [] = Just [];
mapM f (x : xs) = bind (f x) (\ y -> bind (mapM f xs) (\ ys -> Just (y : ys)));

doc_of_string :: [Prelude.Char] -> Sum [Prelude.Char] Xmldoc;
doc_of_string s = bindb (parse_doc s) (\ (doc, _) -> Inr doc);

bool :: forall a b c d. Logic_ext a b c d -> Set b;
bool (Logic_ext types type_values bool to_bool interpret more) = bool;

dflt_cmp ::
  forall a b. (a -> b -> Bool) -> (a -> b -> Bool) -> a -> b -> Comp_res;
dflt_cmp le lt a b =
  (if lt a b then LESS else (if le a b then EQUAL else GREATER));

nodes_lts_impl :: forall a b c d e. (Eq d) => Lts_impl a b c d e -> [d];
nodes_lts_impl pi =
  remdups
    (map (source . snd) (transitions_impl pi) ++
      map (target . snd) (transitions_impl pi));

guard :: Bool -> Maybe ();
guard b = (if b then Just () else Nothing);

map_term :: forall a b c d. (a -> b) -> (c -> d) -> Term a c -> Term b d;
map_term f1 f2 (Var x1) = Var (f2 x1);
map_term f1 f2 (Fun x21 x22) = Fun (f1 x21) (map (map_term f1 f2) x22);

catch_errora :: forall a b c. Sum a b -> (a -> Sum c b) -> Sum c b;
catch_errora m f = (case m of {
                     Inl a -> f a;
                     Inr a -> Inr a;
                   });

forallM :: forall a b. (a -> Sum b ()) -> [a] -> Sum (a, b) ();
forallM f [] = Inr ();
forallM f (x : xs) =
  bindb (catch_errora (f x) (\ xa -> Inl (x, xa))) (\ _ -> forallM f xs);

types :: forall a b c d. Logic_ext a b c d -> a -> ([b], b);
types (Logic_ext types type_values bool to_bool interpret more) = types;

case_sum_bot :: forall a b c. a -> (b -> a) -> (c -> a) -> Sum_bot b c -> a;
case_sum_bot f g h (Sumbot p) = (case p of {
                                  Inl a -> g a;
                                  Inr a -> h a;
                                });

left :: forall a b. a -> Sum_bot a b;
left x = Sumbot (Inl x);

xml_take ::
  forall a b.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      (a -> [Xml] -> Sum_bot [Prelude.Char] b) ->
        [Xml] -> Sum_bot [Prelude.Char] b;
xml_take p1 p2 [] =
  errora
    ['u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 't', 'a', 'g', ' ',
      'c', 'l', 'o', 's', 'e'];
xml_take p1 p2 (x : xs) =
  case_sum_bot (error "undefined") left (\ a -> p2 a xs) (p1 x);

zero :: Fmap Nat Rat;
zero = fmempty;

sup_set :: forall a. (Eq a) => Set a -> Set a -> Set a;
sup_set (Coset xs) a = Coset (filter (\ x -> not (member x a)) xs);
sup_set (Set xs) a = fold inserta xs a;

bot_set :: forall a. Set a;
bot_set = Set [];

sup_seta :: forall a. (Eq a) => Set (Set a) -> Set a;
sup_seta (Set xs) = fold sup_set xs bot_set;

vars_term :: forall a b. (Eq b) => Term a b -> Set b;
vars_term (Var x1) = inserta x1 bot_set;
vars_term (Fun x21 x22) = sup_seta (image vars_term (Set x22));

array_get :: forall a. Array.Array a -> Nat -> a;
array_get (Array.Array a) n = nth a n;

array_set :: forall a. Array.Array a -> Nat -> a -> Array.Array a;
array_set (Array.Array aa) n a = Array.Array (list_update aa n a);

vars_formula ::
  forall a b c. (Eq b, Eq c) => Formula (Term a (b, c)) -> Set (b, c);
vars_formula (Atom a) = vars_term a;
vars_formula (NegAtom a) = vars_term a;
vars_formula (Conjunctiona phi_s) = sup_seta (image vars_formula (Set phi_s));
vars_formula (Disjunction phi_s) = sup_seta (image vars_formula (Set phi_s));

as_length :: forall a. (Array.Array a, Nat) -> Nat;
as_length = snd;

times_nat :: Nat -> Nat -> Nat;
times_nat m n = Nat (integer_of_nat m * integer_of_nat n);

array_shrink :: forall a. Array.Array a -> Nat -> Array.Array a;
array_shrink (Array.Array a) sz =
  (if less_nat (size_list a) sz then error "undefined"
    else Array.Array (take sz a));

array_length :: forall a. Array.Array a -> Nat;
array_length (Array.Array a) = size_list a;

as_shrink :: forall a. (Array.Array a, Nat) -> (Array.Array a, Nat);
as_shrink s =
  let {
    a = s;
    (aa, n) = a;
    ab = (if less_eq_nat (times_nat (nat_of_integer (128 :: Integer)) n)
               (array_length aa) &&
               less_nat (nat_of_integer (4 :: Integer)) n
           then array_shrink aa n else aa);
  } in (ab, n);

as_take :: forall a. Nat -> (Array.Array a, Nat) -> (Array.Array a, Nat);
as_take m s = let {
                a = s;
                (aa, n) = a;
              } in (if less_nat m n then as_shrink (aa, m) else (aa, n));

as_top :: forall a. (Array.Array a, Nat) -> a;
as_top s = let {
             a = s;
             (aa, n) = a;
           } in array_get aa (minus_nat n one_nat);

as_pop :: forall a. (Array.Array a, Nat) -> (Array.Array a, Nat);
as_pop s = let {
             a = s;
             (aa, n) = a;
           } in as_shrink (aa, minus_nat n one_nat);

as_get :: forall a. (Array.Array a, Nat) -> Nat -> a;
as_get s i = let {
               a = s;
               (aa, _) = a;
             } in array_get aa i;

while :: forall a. (a -> Bool) -> (a -> a) -> a -> a;
while b c s = (if b s then while b c (c s) else s);

pop_tr ::
  forall a.
    (Compare_order a) => ((Array.Array a, Nat),
                           ((Array.Array Nat, Nat),
                             (Rbta a Int, (Array.Array (Nat, [a]), Nat)))) ->
                           ((Array.Array a, Nat),
                             ((Array.Array Nat, Nat),
                               (Rbta a Int, (Array.Array (Nat, [a]), Nat))));
pop_tr s =
  let {
    (a, (aa, (ab, bb))) = s;
    x = minus_nat (as_length aa) one_nat;
    xa = let {
           (_, bc) =
             while (\ (xf, _) ->
                     less_nat xf
                       (if equal_nat (plus_nat x one_nat) (as_length aa)
                         then as_length a else as_get aa (plus_nat x one_nat)))
               (\ (ac, bc) ->
                 (suc ac,
                   rbt_insert (as_get a ac)
                     (uminus_int (Int_of_integer (1 :: Integer))) bc))
               (as_get aa x, ab);
         } in bc;
    xb = as_take (as_top aa) a;
    xc = as_pop aa;
  } in (xb, (xc, (xa, bb)));

succ_transitions ::
  forall a b c d e.
    (Eq d) => Lts_impl a b c d e -> d -> [Transition_rule a b c d];
succ_transitions (Lts_Impl i ts lc) l =
  concatMap (\ (_, tau) -> (if source tau == l then [tau] else [])) ts;

right :: forall a b. a -> Sum_bot b a;
right x = Sumbot (Inr x);

xml_leave :: forall a. a -> [Xml] -> Sum_bot [Prelude.Char] a;
xml_leave v [] = right v;
xml_leave v (x : xs) =
  errora
    (['w', 'a', 'n', 't', ' ', 't', 'o', ' ', 'c', 'l', 'o', 's', 'e', ' ', 'b',
       'u', 't', ' ', 'f', 'o', 'u', 'n', 'd', '\n'] ++
      shows_prec_xml zero_nat x []);

xml1to2elements ::
  forall a b c.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (a -> Maybe b -> c) -> Xml -> Sum_bot [Prelude.Char] c;
xml1to2elements tag p1 p2 f (XML name atts cs) =
  let {
    l = size_list cs;
  } in (if name == tag &&
             null atts &&
               less_eq_nat one_nat l &&
                 less_eq_nat l (nat_of_integer (2 :: Integer))
         then binda (p1 (nth cs zero_nat))
                (\ x1 ->
                  (if equal_nat l (nat_of_integer (2 :: Integer))
                    then binda (p2 (nth cs one_nat))
                           (\ x2 -> returna (f x1 (Just x2)))
                    else returna (f x1 Nothing)))
         else fail tag (XML name atts cs));
xml1to2elements tag p1 p2 f (XML_text v) = fail tag (XML_text v);

array_grow :: forall a. Array.Array a -> Nat -> a -> Array.Array a;
array_grow (Array.Array a) inc x = Array.Array (a ++ replicate inc x);

formula_parser ::
  forall a b c.
    (Xml -> Sum_bot [Prelude.Char] (Formula (Term a (b, c)))) ->
      Xml -> Sum_bot [Prelude.Char] (Formula (Term a (b, c)));
formula_parser ep x =
  xml_if ['d', 'i', 's', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n']
    (many ['d', 'i', 's', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n']
      (formula_parser ep) Disjunction)
    (xml_if ['c', 'o', 'n', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n']
      (many ['c', 'o', 'n', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n']
        (formula_parser ep) Conjunctiona)
      ep)
    x;

transition_parser ::
  forall a b c d e.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      (Xml -> Sum_bot [Prelude.Char] b) ->
        (Xml -> Sum_bot [Prelude.Char] (Formula (Term c (Trans_var d, e)))) ->
          Xml -> Sum_bot [Prelude.Char] (b, Transition_rule c d e a);
transition_parser location_parser trans_id_parser tatom_parser =
  tuple4 ['t', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n'] trans_id_parser
    (singleton ['s', 'o', 'u', 'r', 'c', 'e'] location_parser id)
    (singleton ['t', 'a', 'r', 'g', 'e', 't'] location_parser id)
    (singleton ['f', 'o', 'r', 'm', 'u', 'l', 'a'] (formula_parser tatom_parser)
      id)
    (\ tr l r phi -> (tr, Transition l r phi));

lts_parser ::
  forall a b c d e.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] (Formula (Term c (Trans_var d, e)))) ->
            Xml -> Sum_bot [Prelude.Char] (Lts_impl c d e a b);
lts_parser tag location_parser trans_id_parser tatom_parser =
  many1 tag (singleton ['i', 'n', 'i', 't', 'i', 'a', 'l'] location_parser id)
    (transition_parser location_parser trans_id_parser tatom_parser)
    (\ i t -> Lts_Impl i t []);

map_prod :: forall a b c d. (a -> b) -> (c -> d) -> (a, c) -> (b, d);
map_prod f g (a, b) = (f a, g b);

showsp_formula ::
  forall a.
    (Nat -> a -> [Prelude.Char] -> [Prelude.Char]) ->
      Nat -> Formula a -> [Prelude.Char] -> [Prelude.Char];
showsp_formula show_a p (Disjunction x) =
  (((shows_pl p .
      shows_string ['D', 'i', 's', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n']) .
     shows_space) .
    showsp_list (showsp_formula show_a) one_nat x) .
    shows_pr p;
showsp_formula show_a p (Conjunctiona x) =
  (((shows_pl p .
      shows_string ['C', 'o', 'n', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n']) .
     shows_space) .
    showsp_list (showsp_formula show_a) one_nat x) .
    shows_pr p;
showsp_formula show_a p (NegAtom x) =
  (((shows_pl p . shows_string ['N', 'e', 'g', 'A', 't', 'o', 'm']) .
     shows_space) .
    show_a one_nat x) .
    shows_pr p;
showsp_formula show_a p (Atom x) =
  (((shows_pl p . shows_string ['A', 't', 'o', 'm']) . shows_space) .
    show_a one_nat x) .
    shows_pr p;

g_list_to_map_rm_basic_ops ::
  forall a b. (Compare_order a) => [(a, b)] -> Rbt a b;
g_list_to_map_rm_basic_ops l =
  foldl (\ m (k, v) -> insert k v m) empty (reverse l);

ceta_map_of :: forall a b. (Key a) => [(a, b)] -> a -> Maybe b;
ceta_map_of ps = lookup (g_list_to_map_rm_basic_ops ps);

catch_error :: forall a b c. Sum_bot a b -> (a -> Sum_bot c b) -> Sum_bot c b;
catch_error (Sumbot a) f = (case a of {
                             Inl aa -> f aa;
                             Inr aa -> Sumbot (Inr aa);
                           });

formula :: forall a. (a -> Bool) -> Formula a -> Bool;
formula atom (Disjunction phi_s) = all (formula atom) phi_s;
formula atom (Conjunctiona phi_s) = all (formula atom) phi_s;
formula atom (NegAtom a) = atom a;
formula atom (Atom a) = atom a;

rename_vars_exp :: forall a b c d. (a -> b) -> Term c (a, d) -> Term c (b, d);
rename_vars_exp r = map_term id (map_prod r id);

find_max_nat :: Nat -> (Nat -> Bool) -> Nat;
find_max_nat n uu =
  (if equal_nat n zero_nat then zero_nat
    else (if uu (minus_nat n one_nat) then minus_nat n one_nat
           else find_max_nat (minus_nat n one_nat) uu));

rbt_lookup :: forall a b. (a -> a -> Bool) -> Rbta a b -> a -> Maybe b;
rbt_lookup less (Branch uu l x y r) k =
  (if less k x then rbt_lookup less l k
    else (if less x k then rbt_lookup less r k else Just y));
rbt_lookup less Empty k = Nothing;

idx_of_tr ::
  forall a.
    (Linorder a) => a -> ((Array.Array a, Nat),
                           ((Array.Array Nat, Nat),
                             (Rbta a Int, (Array.Array (Nat, [a]), Nat)))) ->
                           Nat;
idx_of_tr s v =
  let {
    (_, (aa, (ab, _))) = v;
    x = let {
          (Just i) = rbt_lookup less ab s;
          True = less_eq_int zero_int i;
        } in nat i;
    xa = find_max_nat (as_length aa) (\ j -> less_eq_nat (as_get aa j) x);
  } in xa;

gi_E :: forall a b c d. Gen_g_impl_ext a b c d -> b;
gi_E (Gen_g_impl_ext gi_V gi_E gi_V0 more) = gi_E;

stat_newnode :: () -> ();
stat_newnode = (\ _ -> ());

is_Nil :: forall a. [a] -> Bool;
is_Nil a = (case a of {
             [] -> True;
             _ : _ -> False;
           });

int_of_nat :: Nat -> Int;
int_of_nat n = Int_of_integer (integer_of_nat n);

as_push :: forall a. (Array.Array a, Nat) -> a -> (Array.Array a, Nat);
as_push s x =
  let {
    a = s;
    (aa, n) = a;
    ab = (if equal_nat n (array_length aa)
           then array_grow aa
                  (max (nat_of_integer (4 :: Integer))
                    (times_nat (nat_of_integer (2 :: Integer)) n))
                  x
           else aa);
    ac = array_set ab n x;
  } in (ac, plus_nat n one_nat);

push_code ::
  forall a b.
    (Compare_order a) => Gen_g_impl_ext (a -> Bool) (a -> [a]) [a] b ->
                           a -> ((Array.Array a, Nat),
                                  ((Array.Array Nat, Nat),
                                    (Rbta a Int,
                                      (Array.Array (Nat, [a]), Nat)))) ->
                                  ((Array.Array a, Nat),
                                    ((Array.Array Nat, Nat),
                                      (Rbta a Int,
(Array.Array (Nat, [a]), Nat))));
push_code g_impl =
  (\ x (xa, (xb, (xc, xd))) ->
    let {
      _ = stat_newnode ();
      xf = as_length xa;
      xg = as_push xa x;
      xh = as_push xb xf;
      xi = rbt_insert x (int_of_nat xf) xc;
      xj = (if is_Nil (gi_E g_impl x) then xd
             else as_push xd (xf, gi_E g_impl x));
    } in (xg, (xh, (xi, xj))));

as_set :: forall a. (Array.Array a, Nat) -> Nat -> a -> (Array.Array a, Nat);
as_set s i x = let {
                 a = s;
                 (aa, b) = a;
               } in (array_set aa i x, b);

xml_enter_if ::
  forall a. [Prelude.Char] -> ([Xml] -> a) -> (Xml -> a) -> Xml -> a;
xml_enter_if tag ps p2 xml = let {
                               (XML nam [] xs) = xml;
                             } in (if nam == tag then ps xs else p2 xml);

xml_take_int ::
  forall a.
    (Int -> [Xml] -> Sum_bot [Prelude.Char] a) ->
      [Xml] -> Sum_bot [Prelude.Char] a;
xml_take_int p xs =
  (case xs of {
    [] -> errora
            ['e', 'x', 'p', 'e', 'c', 't', 'i', 'n', 'g', ' ', 'a', 'n', ' ',
              'i', 'n', 't', 'e', 'g', 'e', 'r', ' ', 'b', 'u', 't', ' ', 't',
              'a', 'g', ' ', 'c', 'l', 'o', 's', 'e', 'd'];
    XML list1 list2 list3 : _ ->
      errora
        (['e', 'x', 'p', 'e', 'c', 't', 'i', 'n', 'g', ' ', 'a', 'n', ' ', 'i',
           'n', 't', 'e', 'g', 'e', 'r', ' ', 'b', 'u', 't', ' ', 'e', 'n', 'c',
           'o', 'u', 'n', 't', 'e', 'r', 'e', 'd', '\n'] ++
          shows_prec_xml zero_nat (XML list1 list2 list3) []);
    XML_text text : xsa ->
      case_sum_bot (error "undefined") left (\ n -> p n xsa)
        (int_of_string text);
  });

fun_of_map_fun :: forall a b. (a -> Maybe b) -> (a -> b) -> a -> b;
fun_of_map_fun m d a = (case m a of {
                         Nothing -> d a;
                         Just b -> b;
                       });

precompute_fun :: forall a b. (Key a) => (a -> b) -> [a] -> a -> b;
precompute_fun f asa =
  fun_of_map_fun (ceta_map_of (map (\ a -> (a, f a)) asa)) f;

edges_to_adj_fun :: forall a. (Eq a, Key a) => [(a, a)] -> a -> [a];
edges_to_adj_fun e =
  precompute_fun
    (\ a ->
      remdups (concatMap (\ ea -> (if fst ea == a then [snd ea] else [])) e))
    (remdups (map fst e ++ map snd e));

create_graph_impl ::
  forall a.
    (Eq a, Key a) => [(a, a)] -> Gen_g_impl_ext (a -> Bool) (a -> [a]) [a] ();
create_graph_impl e =
  Gen_g_impl_ext (membera (map fst e ++ map snd e)) (edges_to_adj_fun e)
    (remdups (map fst e ++ map snd e)) ();

as_singleton :: forall a b. (One b) => a -> (Array.Array a, b);
as_singleton x = (Array.Array [x], one);

gi_V0 :: forall a b c d. Gen_g_impl_ext a b c d -> c;
gi_V0 (Gen_g_impl_ext gi_V gi_E gi_V0 more) = gi_V0;

as_is_empty :: forall a. (Array.Array a, Nat) -> Bool;
as_is_empty s = equal_nat (snd s) zero_nat;

rev_append :: forall a. [a] -> [a] -> [a];
rev_append [] ac = ac;
rev_append (x : xs) ac = rev_append xs (x : ac);

glist_delete_aux :: forall a. (a -> a -> Bool) -> a -> [a] -> [a] -> [a];
glist_delete_aux eq x [] asa = asa;
glist_delete_aux eq x (y : ys) asa =
  (if eq x y then rev_append asa ys else glist_delete_aux eq x ys (y : asa));

glist_delete :: forall a. (a -> a -> Bool) -> a -> [a] -> [a];
glist_delete eq x l = glist_delete_aux eq x l [];

select_edge_tr ::
  forall a.
    (Linorder a) => ((Array.Array a, Nat),
                      ((Array.Array Nat, Nat),
                        (Rbta a Int, (Array.Array (Nat, [a]), Nat)))) ->
                      (Maybe a,
                        ((Array.Array a, Nat),
                          ((Array.Array Nat, Nat),
                            (Rbta a Int, (Array.Array (Nat, [a]), Nat)))));
select_edge_tr s =
  let {
    (a, (aa, (ab, bb))) = s;
  } in (if as_is_empty bb then (Nothing, (a, (aa, (ab, bb))))
         else let {
                (ac, bc) = as_top bb;
              } in (if less_eq_nat
                         (as_get aa (minus_nat (as_length aa) one_nat)) ac
                     then let {
                            xa = gen_pick (\ x -> foldli (id x)) bc;
                            xb = glist_delete (comp2eq (dflt_cmp less_eq less))
                                   xa bc;
                            xc = (if is_Nil xb then as_pop bb
                                   else as_set bb
  (minus_nat (as_length bb) one_nat) (ac, xb));
                          } in (Just xa, (a, (aa, (ab, xc))))
                     else (Nothing, (a, (aa, (ab, bb))))));

as_empty :: forall a b. (Zero b) => () -> (Array.Array a, b);
as_empty uu = (Array.Array [], zeroa);

stat_start :: () -> ();
stat_start = (\ _ -> ());

last_seg_tr ::
  forall a.
    (Linorder a) => ((Array.Array a, Nat),
                      ((Array.Array Nat, Nat),
                        (Rbta a Int, (Array.Array (Nat, [a]), Nat)))) ->
                      [a];
last_seg_tr s =
  let {
    (a, (aa, (_, _))) = s;
    (_, bc) =
      while (\ (xe, _) ->
              less_nat xe
                (if equal_nat
                      (plus_nat (minus_nat (as_length aa) one_nat) one_nat)
                      (as_length aa)
                  then as_length a
                  else as_get aa
                         (plus_nat (minus_nat (as_length aa) one_nat) one_nat)))
        (\ (ac, bc) -> let {
                         xa = as_get a ac;
                       } in (suc ac, xa : bc))
        (as_get aa (minus_nat (as_length aa) one_nat), []);
  } in bc;

collapse_tr ::
  forall a.
    (Linorder a) => a -> ((Array.Array a, Nat),
                           ((Array.Array Nat, Nat),
                             (Rbta a Int, (Array.Array (Nat, [a]), Nat)))) ->
                           ((Array.Array a, Nat),
                             ((Array.Array Nat, Nat),
                               (Rbta a Int, (Array.Array (Nat, [a]), Nat))));
collapse_tr v s = let {
                    (a, (aa, (ab, bb))) = s;
                    x = idx_of_tr v (a, (aa, (ab, bb)));
                    xa = as_take (plus_nat x one_nat) aa;
                  } in (a, (xa, (ab, bb)));

stat_stop :: () -> ();
stat_stop = (\ _ -> ());

compute_SCC_tr ::
  forall a b.
    (Compare_order a) => Gen_g_impl_ext (a -> Bool) (a -> [a]) [a] b -> [[a]];
compute_SCC_tr g =
  let {
    _ = stat_start ();
    xa = ([], Empty);
    a = foldli (id (gi_V0 g)) (\ _ -> True)
          (\ xb (a, b) ->
            (if not (case rbt_lookup less b xb of {
                      Nothing -> False;
                      Just i ->
                        (if less_eq_int zero_int i then False else True);
                    })
              then let {
                     xc = (a, (as_singleton xb,
                                (as_singleton zero_nat,
                                  (rbt_insert xb (int_of_nat zero_nat) b,
                                    (if is_Nil (gi_E g xb) then as_empty ()
                                      else as_singleton
     (zero_nat, gi_E g xb))))));
                     (aa, (_, (_, (ad, _)))) =
                       while (\ (_, xh) ->
                               not (as_is_empty (let {
           (xi, (_, (_, _))) = xh;
         } in xi)))
                         (\ (aa, ba) ->
                           (case select_edge_tr ba of {
                             (Nothing, bb) -> let {
        xf = last_seg_tr bb;
        xg = pop_tr bb;
        xh = xf : aa;
      } in (xh, xg);
                             (Just xf, bb) ->
                               (if (case rbt_lookup less
   (let {
      (_, (_, (xn, _))) = bb;
    } in xn)
   xf
                                     of {
                                     Nothing -> False;
                                     Just i ->
                                       (if less_eq_int zero_int i then True
 else False);
                                   })
                                 then let {
ab = collapse_tr xf bb;
                                      } in (aa, ab)
                                 else (if not
    (case rbt_lookup less (let {
                             (_, (_, (xn, _))) = bb;
                           } in xn)
            xf
      of {
      Nothing -> False;
      Just i -> (if less_eq_int zero_int i then False else True);
    })
then (aa, push_code g xf bb) else (aa, bb)));
                           }))
                         xc;
                   } in (aa, ad)
              else (a, b)))
          xa;
    (aa, _) = a;
    _ = stat_stop ();
  } in aa;

scc_decomp :: forall a. (Eq a, Key a) => [(a, a)] -> [[a]];
scc_decomp e =
  let {
    ee = Set e;
  } in filter (\ a -> (case a of {
                        [] -> True;
                        [v] -> member (v, v) ee;
                        _ : _ : _ -> True;
                      }))
         (compute_SCC_tr (create_graph_impl e));

check_acyclic ::
  forall a.
    (Eq a, Key a,
      Showa a) => [(a, a)] -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_acyclic r =
  catch_errora
    (catch_errora
      (forallM
        (\ scc ->
          Inl ((shows_prec_list zero_nat ['S', 'C', 'C', ' '] .
                 shows_prec_list zero_nat scc) .
                shows_prec_list zero_nat
                  [' ', 'd', 'e', 't', 'e', 'c', 't', 'e', 'd', ' ']))
        (scc_decomp r))
      (\ x -> Inl (snd x)))
    (\ x ->
      Inl (((shows_prec_list zero_nat ['\n', 'g', 'r', 'a', 'p', 'h', ' '] .
              shows_prec_list zero_nat r) .
             shows_prec_list zero_nat
               [' ', 'n', 'o', 't', ' ', 'a', 'c', 'y', 'c', 'l', 'i', 'c',
                 '\n']) .
            x));

type_of ::
  forall a b c d. (Eq b) => Logic_ext a b c () -> Term a (d, b) -> Maybe b;
type_of lambda (Fun f ts) =
  bind (mapM (type_of lambda) ts)
    (\ tys -> let {
                (tysa, t) = types lambda f;
              } in bind (guard (tys == tysa)) (\ _ -> Just t));
type_of lambda (Var v) = Just (snd v);

is_bool ::
  forall a b c d. (Eq b) => Logic_ext a b c () -> Term a (d, b) -> Bool;
is_bool lambda e = (case type_of lambda e of {
                     Nothing -> False;
                     Just v -> member v (bool lambda);
                   }) &&
                     not (is_Var e);

invariant ::
  forall a b c d e f g. Art_node_impl a b c d e f g -> Formula (Term a (b, c));
invariant (Art_Node x1 x2 x3 x4) = x2;

location :: forall a b c d e f g. Art_node_impl a b c d e f g -> d;
location (Art_Node x1 x2 x3 x4) = x3;

initial_nodea :: forall a b c d e f g h. Art_impl_ext a b c d e f g h -> e;
initial_nodea (Art_impl_ext initial_node nodes more) = initial_node;

name :: forall a b c d e f g. Art_node_impl a b c d e f g -> e;
name (Art_Node x1 x2 x3 x4) = x1;

edgea ::
  forall a b c d e f g. Art_node_impl a b c d e f g -> Art_edge_impl e f g;
edgea (Art_Node x1 x2 x3 x4) = x4;

nodesb ::
  forall a b c d e f g h.
    Art_impl_ext a b c d e f g h -> [Art_node_impl a b c d e f g];
nodesb (Art_impl_ext initial_node nodes more) = nodes;

art_edge_of ::
  forall a b c d e f g.
    (Compare_order e,
      Showa e) => Lts_impl a b c d e ->
                    Art_edge_impl f e g -> Art_edge a b c d f;
art_edge_of pi (Cover_Edge an uu) = Cover an;
art_edge_of pi (Children_Edge ans) =
  Children (map (\ (t, a) -> let {
                               (aa, _) = a;
                             } in (transition_of pi t, aa))
             ans);

art_nodes :: forall a b c d e f g. Art_impl_ext a b c d e f g () -> [e];
art_nodes ai = map name (nodesb ai);

art_of ::
  forall a b c d e f g.
    (Compare_order e, Showa e, Compare_order f,
      Showa f) => Lts_impl a b c d e ->
                    Art_impl_ext a b c d f e g () -> Art_ext a b c d f ();
art_of pi ai =
  let {
    ans = nodesb ai;
  } in Art_ext (initial_nodea ai) (art_nodes ai)
         (map_of_total
           (\ a ->
             ['e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 'l', 'o', 'o', 'k',
               'i', 'n', 'g', ' ', 'u', 'p', ' ', 'a', 'r', 't', ' ', 'e', 'd',
               'g', 'e', ' '] ++
               shows_prec zero_nat a [])
           (map (\ a -> (name a, art_edge_of pi (edgea a))) ans))
         (map_of_total
           (\ a ->
             ['e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 'l', 'o', 'o', 'k',
               'i', 'n', 'g', ' ', 'u', 'p', ' ', 'n', 'o', 'd', 'e', ' ', 'l',
               'o', 'c', 'a', 't', 'i', 'o', 'n', ' '] ++
               shows_prec zero_nat a [])
           (map (\ a -> (name a, location a)) ans))
         (map_of_total
           (\ a ->
             ['e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 'l', 'o', 'o', 'k',
               'i', 'n', 'g', ' ', 'u', 'p', ' ', 'n', 'o', 'd', 'e', ' ', 'i',
               'n', 'v', 'a', 'r', 'i', 'a', 'n', 't', ' '] ++
               shows_prec zero_nat a [])
           (map (\ a -> (name a, invariant a)) ans))
         ();

xml_take_text ::
  forall a.
    ([Prelude.Char] -> [Xml] -> Sum_bot [Prelude.Char] a) ->
      [Xml] -> Sum_bot [Prelude.Char] a;
xml_take_text p xmls =
  (case xmls of {
    [] -> errora
            (shows_prec_list zero_nat
               ['e', 'x', 'p', 'e', 'c', 't', 'i', 'n', 'g', ' ', 'a', ' ', 't',
                 'e', 'x', 't', ' ', 'b', 'u', 't', ' ', 'e', 'n', 'c', 'o',
                 'u', 'n', 't', 'e', 'r', 'e', 'd', '\n']
               [] ++
              shows_prec_list zero_nat xmls []);
    XML _ _ _ : _ ->
      errora
        (shows_prec_list zero_nat
           ['e', 'x', 'p', 'e', 'c', 't', 'i', 'n', 'g', ' ', 'a', ' ', 't',
             'e', 'x', 't', ' ', 'b', 'u', 't', ' ', 'e', 'n', 'c', 'o', 'u',
             'n', 't', 'e', 'r', 'e', 'd', '\n']
           [] ++
          shows_prec_list zero_nat xmls []);
    XML_text text : xmlsa -> p text xmlsa;
  });

top_set :: forall a. Set a;
top_set = Coset [];

forallM_index_aux ::
  forall a b. (a -> Nat -> Sum b ()) -> Nat -> [a] -> Sum ((a, Nat), b) ();
forallM_index_aux p i [] = Inr ();
forallM_index_aux p i (x : xs) =
  bindb (catch_errora (p x i) (\ xa -> Inl ((x, i), xa)))
    (\ _ -> forallM_index_aux p (suc i) xs);

forallM_index ::
  forall a b. (a -> Nat -> Sum b ()) -> [a] -> Sum ((a, Nat), b) ();
forallM_index p xs = forallM_index_aux p zero_nat xs;

parse_trans_id :: Xml -> Sum_bot [Prelude.Char] [Prelude.Char];
parse_trans_id =
  text ['t', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', 'I', 'd'];

edge :: forall a b c d e f. Art_ext a b c d e f -> e -> Art_edge a b c d e;
edge (Art_ext initial_node nodes edge node_location node_invariant more) = edge;

diff_by_label :: forall a b. (Eq a) => [(a, b)] -> Set a -> [(a, b)];
diff_by_label pairs l = filter (\ v -> not (member (fst v) l)) pairs;

parse_variable_id :: Xml -> Sum_bot [Prelude.Char] [Prelude.Char];
parse_variable_id = text ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'I', 'd'];

parse_trans_var :: Xml -> Sum_bot [Prelude.Char] (Trans_var [Prelude.Char]);
parse_trans_var =
  xml_enter_if ['p', 'o', 's', 't']
    (xml_take parse_variable_id (xml_leave . Post))
    (change parse_variable_id Pre);

natural :: forall a. Sharp a -> a;
natural (Sharp l) = l;
natural (Flat l) = l;

check_cut_points ::
  forall a.
    (Eq a, Key a,
      Showa a) => [(a, a)] ->
                    Set a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_cut_points r x =
  check_acyclic
    (filter (\ ab -> not (member (fst ab) x) && not (member (snd ab) x)) r);

map_formula :: forall a b. (a -> b) -> Formula a -> Formula b;
map_formula f (Atom x1) = Atom (f x1);
map_formula f (NegAtom x2) = NegAtom (f x2);
map_formula f (Conjunctiona x3) = Conjunctiona (map (map_formula f) x3);
map_formula f (Disjunction x4) = Disjunction (map (map_formula f) x4);

nodes :: forall a b c d e f. Art_ext a b c d e f -> [e];
nodes (Art_ext initial_node nodes edge node_location node_invariant more) =
  nodes;

shows_art_node ::
  forall a b c d e f g.
    (Showa d, Showa e,
      Showa f) => Art_node_impl a b c d e f g ->
                    [Prelude.Char] -> [Prelude.Char];
shows_art_node (Art_Node n uu l (Cover_Edge m uv)) =
  (((shows_prec zero_nat n . shows_prec_list zero_nat ['(', '@', ' ']) .
     shows_prec zero_nat l) .
    shows_prec_list zero_nat
      [')', ':', ' ', 'c', 'o', 'v', 'e', 'r', 'e', 'd', ' ', 'b', 'y', ' ']) .
    shows_prec zero_nat m;
shows_art_node (Art_Node n uw l (Children_Edge ls)) =
  (((shows_prec zero_nat n . shows_prec_list zero_nat ['(', '@', ' ']) .
     shows_prec zero_nat l) .
    shows_prec_list zero_nat
      [')', ':', ' ', 'g', 'o', 'e', 's', ' ', 't', 'o', ' ']) .
    shows_list_gen
      (\ (tr, (na, _)) ->
        ((shows_prec_list zero_nat ['-'] . shows_prec zero_nat tr) .
          shows_prec_list zero_nat ['-', '>']) .
          shows_prec zero_nat na)
      ['[', ']'] ['['] [',', ' '] [']'] ls;

shows_art ::
  forall a b c d e f g.
    (Showa d, Showa e,
      Showa f) => Art_impl_ext a b c d e f g () ->
                    [Prelude.Char] -> [Prelude.Char];
shows_art a =
  (((shows_prec_list zero_nat
       ['A', 'R', 'T', ':', '\n', 'I', 'n', 'i', 't', 'i', 'a', 'l', ' ', 'n',
         'o', 'd', 'e', ':', ' '] .
      shows_prec zero_nat (initial_nodea a)) .
     shows_prec_list zero_nat ['\n', 'A', 'r', 'c', 's', '\n']) .
    shows_sep shows_art_node shows_nl (nodesb a)) .
    shows_nl;

transition_rule ::
  forall a b c d e.
    (Eq b) => Logic_ext a b c () -> Transition_rule a d b e -> Bool;
transition_rule lambda (Transition l r phi) = formula (is_bool lambda) phi;

check_lts_impl ::
  forall a b c d e f.
    (Eq b) => Logic_ext a b c () ->
                Lts_impl a d b e f -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_lts_impl lambda pi =
  let {
    (Lts_Impl _ ti lc) = pi;
  } in bindb (catch_errora
               (forallM
                 (\ (_, t) ->
                   check (transition_rule lambda t)
                     (shows_prec_list zero_nat
                       ['i', 'l', 'l', '-', 'f', 'o', 'r', 'm', 'e', 'd', ' ',
                         't', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', ' ',
                         'i', 'n', ' ', 'L', 'T', 'S']))
                 ti)
               (\ x -> Inl (snd x)))
         (\ _ ->
           catch_errora
             (forallM
               (\ (_, f) ->
                 check (formula (is_bool lambda) f)
                   (shows_prec_list zero_nat
                     ['i', 'l', 'l', '-', 'f', 'o', 'r', 'm', 'e', 'd', ' ',
                       'l', 'o', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'c', 'o',
                       'n', 'd', 'i', 't', 'i', 'o', 'n', ' ', 'i', 'n', ' ',
                       'L', 'T', 'S']))
               lc)
             (\ x -> Inl (snd x)));

contains_var_term :: forall a b. (Eq a) => a -> Term b a -> Bool;
contains_var_term x (Var y) = x == y;
contains_var_term x (Fun uu ts) = any (contains_var_term x) ts;

is_sharp :: forall a. Sharp a -> Bool;
is_sharp (Flat uu) = False;
is_sharp (Sharp uv) = True;

lIA_negate ::
  forall a. (Showa a) => Term LIA_op (a, LIA_type) -> Term LIA_op (a, LIA_type);
lIA_negate (Fun Less [a, b]) = Fun Lesseq [b, a];
lIA_negate (Fun Lesseq [a, b]) = Fun Less [b, a];

lin_const :: forall a. Lin_exp a -> Int;
lin_const (Lin_Exp x1 x2) = x1;

lin_list :: forall a. Lin_exp a -> [(a, Int)];
lin_list (Lin_Exp x1 x2) = x2;

add_and_mult_list :: forall a. Nat -> Lin_exp a -> Lin_exp a -> Lin_exp a;
add_and_mult_list c le1 le2 =
  Lin_Exp (plus_int (times_int (lin_const le1) (int_of_nat c)) (lin_const le2))
    (map (apsnd (times_int (int_of_nat c))) (lin_list le1) ++ lin_list le2);

apply_hint :: forall a. [Nat] -> [Lin_exp a] -> Lin_exp a;
apply_hint (n : ns) (a : asa) = add_and_mult_list n a (apply_hint ns asa);
apply_hint [] (a : asa) = add_and_mult_list one_nat a (apply_hint [] asa);
apply_hint uu [] = Lin_Exp zero_int [];

parse_location_id :: Xml -> Sum_bot [Prelude.Char] [Prelude.Char];
parse_location_id = text ['l', 'o', 'c', 'a', 't', 'i', 'o', 'n', 'I', 'd'];

xml_enter_options_sub ::
  forall a.
    [Prelude.Char] ->
      [([Prelude.Char], [Xml] -> Sum_bot [Prelude.Char] a)] ->
        Xml -> Sum_bot [Prelude.Char] a;
xml_enter_options_sub tags ((tag, p) : rest) (XML name atts xmls) =
  (if tag == name then p xmls
    else xml_enter_options_sub (name ++ tags) rest (XML name atts xmls));
xml_enter_options_sub tags [] xml =
  errora
    (['e', 'x', 'p', 'e', 'c', 't', 'i', 'n', 'g', ' '] ++
      shows_prec_list zero_nat (reverse tags) [] ++
        [' ', 'b', 'u', 't', ' ', 'e', 'n', 'c', 'o', 'u', 'n', 't', 'e', 'r',
          'e', 'd', '\n'] ++
          shows_prec_xml zero_nat xml []);
xml_enter_options_sub tags uu (XML_text v) =
  errora
    (['e', 'x', 'p', 'e', 'c', 't', 'i', 'n', 'g', ' '] ++
      shows_prec_list zero_nat (reverse tags) [] ++
        [' ', 'b', 'u', 't', ' ', 'e', 'n', 'c', 'o', 'u', 'n', 't', 'e', 'r',
          'e', 'd', '\n'] ++
          shows_prec_xml zero_nat (XML_text v) []);

xml_enter_options ::
  forall a.
    [([Prelude.Char], [Xml] -> Sum_bot [Prelude.Char] a)] ->
      Xml -> Sum_bot [Prelude.Char] a;
xml_enter_options = xml_enter_options_sub [];

less_eq_set :: forall a. (Eq a) => Set a -> Set a -> Bool;
less_eq_set (Coset xs) (Set ys) =
  (if null xs && null ys then False
    else (error :: forall a. String -> (() -> a) -> a)
           "subset_eq (List.coset _) (List.set _) requires type class instance card_UNIV"
           (\ _ -> less_eq_set (Coset xs) (Set ys)));
less_eq_set a (Coset ys) = all (\ y -> not (member y a)) ys;
less_eq_set (Set xs) b = all (\ x -> member x b) xs;

equal_set :: forall a. (Eq a) => Set a -> Set a -> Bool;
equal_set a b = less_eq_set a b && less_eq_set b a;

is_cover_node :: forall a b c d e f g. Art_node_impl a b c d e f g -> Bool;
is_cover_node (Art_Node uu uv uw (Cover_Edge ux uy)) = True;
is_cover_node (Art_Node uz va vb (Children_Edge vc)) = False;

cover_hints ::
  forall a b c d e f g.
    (Compare_order e, Default g) => Art_impl_ext a b c d e f g () -> e -> g;
cover_hints ai =
  map_of_default defaulta
    (map_filter
      (\ x ->
        (if is_cover_node x then Just (name x, let {
         (Cover_Edge _ h) = edgea x;
       } in h)
          else Nothing))
      (nodesb ai));

nodesa :: forall a b c d e. Hinter_ext a b c d e -> [c];
nodesa (Hinter_ext nodes succ_trans_list cover_hints transition_hints more) =
  nodes;

drop_xml_attributes :: Xml -> Xml;
drop_xml_attributes (XML n atts cs) = XML n [] cs;
drop_xml_attributes (XML_text v) = XML_text v;

the_bool :: LIA_value -> Bool;
the_bool (Boolean x2) = x2;

lIA_type_values :: LIA_type -> Set LIA_value;
lIA_type_values BoolT = image Boolean top_set;
lIA_type_values IntegerT = image Integera top_set;

the_int :: LIA_value -> Int;
the_int (Integera x1) = x1;

lIA_interpret :: LIA_op -> [LIA_value] -> LIA_value;
lIA_interpret Less [x, y] = Boolean (less_int (the_int x) (the_int y));
lIA_interpret Lesseq [x, y] = Boolean (less_eq_int (the_int x) (the_int y));
lIA_interpret Sum [x, y] = Integera (plus_int (the_int x) (the_int y));
lIA_interpret (Const x) [] = Integera x;
lIA_interpret (Cmult x) [y] = Integera (times_int x (the_int y));
lIA_interpret Lesseq [] = error "undefined";
lIA_interpret Lesseq [v] = error "undefined";
lIA_interpret Lesseq (v : vb : vd : ve) = error "undefined";
lIA_interpret Sum [] = error "undefined";
lIA_interpret Sum [v] = error "undefined";
lIA_interpret Sum (v : vb : vd : ve) = error "undefined";
lIA_interpret (Const v) (va : vb) = error "undefined";
lIA_interpret (Cmult v) [] = error "undefined";
lIA_interpret (Cmult v) (va : vc : vd) = error "undefined";
lIA_interpret Less [] = error "undefined";
lIA_interpret Less [v] = error "undefined";
lIA_interpret uu (v : vb : vd : ve) = error "undefined";

lIA_types :: LIA_op -> ([LIA_type], LIA_type);
lIA_types Less = ([IntegerT, IntegerT], BoolT);
lIA_types Lesseq = ([IntegerT, IntegerT], BoolT);
lIA_types Sum = ([IntegerT, IntegerT], IntegerT);
lIA_types (Const uu) = ([], IntegerT);
lIA_types (Cmult uv) = ([IntegerT], IntegerT);

lia :: Logic_ext LIA_op LIA_type LIA_value ();
lia = Logic_ext lIA_types lIA_type_values (inserta BoolT bot_set) the_bool
        lIA_interpret ();

adda ::
  forall a.
    Term LIA_op (a, LIA_type) ->
      Term LIA_op (a, LIA_type) -> Term LIA_op (a, LIA_type);
adda h t = Fun Sum [h, t];

change_source ::
  forall a b c d. a -> Transition_rule b c d a -> Transition_rule b c d a;
change_source l (Transition src tgt phi) = Transition l tgt phi;

change_target ::
  forall a b c d. a -> Transition_rule b c d a -> Transition_rule b c d a;
change_target l (Transition src tgt phi) = Transition src l phi;

lIA_translate_lit ::
  forall a.
    (Showa a) => Formula (Term LIA_op (a, LIA_type)) ->
                   Term LIA_op (a, LIA_type);
lIA_translate_lit (Atom e) = e;
lIA_translate_lit (NegAtom e) = lIA_negate e;

translate_lits ::
  forall a.
    (Showa a) => [Formula (Term LIA_op (a, LIA_type))] ->
                   [Term LIA_op (a, LIA_type)];
translate_lits = map lIA_translate_lit;

translate_conj ::
  forall a.
    (Showa a) => Formula (Term LIA_op (a, LIA_type)) ->
                   [Term LIA_op (a, LIA_type)];
translate_conj (Conjunctiona phi_s) = translate_lits phi_s;

hints_parser ::
  forall a.
    (Default a) => (Xml -> Sum_bot [Prelude.Char] a) ->
                     Xml -> Sum_bot [Prelude.Char] (Hint a);
hints_parser hint_parser =
  many ['h', 'i', 'n', 't', 's'] hint_parser (\ _ -> default_hint);

art_node_parser ::
  forall a b c d e f g.
    (Default g) => ([Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] a) ->
                     (Xml -> Sum_bot [Prelude.Char] b) ->
                       (Xml -> Sum_bot [Prelude.Char] c) ->
                         (Xml ->
                           Sum_bot [Prelude.Char] (Formula (Term d (e, f)))) ->
                           (Xml -> Sum_bot [Prelude.Char] g) ->
                             Xml ->
                               Sum_bot [Prelude.Char]
                                 (Art_node_impl d e f b a c (Hint g));
art_node_parser art_node_id_parser location_parser trans_id_parser atom_parser
  hint_parser =
  tuple4 ['n', 'o', 'd', 'e']
    (art_node_id_parser ['n', 'o', 'd', 'e', 'I', 'd'])
    (singleton ['i', 'n', 'v', 'a', 'r', 'i', 'a', 'n', 't']
      (formula_parser atom_parser) id)
    (singleton ['l', 'o', 'c', 'a', 't', 'i', 'o', 'n'] location_parser id)
    (options
      [(['c', 'h', 'i', 'l', 'd', 'r', 'e', 'n'],
         many ['c', 'h', 'i', 'l', 'd', 'r', 'e', 'n']
           (triple ['c', 'h', 'i', 'l', 'd'] trans_id_parser
             (art_node_id_parser ['n', 'o', 'd', 'e', 'I', 'd'])
             (hints_parser hint_parser) (\ t n h -> (t, (n, h))))
           Children_Edge),
        (['c', 'o', 'v', 'e', 'r', 'E', 'd', 'g', 'e'],
          pair ['c', 'o', 'v', 'e', 'r', 'E', 'd', 'g', 'e']
            (art_node_id_parser ['n', 'o', 'd', 'e', 'I', 'd'])
            (hints_parser hint_parser) Cover_Edge)])
    Art_Node;

art_parser ::
  forall a b c d e f g.
    (Default g) => ([Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] a) ->
                     (Xml -> Sum_bot [Prelude.Char] b) ->
                       (Xml -> Sum_bot [Prelude.Char] c) ->
                         (Xml ->
                           Sum_bot [Prelude.Char] (Formula (Term d (e, f)))) ->
                           (Xml -> Sum_bot [Prelude.Char] g) ->
                             Xml ->
                               Sum_bot [Prelude.Char]
                                 (Art_impl_ext d e f b a c (Hint g) ());
art_parser art_node_id_parser location_parser trans_id_parser atom_parser
  hint_parser =
  pair ['i', 'm', 'p', 'a', 'c', 't']
    (art_node_id_parser ['i', 'n', 'i', 't', 'i', 'a', 'l'])
    (many ['n', 'o', 'd', 'e', 's']
      (art_node_parser art_node_id_parser location_parser trans_id_parser
        atom_parser hint_parser)
      id)
    (\ init ns -> Art_impl_ext init ns ());

update_transitions_impl ::
  forall a b c d e f.
    Lts_impl a b c d e -> [(f, Transition_rule a b c d)] -> Lts_impl a b c d f;
update_transitions_impl (Lts_Impl i tsa lc) ts = Lts_Impl i ts lc;

del_transitions_impl ::
  forall a b c d e. (Eq e) => Lts_impl a b c d e -> [e] -> Lts_impl a b c d e;
del_transitions_impl p td =
  update_transitions_impl p (diff_by_label (transitions_impl p) (Set td));

initial_node :: forall a b c d e f. Art_ext a b c d e f -> e;
initial_node (Art_ext initial_node nodes edge node_location node_invariant more)
  = initial_node;

node_invariant ::
  forall a b c d e f. Art_ext a b c d e f -> e -> Formula (Term a (b, c));
node_invariant
  (Art_ext initial_node nodes edge node_location node_invariant more) =
  node_invariant;

art ::
  forall a b c d e f.
    (Eq b) => Logic_ext a b c () -> Art_ext a d b e f () -> Bool;
art lambda a =
  all (\ aa -> formula (is_bool lambda) (node_invariant a aa)) (nodes a);

transition_hints ::
  forall a b c d e f g.
    (Eq e) => Art_impl_ext a b c d e f g () -> e -> Maybe [g];
transition_hints ai =
  map_of
    (map_filter
      (\ x ->
        (if not (is_cover_node x)
          then Just (name x, let {
                               (Children_Edge a) = edgea x;
                             } in map (\ (_, (_, h)) -> h) a)
          else Nothing))
      (nodesb ai));

shows_prec_int :: Nat -> Int -> [Prelude.Char] -> [Prelude.Char];
shows_prec_int = showsp_int;

shows_lin_exp ::
  forall a. (Showa a) => Lin_exp a -> [Prelude.Char] -> [Prelude.Char];
shows_lin_exp (Lin_Exp c cxs) =
  (shows_list_gen
     (\ (v, ca) ->
       (if equal_int ca (Int_of_integer (1 :: Integer))
         then shows_prec zero_nat v
         else (shows_prec_int zero_nat ca .
                shows_prec_list zero_nat [' ', '*', ' ']) .
                shows_prec zero_nat v))
     ['0'] [] [' ', '+', ' '] []
     (filter (\ (_, ca) -> not (equal_int ca zero_int)) cxs) .
    shows_prec_list zero_nat [' ', '>', '=', ' ']) .
    shows_prec_int zero_nat (uminus_int c);

flatten_exp :: forall a. Term LIA_op (a, LIA_type) -> Lin_exp a;
flatten_exp (Var a) = Lin_Exp zero_int [(fst a, Int_of_integer (1 :: Integer))];
flatten_exp (Fun Less [a, b]) =
  let {
    (Lin_Exp ac al, Lin_Exp bc bl) = (flatten_exp a, flatten_exp b);
  } in Lin_Exp (minus_int (minus_int bc ac) (Int_of_integer (1 :: Integer)))
         (map (apsnd (times_int (uminus_int (Int_of_integer (1 :: Integer)))))
            al ++
           bl);
flatten_exp (Fun Lesseq [a, b]) =
  let {
    (Lin_Exp ac al, Lin_Exp bc bl) = (flatten_exp a, flatten_exp b);
  } in Lin_Exp (minus_int bc ac)
         (map (apsnd (times_int (uminus_int (Int_of_integer (1 :: Integer)))))
            al ++
           bl);
flatten_exp (Fun Sum [a, b]) =
  let {
    (Lin_Exp ac al, Lin_Exp bc bl) = (flatten_exp a, flatten_exp b);
  } in Lin_Exp (plus_int bc ac) (al ++ bl);
flatten_exp (Fun (Const a) []) = Lin_Exp a [];
flatten_exp (Fun (Cmult c) [a]) =
  let {
    (Lin_Exp ac al) = flatten_exp a;
  } in Lin_Exp (times_int ac c) (map (apsnd (times_int c)) al);

lin_exp_is_negative_constant ::
  forall a. (Showa a) => Lin_exp a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
lin_exp_is_negative_constant (Lin_Exp a lst) =
  catch_errora
    (bindb
      (check (less_int a zero_int)
        (shows_prec_list zero_nat
          ['c', 'o', 'n', 's', 't', 'a', 'n', 't', ' ', 'r', 'e', 'm', 'a', 'i',
            'n', 'i', 'n', 'g', ' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ',
            'l', 'e', 's', 's', ' ', 't', 'h', 'a', 'n', ' ', 'z', 'e', 'r',
            'o']))
      (\ _ ->
        check (all (const False) lst)
          (shows_prec_list zero_nat
            ['c', 'o', 'e', 'f', 'f', 'i', 'c', 'i', 'e', 'n', 't', 's', ' ',
              'u', 'n', 'e', 'q', 'u', 'a', 'l', ' ', 't', 'o', ' ', 'z', 'e',
              'r', 'o'])))
    (\ x ->
      Inl (((shows_prec_list zero_nat
               ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'd', 'e', 'r',
                 'i', 'v', 'e', ' ', 'a', ' ', 'c', 'o', 'n', 't', 'r', 'a',
                 'd', 'i', 'c', 't', 'i', 'o', 'n', ' '] .
              shows_lin_exp (Lin_Exp a lst)) .
             shows_nl) .
            x));

normalize_sum_duplicates :: forall a. (Eq a) => [(a, Int)] -> [(a, Int)];
normalize_sum_duplicates [] = [];
normalize_sum_duplicates ((x, c) : cxs) =
  let {
    (xs, dys) = partition (\ (y, _) -> y == x) cxs;
  } in (x, plus_int c (sum_list (map snd xs))) : normalize_sum_duplicates dys;

normalize_sum_0 :: forall a. [(a, Int)] -> [(a, Int)];
normalize_sum_0 = filter (\ (_, c) -> not (equal_int c zero_int));

normalize_sum :: forall a. (Eq a, Linorder a) => [(a, Int)] -> [(a, Int)];
normalize_sum =
  (normalize_sum_0 . sort_key (\ x -> x)) . normalize_sum_duplicates;

compress :: forall a. (Eq a, Linorder a) => Lin_exp a -> Lin_exp a;
compress v = Lin_Exp (lin_const v) (normalize_sum (lin_list v));

zero_linear_poly :: Linear_poly;
zero_linear_poly = LinearPoly zero;

lin_list_to_linear_poly :: forall a. (a -> Nat) -> [(a, Int)] -> Linear_poly;
lin_list_to_linear_poly rho [] = zero_linear_poly;
lin_list_to_linear_poly rho ((x, c) : le) =
  plus_linear_poly (lp_monom (of_int c) (rho x))
    (lin_list_to_linear_poly rho le);

to_simplex_constraint :: forall a. (a -> Nat) -> Lin_exp a -> Constraint;
to_simplex_constraint rho (Lin_Exp c le) =
  GEQ (lin_list_to_linear_poly rho le) (of_int (uminus_int c));

lin_exp_vars_list :: forall a. Lin_exp a -> [a];
lin_exp_vars_list le = map fst (lin_list le);

unsat_via_simplex ::
  forall a. (Compare_order a, Eq a, Showa a) => [Lin_exp a] -> Bool;
unsat_via_simplex les =
  let {
    vs = remdups (concatMap lin_exp_vars_list les);
    ren_map = of_alist (zip vs (upt zero_nat (size_list vs)));
    ren_fun = (\ v -> (case lookupa ren_map v of {
                        Nothing -> zero_nat;
                        Just n -> n;
                      }));
    cs = map (to_simplex_constraint ren_fun) les;
  } in is_none (simplex cs);

lia_unsat_checker ::
  forall a.
    (Compare_order a, Eq a,
      Showa a) => Lia_hints ->
                    [Lin_exp a] -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
lia_unsat_checker hints cnjs =
  catch_errora
    (case hints of {
      LIA_Hints nums_to_multiply ->
        or_ok (lin_exp_is_negative_constant
                (compress (apply_hint nums_to_multiply cnjs)))
          (lin_exp_is_negative_constant
            (compress (apply_hint (nums_to_multiply ++ [one_nat]) cnjs)));
      LIA_Simplex ->
        check (unsat_via_simplex cnjs)
          (shows_prec_list zero_nat
            ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'u', 's', 'e',
              ' ', 's', 'i', 'm', 'p', 'l', 'e', 'x', ' ', 'a', 'l', 'g', 'o',
              'r', 'i', 't', 'h', 'm', ' ', 't', 'o', ' ', 'p', 'r', 'o', 'v',
              'e', ' ', 'u', 'n', 's', 'a', 't', 'i', 's', 'f', 'i', 'a', 'b',
              'i', 'l', 'i', 't', 'y']);
    })
    (\ x ->
      Inl ((((((shows_prec_list zero_nat
                  ['T', 'h', 'e', ' ', 'l', 'i', 'n', 'e', 'a', 'r', ' ', 'i',
                    'n', 'e', 'q', 'u', 'a', 'l', 'i', 't', 'i', 'e', 's',
                    ' '] .
                 shows_sep shows_lin_exp shows_nl cnjs) .
                shows_prec_list zero_nat
                  [' ', 'c', 'a', 'n', 'n', 'o', 't', ' ', 'b', 'e', ' ', 'p',
                    'r', 'o', 'v', 'e', 'd', ' ', 'u', 'n', 's', 'a', 't', 'i',
                    's', 'f', 'i', 'a', 'b', 'l', 'e', '\n']) .
               shows_prec_list zero_nat
                 ['v', 'i', 'a', ' ', 't', 'h', 'e', ' ', 'h', 'i', 'n', 't',
                   's', ' ']) .
              shows_prec_lia_hints zero_nat hints) .
             shows_nl) .
            x));

check_lia_clause ::
  forall a.
    (Compare_order a, Eq a,
      Showa a) => Lia_hints ->
                    Formula (Term LIA_op (a, LIA_type)) ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_lia_clause hints phi =
  let {
    es = map flatten_exp (translate_conj (form_not phi));
  } in catch_errora (lia_unsat_checker hints es)
         (\ x ->
           Inl ((((shows_prec_list zero_nat
                     ['C', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'p',
                       'r', 'o', 'v', 'e', ' ', 'u', 'n', 's', 'a', 't', 'i',
                       's', 'f', 'i', 'a', 'b', 'i', 'l', 'i', 't', 'y', ' ',
                       'o', 'f', ' ', 'L', 'I', 'A', ' ', 'c', 'o', 'n', 'j',
                       'u', 'n', 'c', 't', 'i', 'o', 'n', ' '] .
                    shows_nl) .
                   shows_list_gen shows_lin_exp ['F', 'a', 'l', 's', 'e'] []
                     [' ', '&', '&', ' '] [] es) .
                  shows_nl) .
                 x));

call_graph_impl :: forall a b c d e. (Eq d) => Lts_impl a b c d e -> [(d, d)];
call_graph_impl r =
  remdups
    (map (\ tau -> (source (snd tau), target (snd tau))) (transitions_impl r));

flat_transition ::
  forall a b c d. Transition_rule a b c d -> Transition_rule a b c (Sharp d);
flat_transition (Transition l r phi) = Transition (Flat l) (Flat r) phi;

shows_formula ::
  forall a.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      Formula a -> [Prelude.Char] -> [Prelude.Char];
shows_formula shows_atom (Disjunction fs) =
  let {
    ss = map (shows_formula shows_atom) fs;
  } in (if equal_nat (size_list ss) one_nat then hd ss
         else (if null ss then id else shows_paren)
                (shows_list_gen id ['F', 'a', 'l', 's', 'e'] []
                  [' ', '|', '|', ' '] [] ss));
shows_formula shows_atom (Conjunctiona fs) =
  let {
    ss = map (shows_formula shows_atom) fs;
  } in (if equal_nat (size_list ss) one_nat then hd ss
         else (if null ss then id else shows_paren)
                (shows_list_gen id ['T', 'r', 'u', 'e'] [] [' ', '&', '&', ' ']
                  [] ss));
shows_formula shows_atom (NegAtom a) =
  (shows_prec_list zero_nat ['!', ' ', '('] . shows_atom a) .
    shows_prec_list zero_nat [')'];
shows_formula shows_atom (Atom a) = shows_atom a;

node_location :: forall a b c d e f. Art_ext a b c d e f -> e -> d;
node_location
  (Art_ext initial_node nodes edge node_location node_invariant more) =
  node_location;

constant_exp :: forall a. LIA_value -> Term LIA_op a;
constant_exp (Integera n) = Fun (Const n) [];
constant_exp (Boolean False) =
  Fun Less
    [Fun (Const (Int_of_integer (1 :: Integer))) [], Fun (Const zero_int) []];
constant_exp (Boolean True) =
  Fun Less
    [Fun (Const zero_int) [], Fun (Const (Int_of_integer (1 :: Integer))) []];

shows_transition ::
  forall a b c d.
    (Showa d) => (Term a (Trans_var b, c) ->
                   [Prelude.Char] -> [Prelude.Char]) ->
                   Transition_rule a b c d -> [Prelude.Char] -> [Prelude.Char];
shows_transition shows_tatom (Transition s t phi) =
  (((shows_prec zero_nat s .
      shows_prec_list zero_nat [' ', '-', '-', '-', '>', ' ']) .
     shows_prec zero_nat t) .
    shows_prec_list zero_nat [':', ' ']) .
    shows_formula shows_tatom phi;

shows_labeled_transition ::
  forall a b c d e.
    (Showa d,
      Showa e) => (Term a (Trans_var b, c) ->
                    [Prelude.Char] -> [Prelude.Char]) ->
                    (d, Transition_rule a b c e) ->
                      [Prelude.Char] -> [Prelude.Char];
shows_labeled_transition shows_tatom (lab, tran) =
  (shows_prec zero_nat lab . shows_prec_list zero_nat [':', ' ']) .
    shows_transition shows_tatom tran;

shows_lts ::
  forall a b c d e.
    (Showa d,
      Showa e) => (Term a (b, c) -> [Prelude.Char] -> [Prelude.Char]) ->
                    (Term a (Trans_var b, c) ->
                      [Prelude.Char] -> [Prelude.Char]) ->
                      Lts_impl a b c d e -> [Prelude.Char] -> [Prelude.Char];
shows_lts shows_atom shows_tatom (Lts_Impl i tran lc) =
  (((((shows_prec_list zero_nat
         ['L', 'T', 'S', ':', '\n', 'I', 'n', 'i', 't', 'i', 'a', 'l', ' ', 'l',
           'o', 'c', 'a', 't', 'i', 'o', 'n', ':', ' '] .
        shows_prec zero_nat i) .
       shows_prec_list zero_nat
         ['\n', 'T', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', 's', '\n']) .
      shows_sep (shows_labeled_transition shows_tatom) shows_nl tran) .
     shows_prec_list zero_nat
       ['\n', 'L', 'o', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'c', 'o', 'n', 'd',
         'i', 't', 'i', 'o', 'n', 's']) .
    shows_sep
      (\ (l, f) ->
        (shows_prec zero_nat l . shows_prec_list zero_nat [':', ' ']) .
          shows_formula shows_atom f)
      shows_nl lc) .
    shows_nl;

sharp_transition ::
  forall a b c d. Transition_rule a b c d -> Transition_rule a b c (Sharp d);
sharp_transition (Transition l r phi) = Transition (Sharp l) (Sharp r) phi;

get_disj_invariant ::
  forall a b c d e.
    (Eq d) => Art_ext a b c d e () -> d -> Formula (Term a (b, c));
get_disj_invariant a l =
  form_ex
    (map_filter
      (\ x ->
        (if node_location a x == l then Just (node_invariant a x) else Nothing))
      (nodes a));

cover_hintsa :: forall a b c d e. Hinter_ext a b c d e -> c -> a;
cover_hintsa
  (Hinter_ext nodes succ_trans_list cover_hints transition_hints more) =
  cover_hints;

lIA_sym_parser ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Term LIA_op (a, LIA_type));
lIA_sym_parser v =
  xml_enter_if ['c', 'o', 'n', 's', 't', 'a', 'n', 't']
    (xml_take_int (xml_leave . (\ c -> Fun (Const c) [])))
    (change v (\ va -> Var (va, IntegerT)));

product_parser ::
  forall a.
    (Showa a) => (Xml -> Sum_bot [Prelude.Char] a) ->
                   Xml -> Sum_bot [Prelude.Char] (Term LIA_op (a, LIA_type));
product_parser v xml =
  (case xml of {
    XML _ [] [] -> lIA_sym_parser v xml;
    XML _ [] [_] -> lIA_sym_parser v xml;
    XML tag [] [x, y] ->
      (if tag == ['p', 'r', 'o', 'd', 'u', 'c', 't']
        then binda (lIA_sym_parser v x)
               (\ l ->
                 binda (lIA_sym_parser v y)
                   (\ r ->
                     (case (l, r) of {
                       (Var _, Var _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Var _, Fun Less _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Var _, Fun Lesseq _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Var _, Fun Sum _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Var _, Fun (Const i) []) -> returna (Fun (Cmult i) [l]);
                       (Var _, Fun (Const _) (_ : _)) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Var _, Fun (Cmult _) _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Less _, Var _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Less _, Fun Less _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Less _, Fun Lesseq _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Less _, Fun Sum _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Less _, Fun (Const i) []) ->
                         returna (Fun (Cmult i) [l]);
                       (Fun Less _, Fun (Const _) (_ : _)) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Less _, Fun (Cmult _) _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Lesseq _, Var _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Lesseq _, Fun Less _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Lesseq _, Fun Lesseq _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Lesseq _, Fun Sum _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Lesseq _, Fun (Const i) []) ->
                         returna (Fun (Cmult i) [l]);
                       (Fun Lesseq _, Fun (Const _) (_ : _)) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Lesseq _, Fun (Cmult _) _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Sum _, Var _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Sum _, Fun Less _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Sum _, Fun Lesseq _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Sum _, Fun Sum _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Sum _, Fun (Const i) []) ->
                         returna (Fun (Cmult i) [l]);
                       (Fun Sum _, Fun (Const _) (_ : _)) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun Sum _, Fun (Cmult _) _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Const i) [], _) -> returna (Fun (Cmult i) [r]);
                       (Fun (Const _) (_ : _), Var _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Const _) (_ : _), Fun Less _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Const _) (_ : _), Fun Lesseq _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Const _) (_ : _), Fun Sum _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Const _) (_ : _), Fun (Const i) []) ->
                         returna (Fun (Cmult i) [l]);
                       (Fun (Const _) (_ : _), Fun (Const _) (_ : _)) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Const _) (_ : _), Fun (Cmult _) _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Cmult _) _, Var _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Cmult _) _, Fun Less _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Cmult _) _, Fun Lesseq _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Cmult _) _, Fun Sum _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Cmult _) _, Fun (Const i) []) ->
                         returna (Fun (Cmult i) [l]);
                       (Fun (Cmult _) _, Fun (Const _) (_ : _)) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                       (Fun (Cmult _) _, Fun (Cmult _) _) ->
                         errora
                           (shows_prec_list zero_nat
                              ['n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p', 't',
                                'i', 'n', 'g', ' ']
                              [] ++
                             shows_prec_xml zero_nat x [] ++
                               shows_prec_list zero_nat [' ', '*', ' '] [] ++
                                 shows_prec_xml zero_nat y []);
                     })))
        else lIA_sym_parser v xml);
    XML _ [] (_ : _ : _ : _) -> lIA_sym_parser v xml;
    XML _ (_ : _) _ -> lIA_sym_parser v xml;
    XML_text _ -> lIA_sym_parser v xml;
  });

lin_exp_parser ::
  forall a.
    (Showa a) => (Xml -> Sum_bot [Prelude.Char] a) ->
                   Xml -> Sum_bot [Prelude.Char] (Term LIA_op (a, LIA_type));
lin_exp_parser v =
  xml_if ['s', 'u', 'm']
    (many ['s', 'u', 'm'] (product_parser v)
      (foldl adda (Fun (Const zero_int) [])))
    (product_parser v);

refine_transition_formula ::
  forall a b c d.
    Transition_rule a b c d ->
      Formula (Term a (Trans_var b, c)) -> Transition_rule a b c d;
refine_transition_formula (Transition l r phi) psi =
  Transition l r (form_and phi psi);

invariant_proof_parser ::
  forall a b c d e f g.
    (Default g) => ([Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] a) ->
                     (Xml -> Sum_bot [Prelude.Char] b) ->
                       (Xml -> Sum_bot [Prelude.Char] c) ->
                         (Xml ->
                           Sum_bot [Prelude.Char] (Formula (Term d (e, f)))) ->
                           (Xml -> Sum_bot [Prelude.Char] g) ->
                             Xml ->
                               Sum_bot [Prelude.Char]
                                 ([(b, Formula (Term d (e, f)))] ->
                                   Invariant_proof d e f b a c g);
invariant_proof_parser art_node_id_parser location_parser trans_id_parser
  atom_parser hint_parser =
  options
    [(['i', 'm', 'p', 'a', 'c', 't'],
       change
         (art_parser art_node_id_parser location_parser trans_id_parser
           atom_parser hint_parser)
         (\ prf i -> Impact i prf))];

the_Const :: LIA_op -> Int;
the_Const (Const x4) = x4;

lIA_type_parser :: Xml -> Sum_bot [Prelude.Char] LIA_type;
lIA_type_parser =
  options
    [(['i', 'n', 't'], leaf ['i', 'n', 't'] IntegerT),
      (['b', 'o', 'o', 'l'], leaf ['b', 'o', 'o', 'l'] BoolT)];

art_node_id_parser ::
  [Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] [Prelude.Char];
art_node_id_parser = text;

invariant_parser ::
  forall a b c d.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      (Xml -> Sum_bot [Prelude.Char] (Formula (Term b (c, d)))) ->
        Xml -> Sum_bot [Prelude.Char] (a, Formula (Term b (c, d)));
invariant_parser location_parser atom_parser =
  pair ['i', 'n', 'v', 'a', 'r', 'i', 'a', 'n', 't']
    (singleton ['l', 'o', 'c', 'a', 't', 'i', 'o', 'n'] location_parser id)
    (singleton ['f', 'o', 'r', 'm', 'u', 'l', 'a'] (formula_parser atom_parser)
      id)
    (\ a b -> (a, b));

invariants_parser ::
  forall a b c d.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      (Xml -> Sum_bot [Prelude.Char] (Formula (Term b (c, d)))) ->
        Xml -> Sum_bot [Prelude.Char] [(a, Formula (Term b (c, d)))];
invariants_parser location_parser atom_parser =
  many ['i', 'n', 'v', 'a', 'r', 'i', 'a', 'n', 't', 's']
    (invariant_parser location_parser atom_parser) id;

cooperation_proof_parser ::
  forall a b c.
    (Compare a,
      Compare_order b) => (Xml -> Sum_bot [Prelude.Char] (Sharp a)) ->
                            (Xml -> Sum_bot [Prelude.Char] b) ->
                              (Xml ->
                                Sum_bot [Prelude.Char]
                                  (Term LIA_op (c, LIA_type))) ->
                                (Xml ->
                                  Sum_bot [Prelude.Char]
                                    (Formula (Term LIA_op (c, LIA_type)))) ->
                                  (Xml ->
                                    Sum_bot [Prelude.Char]
                                      (Formula
(Term LIA_op (Trans_var c, LIA_type)))) ->
                                    (Xml ->
                                      Sum_bot [Prelude.Char]
(b, Transition_rule LIA_op c LIA_type (Sharp a))) ->
                                      (Xml -> Sum_bot [Prelude.Char] c) ->
(Xml -> Sum_bot [Prelude.Char] Lia_hints) ->
  Xml ->
    Sum_bot [Prelude.Char]
      (Cooperation_proof LIA_op c LIA_type LIA_value a b Lia_hints);
cooperation_proof_parser location_parser trans_id_parser exp_parser atom_parser
  tatom_parser transition_parser variable_parser hint_parser xml =
  options
    [(['t', 'r', 'i', 'v', 'i', 'a', 'l'],
       leaf ['t', 'r', 'i', 'v', 'i', 'a', 'l'] Trivial),
      (['n', 'e', 'w', 'I', 'n', 'v', 'a', 'r', 'i', 'a', 'n', 't', 's'],
        triple ['n', 'e', 'w', 'I', 'n', 'v', 'a', 'r', 'i', 'a', 'n', 't', 's']
          (invariants_parser location_parser atom_parser)
          (invariant_proof_parser art_node_id_parser location_parser
            trans_id_parser atom_parser hint_parser)
          (cooperation_proof_parser location_parser trans_id_parser exp_parser
            atom_parser tatom_parser transition_parser variable_parser
            hint_parser)
          (\ i p -> Invariants_Update (p i))),
      (['t', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', 'R', 'e', 'm', 'o',
         'v', 'a', 'l'],
        tuple5
          ['t', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', 'R', 'e', 'm', 'o',
            'v', 'a', 'l']
          (many ['r', 'a', 'n', 'k', 'i', 'n', 'g', 'F', 'u', 'n', 'c', 't',
                  'i', 'o', 'n', 's']
            (pair ['r', 'a', 'n', 'k', 'i', 'n', 'g', 'F', 'u', 'n', 'c', 't',
                    'i', 'o', 'n']
              (singleton ['l', 'o', 'c', 'a', 't', 'i', 'o', 'n']
                location_parser id)
              (many1 ['e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n']
                exp_parser exp_parser (\ a b -> a : b))
              (\ a b -> (a, b)))
            id)
          (many1 ['b', 'o', 'u', 'n', 'd'] exp_parser exp_parser
            (\ a b -> a : b))
          (many ['r', 'e', 'm', 'o', 'v', 'e'] trans_id_parser id)
          (many ['h', 'i', 'n', 't', 's']
            (options
              [(['s', 't', 'r', 'i', 'c', 't', 'D', 'e', 'c', 'r', 'e', 'a',
                  's', 'e'],
                 triple
                   ['s', 't', 'r', 'i', 'c', 't', 'D', 'e', 'c', 'r', 'e', 'a',
                     's', 'e']
                   trans_id_parser
                   (many ['b', 'o', 'u', 'n', 'd', 'H', 'i', 'n', 't', 's']
                     hint_parser id)
                   (many ['d', 'e', 'c', 'r', 'e', 'a', 's', 'e', 'H', 'i', 'n',
                           't', 's']
                     hint_parser id)
                   (\ x _ _ -> (x, default_hint))),
                (['w', 'e', 'a', 'k', 'D', 'e', 'c', 'r', 'e', 'a', 's', 'e'],
                  pair ['w', 'e', 'a', 'k', 'D', 'e', 'c', 'r', 'e', 'a', 's',
                         'e']
                    trans_id_parser
                    (many ['d', 'e', 'c', 'r', 'e', 'a', 's', 'e', 'H', 'i',
                            'n', 't', 's']
                      hint_parser id)
                    (\ x _ -> (x, default_hint)))])
            (map_of_default default_hint))
          (cooperation_proof_parser location_parser trans_id_parser exp_parser
            atom_parser tatom_parser transition_parser variable_parser
            hint_parser)
          (\ rs bounds removed hinter ->
            Transition_Removal
              (Transition_removal_info (map_of_default [] rs) removed IntegerT
                (map (\ bound ->
                       Integera
                         (minus_int (the_Const (fst (the (root bound))))
                           (Int_of_integer (1 :: Integer))))
                  bounds)
                hinter))),
      (['l', 'o', 'c', 'a', 't', 'i', 'o', 'n', 'A', 'd', 'd', 'i', 't', 'i',
         'o', 'n'],
        pair ['l', 'o', 'c', 'a', 't', 'i', 'o', 'n', 'A', 'd', 'd', 'i', 't',
               'i', 'o', 'n']
          transition_parser
          (cooperation_proof_parser location_parser trans_id_parser exp_parser
            atom_parser tatom_parser transition_parser variable_parser
            hint_parser)
          (\ (tr_id, tau) ->
            Location_Addition
              (Location_Addition_Info (source tau) (target tau) tr_id tau))),
      (['f', 'r', 'e', 's', 'h', 'V', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'A',
         'd', 'd', 'i', 't', 'i', 'o', 'n'],
        tuple4
          ['f', 'r', 'e', 's', 'h', 'V', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'A',
            'd', 'd', 'i', 't', 'i', 'o', 'n']
          variable_parser lIA_type_parser
          (many ['a', 'd', 'd', 'i', 't', 'i', 'o', 'n', 'a', 'l', 'F', 'o',
                  'r', 'm', 'u', 'l', 'a', 's']
            (pair ['a', 'd', 'd', 'i', 't', 'i', 'o', 'n', 'a', 'l', 'F', 'o',
                    'r', 'm', 'u', 'l', 'a']
              trans_id_parser (formula_parser tatom_parser) (\ a b -> (a, b)))
            id)
          (cooperation_proof_parser location_parser trans_id_parser exp_parser
            atom_parser tatom_parser transition_parser variable_parser
            hint_parser)
          (\ x1 x2 x3 ->
            Fresh_Variable_Addition (Fresh_Variable_Addition_Info x1 x2 x3))),
      (['c', 'u', 't', 'T', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', 'S',
         'p', 'l', 'i', 't'],
        many ['c', 'u', 't', 'T', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n',
               'S', 'p', 'l', 'i', 't']
          (pair ['c', 'u', 't', 'T', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o',
                  'n', 's', 'W', 'i', 't', 'h', 'P', 'r', 'o', 'o', 'f']
            (many ['c', 'u', 't', 'T', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o',
                    'n', 's']
              trans_id_parser id)
            (cooperation_proof_parser location_parser trans_id_parser exp_parser
              atom_parser tatom_parser transition_parser variable_parser
              hint_parser)
            (\ a b -> (a, b)))
          Cut_Transition_Split),
      (['s', 'c', 'c', 'D', 'e', 'c', 'o', 'm', 'p', 'o', 's', 'i', 't', 'i',
         'o', 'n'],
        many ['s', 'c', 'c', 'D', 'e', 'c', 'o', 'm', 'p', 'o', 's', 'i', 't',
               'i', 'o', 'n']
          (pair ['s', 'c', 'c', 'W', 'i', 't', 'h', 'P', 'r', 'o', 'o', 'f']
            (many ['s', 'c', 'c'] location_parser id)
            (cooperation_proof_parser location_parser trans_id_parser exp_parser
              atom_parser tatom_parser transition_parser variable_parser
              hint_parser)
            (\ a b -> (a, b)))
          Scc_Decomp)]
    xml;

cut_points_to_transitions ::
  forall a b c d e.
    [(Sharp a, Transition_rule b c d (Sharp e))] ->
      [(e, (a, Formula (Term b (Trans_var c, d))))] ->
        [(Sharp a, Transition_rule b c d (Sharp e))];
cut_points_to_transitions ts [] = ts;
cut_points_to_transitions ts ((l, (tr, phi)) : cps) =
  cut_points_to_transitions ((Flat tr, Transition (Flat l) (Sharp l) phi) : ts)
    cps;

parse_cutPoints ::
  forall a b c.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      ([Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] b) ->
        (Xml ->
          Sum_bot [Prelude.Char]
            (Formula (Term LIA_op (Trans_var c, LIA_type)))) ->
          Xml ->
            Sum_bot [Prelude.Char]
              [(Sharp b, Transition_rule LIA_op c LIA_type (Sharp a))];
parse_cutPoints location_parser trans_id_parser tatom_parser =
  many ['c', 'u', 't', 'P', 'o', 'i', 'n', 't', 's']
    (triple ['c', 'u', 't', 'P', 'o', 'i', 'n', 't'] location_parser
      (trans_id_parser ['s', 'k', 'i', 'p', 'I', 'd'])
      (singleton ['s', 'k', 'i', 'p', 'F', 'o', 'r', 'm', 'u', 'l', 'a']
        (formula_parser tatom_parser) id)
      (\ x y z -> (x, (y, z))))
    (cut_points_to_transitions []);

termination_proof_parser ::
  forall a b c.
    (Compare a,
      Compare b) => (Xml -> Sum_bot [Prelude.Char] a) ->
                      (Xml -> Sum_bot [Prelude.Char] (Sharp a)) ->
                        ([Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] b) ->
                          (Xml -> Sum_bot [Prelude.Char] (Sharp b)) ->
                            (Xml ->
                              Sum_bot [Prelude.Char]
                                (Term LIA_op (c, LIA_type))) ->
                              (Xml ->
                                Sum_bot [Prelude.Char]
                                  (Formula (Term LIA_op (c, LIA_type)))) ->
                                (Xml ->
                                  Sum_bot [Prelude.Char]
                                    (Formula
                                      (Term LIA_op (Trans_var c, LIA_type)))) ->
                                  (Xml -> Sum_bot [Prelude.Char] c) ->
                                    (Xml -> Sum_bot [Prelude.Char] Lia_hints) ->
                                      Xml ->
Sum_bot [Prelude.Char]
  (Termination_proof LIA_op c LIA_type LIA_value a b Lia_hints);
termination_proof_parser location_parser sharp_location_parser trans_id_parser
  sharp_trans_id_parser exp_parser atom_parser tatom_parser variable_parser
  hint_parser xml =
  options
    [(['t', 'r', 'i', 'v', 'i', 'a', 'l'],
       leaf ['t', 'r', 'i', 'v', 'i', 'a', 'l'] Triviala),
      (['s', 'w', 'i', 't', 'c', 'h', 'T', 'o', 'C', 'o', 'o', 'p', 'e', 'r',
         'a', 't', 'i', 'o', 'n', 'T', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i',
         'o', 'n'],
        pair ['s', 'w', 'i', 't', 'c', 'h', 'T', 'o', 'C', 'o', 'o', 'p', 'e',
               'r', 'a', 't', 'i', 'o', 'n', 'T', 'e', 'r', 'm', 'i', 'n', 'a',
               't', 'i', 'o', 'n']
          (parse_cutPoints location_parser trans_id_parser tatom_parser)
          (cooperation_proof_parser sharp_location_parser sharp_trans_id_parser
            exp_parser atom_parser tatom_parser
            (transition_parser sharp_location_parser sharp_trans_id_parser
              tatom_parser)
            variable_parser hint_parser)
          (\ cp p -> Via_Cooperation [(cp, p)]))]
    xml;

parse_sharp_trans_id :: Xml -> Sum_bot [Prelude.Char] (Sharp [Prelude.Char]);
parse_sharp_trans_id =
  xml_enter_options
    [(['t', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', 'I', 'd'],
       xml_take_text (xml_leave . Flat)),
      (['t', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', 'D', 'u', 'p', 'l',
         'i', 'c', 'a', 't', 'e'],
        xml_take_text (xml_leave . Sharp))];

parse_sharp_location :: Xml -> Sum_bot [Prelude.Char] (Sharp [Prelude.Char]);
parse_sharp_location =
  xml_enter_options
    [(['l', 'o', 'c', 'a', 't', 'i', 'o', 'n', 'I', 'd'],
       xml_take_text (xml_leave . Flat)),
      (['l', 'o', 'c', 'a', 't', 'i', 'o', 'n', 'D', 'u', 'p', 'l', 'i', 'c',
         'a', 't', 'e'],
        xml_take_text (xml_leave . Sharp))];

lin_atom_parser ::
  forall a.
    (Showa a) => (Xml -> Sum_bot [Prelude.Char] a) ->
                   Xml ->
                     Sum_bot [Prelude.Char]
                       (Formula (Term LIA_op (a, LIA_type)));
lin_atom_parser v =
  options
    [(['l', 'e', 'q'],
       xml1to2elements ['l', 'e', 'q'] (lin_exp_parser v) (lin_exp_parser v)
         (\ l r ->
           Atom (Fun Lesseq [l, (case r of {
                                  Nothing -> Fun (Const zero_int) [];
                                  Just ra -> ra;
                                })]))),
      (['l', 'e', 's', 's'],
        pair ['l', 'e', 's', 's'] (lin_exp_parser v) (lin_exp_parser v)
          (\ l r -> Atom (Fun Less [l, r]))),
      (['e', 'q'],
        pair ['e', 'q'] (lin_exp_parser v) (lin_exp_parser v)
          (\ l r ->
            Conjunctiona
              [Atom (Fun Lesseq [l, r]), Atom (Fun Lesseq [r, l])]))];

lIA_tatom_parser ::
  Xml ->
    Sum_bot [Prelude.Char]
      (Formula (Term LIA_op (Trans_var [Prelude.Char], LIA_type)));
lIA_tatom_parser = lin_atom_parser parse_trans_var;

lIA_atom_parser ::
  Xml ->
    Sum_bot [Prelude.Char] (Formula (Term LIA_op ([Prelude.Char], LIA_type)));
lIA_atom_parser = lin_atom_parser parse_variable_id;

lIA_exp_parser ::
  Xml -> Sum_bot [Prelude.Char] (Term LIA_op ([Prelude.Char], LIA_type));
lIA_exp_parser = lin_exp_parser parse_variable_id;

constant_parser :: Xml -> Sum_bot [Prelude.Char] Int;
constant_parser = int ['c', 'o', 'n', 's', 't', 'a', 'n', 't'];

lIA_hint_parser :: Xml -> Sum_bot [Prelude.Char] Lia_hints;
lIA_hint_parser =
  singleton
    ['l', 'i', 'n', 'e', 'a', 'r', 'I', 'm', 'p', 'l', 'i', 'c', 'a', 't', 'i',
      'o', 'n', 'H', 'i', 'n', 't']
    (options
      [(['l', 'i', 'n', 'e', 'a', 'r', 'C', 'o', 'm', 'b', 'i', 'n', 'a', 't',
          'i', 'o', 'n'],
         many ['l', 'i', 'n', 'e', 'a', 'r', 'C', 'o', 'm', 'b', 'i', 'n', 'a',
                't', 'i', 'o', 'n']
           constant_parser (\ xs -> LIA_Hints (map nat xs))),
        (['s', 'i', 'm', 'p', 'l', 'e', 'x'],
          leaf ['s', 'i', 'm', 'p', 'l', 'e', 'x'] LIA_Simplex)])
    id;

xmldoc_termination_cert_problem ::
  Xmldoc ->
    Sum_bot [Prelude.Char]
      (Termination_cert_problem LIA_op [Prelude.Char] LIA_type LIA_value
        [Prelude.Char] [Prelude.Char] Lia_hints);
xmldoc_termination_cert_problem (XMLDOC header xml) =
  pair ['c', 'e', 'r', 't', 'i', 'f', 'i', 'c', 'a', 't', 'e']
    (lts_parser ['i', 'n', 'p', 'u', 't', 'P', 'r', 'o', 'g', 'r', 'a', 'm']
      parse_location_id parse_trans_id lIA_tatom_parser)
    (termination_proof_parser parse_location_id parse_sharp_location text
      parse_sharp_trans_id lIA_exp_parser lIA_atom_parser lIA_tatom_parser
      parse_variable_id lIA_hint_parser)
    Termination_Cert_Problem (drop_xml_attributes xml);

def_checker_main ::
  forall a.
    (Eq a) => a -> LIA_type ->
                     Term LIA_op (a, LIA_type) ->
                       Term LIA_op (a, LIA_type) ->
                         Term LIA_op (a, LIA_type) ->
                           Term LIA_op (a, LIA_type) -> Bool;
def_checker_main x ty l1 r1 l2 r2 =
  is_bool lia (Fun Lesseq [l1, r1]) &&
    type_of lia r1 == Just ty &&
      is_bool lia (Fun Lesseq [l2, r2]) &&
        equal_term (Var (x, ty)) l1 &&
          equal_term l1 r2 &&
            equal_term l2 r1 && not (contains_var_term (x, ty) r1);

show_LIA_exp ::
  forall a b.
    (Showa a) => Term LIA_op (a, b) -> [Prelude.Char] -> [Prelude.Char];
show_LIA_exp (Var (x, ty)) = shows_prec zero_nat x;
show_LIA_exp (Fun (Const n) []) = shows_prec_int zero_nat n;
show_LIA_exp (Fun (Cmult n) [Var (x, ty)]) =
  (shows_prec_int zero_nat n . shows_prec_list zero_nat [' ', '*', ' ']) .
    shows_paren (shows_prec zero_nat x);
show_LIA_exp (Fun Less [s, t]) =
  (show_LIA_exp s . shows_prec_list zero_nat [' ', '<', ' ']) . show_LIA_exp t;
show_LIA_exp (Fun Lesseq [s, t]) =
  (show_LIA_exp s . shows_prec_list zero_nat [' ', '<', '=', ' ']) .
    show_LIA_exp t;
show_LIA_exp (Fun Sum [s, t]) =
  (show_LIA_exp s . shows_prec_list zero_nat [' ', '+', ' ']) . show_LIA_exp t;
show_LIA_exp (Fun Less []) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun Less [v]) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun Less (v : vc : ve : vf)) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun Lesseq []) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun Lesseq [v]) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun Lesseq (v : vc : ve : vf)) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun Sum []) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun Sum [v]) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun Sum (v : vc : ve : vf)) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun (Cmult vb) []) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun (Cmult vb) (Fun vd ve : vc)) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun (Cmult vb) (v : vd : ve)) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun (Const va) (vb : vc)) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun v [Fun va vd]) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun v (Fun va vd : vb : vf : vg)) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];
show_LIA_exp (Fun v (vb : va : vc : ve)) =
  shows_prec_list zero_nat
    ['<', '<', ' ', 'u', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'L',
      'I', 'A', ' ', 'e', 'x', 'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ' ', '>',
      '>'];

def_checker ::
  forall a.
    (Eq a,
      Showa a) => a -> LIA_type ->
                         Formula (Term LIA_op (a, LIA_type)) ->
                           Sum ([Prelude.Char] -> [Prelude.Char]) ();
def_checker x ty phi =
  catch_errora
    (case phi of {
      Atom _ ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', 'f', 'o', 'r', 'm', 'u',
                'l', 'a']);
      NegAtom _ ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', 'f', 'o', 'r', 'm', 'u',
                'l', 'a']);
      Conjunctiona [] -> Inr ();
      Conjunctiona [_] ->
        Inl (shows_prec_list zero_nat
              ['C', 'o', 'n', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n', ' ', 'o',
                'f', ' ', 'm', 'o', 'r', 'e', ' ', 't', 'h', 'a', 'n', ' ', 't',
                'w', 'o']);
      Conjunctiona [Atom (Var _), _] ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '1', 's', 't', ' ', 'l',
                'i', 't', 'e', 'r', 'a', 'l']);
      Conjunctiona [Atom (Fun Less _), _] ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '1', 's', 't', ' ', 'l',
                'i', 't', 'e', 'r', 'a', 'l']);
      Conjunctiona [Atom (Fun Lesseq []), _] ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '1', 's', 't', ' ', 'l',
                'i', 't', 'e', 'r', 'a', 'l']);
      Conjunctiona [Atom (Fun Lesseq [_]), _] ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '1', 's', 't', ' ', 'l',
                'i', 't', 'e', 'r', 'a', 'l']);
      Conjunctiona [Atom (Fun Lesseq [l1, r1]), lt2] ->
        (case lt2 of {
          Atom (Var _) ->
            Inl (shows_prec_list zero_nat
                  ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '2', 'n', 'd', ' ',
                    'l', 'i', 't', 'e', 'r', 'a', 'l']);
          Atom (Fun Less _) ->
            Inl (shows_prec_list zero_nat
                  ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '2', 'n', 'd', ' ',
                    'l', 'i', 't', 'e', 'r', 'a', 'l']);
          Atom (Fun Lesseq []) ->
            Inl (shows_prec_list zero_nat
                  ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '2', 'n', 'd', ' ',
                    'l', 'i', 't', 'e', 'r', 'a', 'l']);
          Atom (Fun Lesseq [_]) ->
            Inl (shows_prec_list zero_nat
                  ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '2', 'n', 'd', ' ',
                    'l', 'i', 't', 'e', 'r', 'a', 'l']);
          Atom (Fun Lesseq [l2, r2]) ->
            check (def_checker_main x ty l1 r1 l2 r2 ||
                    def_checker_main x ty l2 r2 l1 r1)
              (shows_prec_list zero_nat
                ['N', 'o', 'n', '-', 'e', 'q', 'u', 'a', 't', 'i', 'o', 'n',
                  ' ', 'n', 'o', 't', ' ', 's', 'u', 'p', 'p', 'o', 'r', 't',
                  'e', 'd']);
          Atom (Fun Lesseq (_ : _ : _ : _)) ->
            Inl (shows_prec_list zero_nat
                  ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '2', 'n', 'd', ' ',
                    'l', 'i', 't', 'e', 'r', 'a', 'l']);
          Atom (Fun Sum _) ->
            Inl (shows_prec_list zero_nat
                  ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '2', 'n', 'd', ' ',
                    'l', 'i', 't', 'e', 'r', 'a', 'l']);
          Atom (Fun (Const _) _) ->
            Inl (shows_prec_list zero_nat
                  ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '2', 'n', 'd', ' ',
                    'l', 'i', 't', 'e', 'r', 'a', 'l']);
          Atom (Fun (Cmult _) _) ->
            Inl (shows_prec_list zero_nat
                  ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '2', 'n', 'd', ' ',
                    'l', 'i', 't', 'e', 'r', 'a', 'l']);
          NegAtom _ ->
            Inl (shows_prec_list zero_nat
                  ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '2', 'n', 'd', ' ',
                    'c', 'l', 'a', 'u', 's', 'e']);
          Conjunctiona _ ->
            Inl (shows_prec_list zero_nat
                  ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '2', 'n', 'd', ' ',
                    'c', 'l', 'a', 'u', 's', 'e']);
          Disjunction _ ->
            Inl (shows_prec_list zero_nat
                  ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '2', 'n', 'd', ' ',
                    'c', 'l', 'a', 'u', 's', 'e']);
        });
      Conjunctiona [Atom (Fun Lesseq (_ : _ : _ : _)), _] ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '1', 's', 't', ' ', 'l',
                'i', 't', 'e', 'r', 'a', 'l']);
      Conjunctiona [Atom (Fun Sum _), _] ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '1', 's', 't', ' ', 'l',
                'i', 't', 'e', 'r', 'a', 'l']);
      Conjunctiona [Atom (Fun (Const _) _), _] ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '1', 's', 't', ' ', 'l',
                'i', 't', 'e', 'r', 'a', 'l']);
      Conjunctiona [Atom (Fun (Cmult _) _), _] ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '1', 's', 't', ' ', 'l',
                'i', 't', 'e', 'r', 'a', 'l']);
      Conjunctiona [NegAtom _, _] ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '1', 's', 't', ' ', 'c',
                'l', 'a', 'u', 's', 'e']);
      Conjunctiona [Conjunctiona _, _] ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '1', 's', 't', ' ', 'c',
                'l', 'a', 'u', 's', 'e']);
      Conjunctiona [Disjunction _, _] ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', '1', 's', 't', ' ', 'c',
                'l', 'a', 'u', 's', 'e']);
      Conjunctiona (_ : _ : _ : _) ->
        Inl (shows_prec_list zero_nat
              ['C', 'o', 'n', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n', ' ', 'o',
                'f', ' ', 'm', 'o', 'r', 'e', ' ', 't', 'h', 'a', 'n', ' ', 't',
                'w', 'o']);
      Disjunction _ ->
        Inl (shows_prec_list zero_nat
              ['I', 'n', 'v', 'a', 'l', 'i', 'd', ' ', 'f', 'o', 'r', 'm', 'u',
                'l', 'a']);
    })
    (\ xa ->
      Inl (((((shows_prec_list zero_nat
                 ['e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 'd', 'e', 'f',
                   'i', 'n', 'i', 'b', 'i', 'l', 'i', 't', 'y', ' ', 'c', 'h',
                   'e', 'c', 'k', 'e', 'r', ' ', 'f', 'o', 'r', ' '] .
                shows_prec zero_nat x) .
               shows_prec_list zero_nat
                 [' ', 'o', 'n', ' ', 'f', 'o', 'r', 'm', 'u', 'l', 'a', '\n',
                   ' ', ' ']) .
              shows_formula show_LIA_exp phi) .
             shows_nl) .
            xa));

check_valid_formula ::
  forall a b c d.
    (Default a, Showa a, Showa b, Showa c,
      Showa d) => (a -> Formula (Term b (c, d)) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                    (Term b (c, d) -> [Prelude.Char] -> [Prelude.Char]) ->
                      Formula (Term b (c, d)) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_valid_formula logic_checker shows_atom phi =
  catch_errora
    (let {
       (Conjunctiona phi_s) = flatten phi;
     } in catch_errora (forallM (logic_checker defaulta) phi_s)
            (\ x -> Inl (snd x)))
    (\ x ->
      Inl (((shows_prec_list zero_nat
               ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'c', 'h',
                 'e', 'c', 'k', 'i', 'n', 'g', ' ', 'v', 'a', 'l', 'i', 'd',
                 'i', 't', 'y', ' ', 'o', 'f', ' ', 'f', 'o', 'r', 'm', 'u',
                 'l', 'a', ' '] .
              shows_formula shows_atom phi) .
             shows_nl) .
            x));

check_skip_transition ::
  forall a b c d e.
    (Default a, Showa a, Showa b, Showa c,
      Showa d) => (a -> Formula (Term b (c, d)) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                    (Term b (c, d) -> [Prelude.Char] -> [Prelude.Char]) ->
                      Transition_rule b c d e ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_skip_transition logic_checker shows_atom tau =
  let {
    (Transition _ _ phi) = tau;
  } in check_valid_formula logic_checker shows_atom
         (map_formula (rename_vars_exp untrans_var) phi);

check_exists_cut ::
  forall a b c d e.
    (Default a, Showa a, Showa b, Showa c, Showa d, Eq e,
      Showa e) => (a -> Formula (Term b (c, d)) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                    (Term b (c, d) -> [Prelude.Char] -> [Prelude.Char]) ->
                      [Transition_rule b c d (Sharp e)] ->
                        e -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_exists_cut logic_checker shows_atom taus n =
  check (any (\ tau ->
               equal_sharp (source tau) (Flat n) &&
                 equal_sharp (target tau) (Sharp n) &&
                   isOK (check_skip_transition logic_checker shows_atom tau))
          taus)
    (shows_prec_list zero_nat
      (['m', 'i', 's', 's', 'i', 'n', 'g', ' ', 's', 'k', 'i', 'p', ' ', 't',
         'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', ' ', 'f', 'o', 'r',
         ' '] ++
        shows_prec zero_nat n []));

make_copy_prog ::
  forall a b c d e.
    Lts_impl a b c d e ->
      [(Sharp e, Transition_rule a b c (Sharp d))] ->
        Lts_impl a b c (Sharp d) (Sharp e);
make_copy_prog (Lts_Impl init tau_s lc) cutpoints =
  Lts_Impl (Flat init)
    (map (\ (tr, tau) -> (Flat tr, flat_transition tau)) tau_s ++
      cutpoints ++ map (\ (tr, tau) -> (Sharp tr, sharp_transition tau)) tau_s)
    (map (\ (tr, a) -> (Flat tr, a)) lc ++ map (\ (tr, a) -> (Sharp tr, a)) lc);

create_initial_cp_prog ::
  forall a b c d e f g.
    (Showa a, Eq b, Showa b, Default d, Showa d, Showa e, Eq f, Key f, Showa f,
      Showa g) => Logic_ext a b c () ->
                    (d -> Formula (Term a (e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (Term a (e, b) -> [Prelude.Char] -> [Prelude.Char]) ->
                        Lts_impl a e b f g ->
                          [[(Sharp g, Transition_rule a e b (Sharp f))]] ->
                            Sum ([Prelude.Char] -> [Prelude.Char])
                              [Lts_impl a e b (Sharp f) (Sharp g)];
create_initial_cp_prog lambda logic_checker shows_atom p cp_trans_list =
  (case let {
          cp_trans = concat cp_trans_list;
          cut_points =
            remdups (map (\ (_, tau) -> natural (source tau)) cp_trans);
        } in bindb (catch_errora
                     (check_cut_points (call_graph_impl p) (Set cut_points))
                     (\ x ->
                       Inl (shows_prec_list zero_nat
                              ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n',
                                ' ', 'e', 'n', 's', 'u', 'r', 'i', 'n', 'g',
                                ' ', 'v', 'a', 'l', 'i', 'd', 'i', 't', 'y',
                                ' ', 'o', 'f', ' ', 'c', 'u', 't', 'p', 'o',
                                'i', 'n', 't', 's', '\n'] .
                             x)))
               (\ _ ->
                 bindb (check (null (assertion_impl p))
                         (shows_prec_list zero_nat
                           ['T', 'O', 'D', 'O', ':', ' ', 'c', 'u', 'r', 'r',
                             'e', 'n', 't', 'l', 'y', ' ', 'l', 'o', 'c', 'a',
                             't', 'i', 'o', 'n', ' ', 'c', 'o', 'n', 'd', 'i',
                             't', 'i', 'o', 'n', 's', ' ', 'a', 'r', 'e', ' ',
                             'u', 'n', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e',
                             'd', ' ', 'w', 'h', 'e', 'n', ' ', 'c', 'r', 'e',
                             'a', 't', 'i', 'n', 'g', ' ', 'i', 'n', 'i', 't',
                             'i', 'a', 'l', ' ', 'c', 'o', 'o', 'p', 'e', 'r',
                             'a', 't', 'i', 'o', 'n', ' ', 'p', 'r', 'o', 'b',
                             'l', 'e', 'm']))
                   (\ _ ->
                     bindb (catch_errora
                             (forallM
                               (\ (n, cp) ->
                                 check (transition_rule lambda cp)
                                   (shows_prec_sharp zero_nat n .
                                     shows_prec_list zero_nat
                                       [' ', 'i', 's', ' ', 'n', 'o', 'n', ' ',
 'v', 'a', 'l', 'i', 'd', ' ', 't', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n',
 ' ', 'r', 'u', 'l', 'e']))
                               cp_trans)
                             (\ x -> Inl (snd x)))
                       (\ _ ->
                         catch_errora
                           (forallM
                             (check_exists_cut logic_checker shows_atom
                               (map snd cp_trans))
                             cut_points)
                           (\ x -> Inl (snd x)))))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (map (make_copy_prog p) cp_trans_list);
  });

fresh_variable_checker ::
  forall a b c d e f.
    (Showa a, Eq b, Showa b, Eq d, Showa d, Showa e,
      Showa f) => Logic_ext a b c () ->
                    (Trans_var d ->
                      b -> Formula (Term a (Trans_var d, b)) ->
                             Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (Term a (Trans_var d, b) ->
                        [Prelude.Char] -> [Prelude.Char]) ->
                        Lts_impl a d b e f ->
                          (f -> Formula (Term a (Trans_var d, b))) ->
                            d -> b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
fresh_variable_checker lambda def_checker sa2 p f x ty =
  catch_errora
    (bindb
      (catch_errora
        (forallM
          (\ (l, fa) ->
            check (not (member (x, ty) (vars_formula fa)))
              ((shows_prec zero_nat x .
                 shows_prec_list zero_nat
                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'f', 'r', 'e', 's',
                     'h', ',', ' ', 'i', 't', ' ', 'o', 'c', 'c', 'u', 'r', 's',
                     ' ', 'i', 'n', ' ', 'l', 'o', 'c', 'a', 't', 'i', 'o', 'n',
                     ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', ' ', 'o',
                     'f', ' ']) .
                shows_prec zero_nat l))
          (assertion_impl p))
        (\ xa -> Inl (snd xa)))
      (\ _ ->
        catch_errora
          (forallM
            (\ (tr, tau) ->
              let {
                psi = f tr;
              } in bindb (check (formula (is_bool lambda) psi)
                           (shows_prec_list zero_nat
                             ['n', 'e', 'w', ' ', 't', 'r', 'a', 'n', 's', 'i',
                               't', 'i', 'o', 'n', ' ', 'f', 'o', 'r', 'm', 'u',
                               'l', 'a', ' ', 's', 'e', 'e', 'm', 's', ' ', 't',
                               'o', ' ', 'b', 'e', ' ', 'n', 'o', 't', ' ', 'w',
                               'e', 'l', 'l', '-', 'f', 'o', 'r', 'm', 'e',
                               'd']))
                     (\ _ ->
                       catch_errora
                         (let {
                            (Transition _ _ phi) = tau;
                          } in bindb (def_checker (Post x) ty psi)
                                 (\ _ ->
                                   bindb (check
   (not (member (Post x, ty) (vars_formula phi)))
   (shows_prec_list zero_nat
      ['P', 'o', 's', 't', ' ', 'x', ' ', 'i', 'n', ' ', 't', 'r', 'a', 'n',
        's', 'i', 't', 'i', 'o', 'n', ' ', 'f', 'o', 'r', 'm', 'u', 'l', 'a'] .
     shows_formula sa2 phi))
                                     (\ _ ->
                                       check
 (not (member (Pre x, ty) (vars_formula phi)))
 (shows_prec_list zero_nat
    ['P', 'r', 'e', ' ', 'x', ' ', 'i', 'n', ' ', 't', 'r', 'a', 'n', 's', 'i',
      't', 'i', 'o', 'n', ' ', 'f', 'o', 'r', 'm', 'u', 'l', 'a'] .
   shows_formula sa2 phi))))
                         (\ xa ->
                           Inl (((shows_prec_list zero_nat
                                    ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
                                      'i', 'n', ' ', 't', 'r', 'a', 'n', 's',
                                      'i', 't', 'i', 'o', 'n', ' ', 'f', 'o',
                                      'r', 'm', 'u', 'l', 'a', ' ', 'o', 'f',
                                      ' ', 't', 'r', 'a', 'n', 's', 'i', 't',
                                      'i', 'o', 'n', ' '] .
                                   shows_prec zero_nat tr) .
                                  shows_nl) .
                                 xa))))
            (transitions_impl p))
          (\ xa -> Inl (snd xa))))
    (\ xa ->
      Inl (shows_prec_list zero_nat
             ['f', 'r', 'e', 's', 'h', '_', 'v', 'a', 'r', 'i', 'a', 'b', 'l',
               'e', '_', 'c', 'h', 'e', 'c', 'k', 'e', 'r', ' ', 'f', 'a', 'i',
               'l', 'e', 'd', '\n'] .
            xa));

shows_prec_formula ::
  forall a. (Showa a) => Nat -> Formula a -> [Prelude.Char] -> [Prelude.Char];
shows_prec_formula = showsp_formula shows_prec;

refine_transition_formulas ::
  forall a b c d e.
    Lts_impl a b c d e ->
      (e -> Formula (Term a (Trans_var b, c))) -> Lts_impl a b c d e;
refine_transition_formulas p f =
  Lts_Impl (initiala p)
    (map (\ (tr, tau) -> (tr, refine_transition_formula tau (f tr)))
      (transitions_impl p))
    (assertion_impl p);

fresh_variable_addition ::
  forall a b c d e f.
    (Showa a, Eq b, Showa b, Eq d, Showa d, Showa e, Compare_order f,
      Showa f) => Logic_ext a b c () ->
                    (Trans_var d ->
                      b -> Formula (Term a (Trans_var d, b)) ->
                             Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (Term a (Trans_var d, b) ->
                        [Prelude.Char] -> [Prelude.Char]) ->
                        Lts_impl a d b e f ->
                          Fresh_variable_addition_info a d b f ->
                            Sum ([Prelude.Char] -> [Prelude.Char])
                              (Lts_impl a d b e f);
fresh_variable_addition lambda def_checker sa2 p
  (Fresh_Variable_Addition_Info x ty forms) =
  let {
    m = of_alist forms;
    f = lookup_default (Conjunctiona []) m;
  } in (case catch_errora
               (bindb
                 (catch_errora
                   (forallM
                     (\ fa ->
                       check (formula (is_bool lambda) fa)
                         (shows_prec_formula zero_nat fa .
                           shows_prec_list zero_nat
                             [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ',
                               'v', 'a', 'l', 'i', 'd', ' ', 'f', 'o', 'r', 'm',
                               'u', 'l', 'a']))
                     (map snd forms))
                   (\ xa -> Inl (snd xa)))
                 (\ _ ->
                   fresh_variable_checker lambda def_checker sa2 p f x ty))
               (\ xa ->
                 Inl (((shows_prec_list zero_nat
                          ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n',
                            ' ', 'a', 'd', 'd', 'i', 'n', 'g', ' ', 'f', 'r',
                            'e', 's', 'h', ' ', 'v', 'a', 'r', 'i', 'a', 'b',
                            'l', 'e', ' '] .
                         shows_prec zero_nat x) .
                        shows_nl) .
                       xa))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (refine_transition_formulas p f);
       });

check_formula_hint ::
  forall a b c d.
    (Default a, Showa a, Showa b, Showa c,
      Showa d) => (a -> Formula (Term b (c, d)) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                    (Term b (c, d) -> [Prelude.Char] -> [Prelude.Char]) ->
                      Hint a ->
                        Formula (Term b (c, d)) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_formula_hint logic_checker shows_atom (Conjunction hints) phi =
  (case phi of {
    Atom _ ->
      Inl (shows_prec_list zero_nat
             ['C', 'o', 'n', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n', ' ', 'h',
               'i', 'n', 't', ' ', 'f', 'o', 'r', ' ', 'n', 'o', 'n', ' ', 'C',
               'o', 'n', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n', ' '] .
            shows_formula shows_atom phi);
    NegAtom _ ->
      Inl (shows_prec_list zero_nat
             ['C', 'o', 'n', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n', ' ', 'h',
               'i', 'n', 't', ' ', 'f', 'o', 'r', ' ', 'n', 'o', 'n', ' ', 'C',
               'o', 'n', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n', ' '] .
            shows_formula shows_atom phi);
    Conjunctiona a -> check_formula_hint2 logic_checker shows_atom hints a;
    Disjunction _ ->
      Inl (shows_prec_list zero_nat
             ['C', 'o', 'n', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n', ' ', 'h',
               'i', 'n', 't', ' ', 'f', 'o', 'r', ' ', 'n', 'o', 'n', ' ', 'C',
               'o', 'n', 'j', 'u', 'n', 'c', 't', 'i', 'o', 'n', ' '] .
            shows_formula shows_atom phi);
  });
check_formula_hint logic_checker shows_atom (Base h) phi =
  bindb (check (is_clause phi)
          (shows_prec_list zero_nat
            ['o', 'n', 'l', 'y', ' ', 'c', 'l', 'a', 'u', 's', 'e', 's', ' ',
              'm', 'a', 'y', ' ', 'b', 'e', ' ', 'p', 'a', 's', 's', 'e', 'd',
              ' ', 't', 'o', ' ', 'l', 'o', 'g', 'i', 'c', ' ', 'c', 'h', 'e',
              'c', 'k', 'e', 'r', ' ', 'i', 'n', ' ', 'c', 'h', 'e', 'c', 'k',
              '_', 'f', 'o', 'r', 'm', 'u', 'l', 'a', '_', 'h', 'i', 'n', 't']))
    (\ _ ->
      catch_errora (logic_checker h phi)
        (\ x ->
          Inl (((shows_prec_list zero_nat
                   ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'c',
                     'h', 'e', 'c', 'k', 'i', 'n', 'g', ' '] .
                  shows_formula shows_atom phi) .
                 shows_nl) .
                x)));
check_formula_hint logic_checker shows_atom Default phi =
  check_valid_formula logic_checker shows_atom phi;

check_formula_hint2 ::
  forall a b c d.
    (Default a, Showa a, Showa b, Showa c,
      Showa d) => (a -> Formula (Term b (c, d)) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                    (Term b (c, d) -> [Prelude.Char] -> [Prelude.Char]) ->
                      [Hint a] ->
                        [Formula (Term b (c, d))] ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_formula_hint2 logic_checker shows_atom [] (v : va) =
  Inl (shows_prec_list zero_nat
        ['L', 'e', 'n', 'g', 't', 'h', ' ', 'm', 'i', 's', 'm', 'a', 't', 'c',
          'h', ' ', 'i', 'n', ' ', 'C', 'o', 'n', 'j', 'u', 'n', 'c', 't', 'i',
          'o', 'n', ' ', 'h', 'i', 'n', 't', 's']);
check_formula_hint2 logic_checker shows_atom (v : va) [] =
  Inl (shows_prec_list zero_nat
        ['L', 'e', 'n', 'g', 't', 'h', ' ', 'm', 'i', 's', 'm', 'a', 't', 'c',
          'h', ' ', 'i', 'n', ' ', 'C', 'o', 'n', 'j', 'u', 'n', 'c', 't', 'i',
          'o', 'n', ' ', 'h', 'i', 'n', 't', 's']);
check_formula_hint2 logic_checker shows_atom (h : hs) (phi : phi_s) =
  bindb (check_formula_hint logic_checker shows_atom h phi)
    (\ _ -> check_formula_hint2 logic_checker shows_atom hs phi_s);
check_formula_hint2 logic_checker shows_atom [] [] = Inr ();

transition_hintsa :: forall a b c d e. Hinter_ext a b c d e -> c -> Maybe [a];
transition_hintsa
  (Hinter_ext nodes succ_trans_list cover_hints transition_hints more) =
  transition_hints;

check_children_edges_cond ::
  forall a b c d e f.
    (Default a, Showa a, Showa b, Showa c, Showa d, Showa e,
      Showa f) => (a -> Formula (Term b (Trans_var c, d)) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                    (Term b (Trans_var c, d) ->
                      [Prelude.Char] -> [Prelude.Char]) ->
                      Lts_ext b c d e () ->
                        Art_ext b c d e f () ->
                          Hinter_ext (Hint a) e f (Transition_rule b c d e)
                            () ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_children_edges_cond tc2 sa2 p a h =
  let {
    lc = assertion p;
  } in catch_errora
         (catch_errora
           (forallM
             (\ aa ->
               (case edge a aa of {
                 Cover _ -> Inr ();
                 Children children ->
                   (case transition_hintsa h aa of {
                     Nothing ->
                       Inl (shows_prec_list zero_nat
                             ['n', 'o', 't', ' ', 'y', 'e', 't']);
                     Just hints ->
                       catch_errora
                         (bindb
                           (check
                             (equal_nat (size_list hints) (size_list children))
                             (shows_prec_list zero_nat
                               ['t', 'h', 'e', ' ', 'n', 'u', 'm', 'b', 'e',
                                 'r', ' ', 'o', 'f', ' ', 'h', 'i', 'n', 't',
                                 's', ' ', 'd', 'i', 'f', 'f', 'e', 'r', 's',
                                 ' ', 'f', 'r', 'o', 'm', ' ', 't', 'h', 'e',
                                 ' ', 'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o',
                                 'f', ' ', 'c', 'h', 'i', 'l', 'd', 'r', 'e',
                                 'n']))
                           (\ _ ->
                             catch_errora
                               (forallM
                                 (\ (b, c) ->
                                   let {
                                     (tau, ba) = b;
                                   } in (\ ha ->
  let {
    (Transition l r phi) = tau;
  } in catch_errora
         (check_formula_hint tc2 sa2 ha
           (form_or
             (form_not
               (form_and
                 (form_and
                   (form_and (map_formula (rename_vars_exp Pre) (lc l))
                     (map_formula (rename_vars_exp Post) (lc r)))
                   (map_formula (rename_vars_exp Pre) (node_invariant a aa)))
                 phi))
             (map_formula (rename_vars_exp Post) (node_invariant a ba))))
         (\ x ->
           Inl ((((((((shows_prec_list zero_nat
                         ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ',
                           'c', 'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ', 'e',
                           'd', 'g', 'e', ' '] .
                        shows_prec zero_nat aa) .
                       shows_prec_list zero_nat [' ', '-', '-', '>', ' ']) .
                      shows_prec zero_nat ba) .
                     shows_prec_list zero_nat
                       [' ', 'f', 'o', 'r', ' ', 't', 'r', 'a', 'n', 's', 'i',
                         't', 'i', 'o', 'n']) .
                    shows_nl) .
                   shows_transition sa2 tau) .
                  shows_nl) .
                 x)))
                                     c)
                                 (zip children hints))
                               (\ x -> Inl (snd x))))
                         (\ x ->
                           Inl (((shows_prec_list zero_nat
                                    ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
                                      'i', 'n', ' ', 'c', 'h', 'e', 'c', 'k',
                                      'i', 'n', 'g', ' ', 't', 'r', 'a', 'n',
                                      's', 'i', 't', 'i', 'o', 'n', 's', ' ',
                                      'o', 'f', ' ', 'n', 'o', 'd', 'e', ' '] .
                                   shows_prec zero_nat aa) .
                                  shows_nl) .
                                 x));
                   });
               }))
             (nodesa h))
           (\ x -> Inl (snd x)))
         (\ x ->
           Inl (shows_prec_list zero_nat
                  ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n',
                    's', 'u', 'r', 'e', ' ', 't', 'r', 'a', 'n', 's', 'i', 't',
                    'i', 'o', 'n', ' ', 'e', 'd', 'g', 'e', ' ', 'c', 'o', 'n',
                    'd', 'i', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' ', 'A', 'R',
                    'T', '\n'] .
                 x));

is_cover_nodea :: forall a b c d e. Art_edge a b c d e -> Bool;
is_cover_nodea (Cover x1) = True;
is_cover_nodea (Children x2) = False;

check_cover_edges_cond ::
  forall a b c d e f.
    (Default a, Showa a, Showa b, Showa c, Showa d, Eq e, Showa e, Eq f,
      Showa f) => (a -> Formula (Term b (c, d)) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                    (Term b (c, d) -> [Prelude.Char] -> [Prelude.Char]) ->
                      Art_ext b c d e f () ->
                        Hinter_ext (Hint a) e f (Transition_rule b c d e) () ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_cover_edges_cond tc sa a h =
  catch_errora
    (catch_errora
      (forallM
        (\ aa ->
          (case edge a aa of {
            Cover b ->
              catch_errora
                (bindb
                  (check (membera (nodes a) b)
                    (shows_prec_list zero_nat
                      ['t', 'a', 'r', 'g', 'e', 't', ' ', 'n', 'o', 'd', 'e',
                        ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'l', 'i', 's',
                        't', 'e', 'd', ' ', 'a', 's', ' ', 'a', 'r', 't', '-',
                        'n', 'o', 'd', 'e']))
                  (\ _ ->
                    bindb (check (node_location a aa == node_location a b)
                            (shows_prec_list zero_nat
                              ['n', 'o', 'd', 'e', '-', 'l', 'o', 'c', 'a', 't',
                                'i', 'o', 'n', 's', ' ', 'd', 'i', 'f', 'f',
                                'e', 'r']))
                      (\ _ ->
                        bindb (check (not (is_cover_nodea (edge a b)))
                                (shows_prec_list zero_nat
                                  ['t', 'a', 'r', 'g', 'e', 't', ' ', 'n', 'o',
                                    'd', 'e', ' ', 'm', 'u', 's', 't', ' ', 'n',
                                    'o', 't', ' ', 'h', 'a', 'v', 'e', ' ', 'c',
                                    'o', 'v', 'e', 'r', ' ', 'e', 'd', 'g',
                                    'e']))
                          (\ _ ->
                            check_formula_hint tc sa (cover_hintsa h aa)
                              (form_or (form_not (node_invariant a aa))
                                (node_invariant a b))))))
                (\ x ->
                  Inl (((shows_prec_list zero_nat
                           ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n',
                             ' ', 'c', 'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ',
                             'c', 'o', 'v', 'e', 'r', ' ', 'e', 'd', 'g', 'e',
                             ' ', 'o', 'f', ' ', 'n', 'o', 'd', 'e', ' '] .
                          shows_prec zero_nat aa) .
                         shows_nl) .
                        x));
            Children _ -> Inr ();
          }))
        (nodesa h))
      (\ x -> Inl (snd x)))
    (\ x ->
      Inl (shows_prec_list zero_nat
             ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n', 's',
               'u', 'r', 'e', ' ', 'c', 'o', 'v', 'e', 'r', ' ', 'e', 'd', 'g',
               'e', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', ' ', 'o',
               'f', ' ', 'A', 'R', 'T', '\n'] .
            x));

equal_transition_rule ::
  forall a b c d.
    (Eq a, Eq b, Eq c,
      Eq d) => Transition_rule a b c d -> Transition_rule a b c d -> Bool;
equal_transition_rule (Transition x1 x2 x3) (Transition y1 y2 y3) =
  x1 == y1 && x2 == y2 && equal_formula x3 y3;

succ_trans_list :: forall a b c d e. Hinter_ext a b c d e -> b -> [d];
succ_trans_list
  (Hinter_ext nodes succ_trans_list cover_hints transition_hints more) =
  succ_trans_list;

check_simulation_cond ::
  forall a b c d e f.
    (Eq a, Showa a, Eq b, Showa b, Eq c, Showa c, Eq d, Showa d, Eq e, Showa e,
      Default f,
      Showa f) => Lts_ext a b c d () ->
                    Art_ext a b c d e () ->
                      Hinter_ext (Hint f) d e (Transition_rule a b c d) () ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_simulation_cond p a h =
  catch_errora
    (bindb
      (check (node_location a (initial_node a) == initial p)
        (shows_prec_list zero_nat
          ['i', 'n', 'i', 't', 'i', 'a', 'l', ' ', 'n', 'o', 'd', 'e', ' ', 'o',
            'f', ' ', 'A', 'R', 'T', ' ', 'd', 'o', 'e', 's', ' ', 'n', 'o',
            't', ' ', 'c', 'o', 'r', 'r', 'e', 's', 'p', 'o', 'n', 'd', ' ',
            't', 'o', ' ', 'i', 'n', 'i', 't', 'i', 'a', 'l', ' ', 'n', 'o',
            'd', 'e', ' ', 'o', 'f', ' ', 'p', 'r', 'o', 'g', 'r', 'a', 'm']))
      (\ _ ->
        catch_errora
          (forallM
            (\ aa ->
              (case edge a aa of {
                Cover _ -> Inr ();
                Children children ->
                  let {
                    l = node_location a aa;
                  } in catch_errora
                         (forallM
                           (\ tau ->
                             check (any (\ (taua, b) ->
  equal_transition_rule taua tau &&
    node_location a b == target tau && membera (nodes a) b)
                                     children)
                               (((((shows_prec_list zero_nat
                                      ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o',
't', ' ', 'f', 'i', 'n', 'd', ' ', 'm', 'a', 't', 'c', 'h', 'i', 'n', 'g', ' ',
't', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', ' ', 'i', 'n', ' ', 'A', 'R',
'T', ' ', 'f', 'o', 'r', ' ', 'n', 'o', 'd', 'e', ' '] .
                                     shows_prec zero_nat aa) .
                                    shows_prec_list zero_nat
                                      [' ', 'a', 'n', 'd', ' ', 't', 'r', 'a',
'n', 's', 'i', 't', 'i', 'o', 'n', ' ']) .
                                   shows_prec zero_nat (source tau)) .
                                  shows_prec_list zero_nat
                                    [' ', '-', '-', '>', ' ']) .
                                 shows_prec zero_nat (target tau)))
                           (succ_trans_list h l))
                         (\ x -> Inl (snd x));
              }))
            (nodesa h))
          (\ x -> Inl (snd x))))
    (\ x ->
      Inl (shows_prec_list zero_nat
             ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n', 's',
               'u', 'r', 'e', ' ', 's', 'i', 'm', 'u', 'l', 'a', 't', 'i', 'o',
               'n', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', ' ', 'o',
               'f', ' ', 'A', 'R', 'T', '\n'] .
            x));

check_initial_cond ::
  forall a b c d e.
    (Eq a, Showa a, Eq b, Showa b, Eq c, Showa c, Showa d, Eq e,
      Showa e) => (Term a (b, c) -> [Prelude.Char] -> [Prelude.Char]) ->
                    Art_ext a b c d e () ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_initial_cond sa a =
  let {
    init = initial_node a;
  } in bindb (check (membera (nodes a) init)
               ((shows_prec_list zero_nat
                   ['i', 'n', 'i', 't', 'i', 'a', 'l', ' ', 'n', 'o', 'd', 'e',
                     ' ', 'o', 'f', ' ', 'A', ' ', '('] .
                  shows_prec zero_nat init) .
                 shows_prec_list zero_nat
                   [')', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'm', 'e', 'n',
                     't', 'i', 'o', 'n', 'e', 'd', ' ', 'a', 's', ' ', 'n', 'o',
                     'd', 'e', ' ', 'o', 'f', ' ', 'A', 'R', 'T']))
         (\ _ ->
           check (equal_formula (node_invariant a init) (Conjunctiona []))
             (((shows_prec_list zero_nat
                  ['t', 'h', 'e', ' ', 'n', 'o', 'd', 'e', ' ', 'i', 'n', 'v',
                    'a', 'r', 'i', 'a', 'n', 't', ' ', 'f', 'o', 'r', ' ', 't',
                    'h', 'e', ' ', 'i', 'n', 'i', 't', 'i', 'a', 'l', ' ', 'A',
                    'R', 'T', ' ', 'n', 'o', 'd', 'e', ' ', '('] .
                 shows_prec zero_nat init) .
                shows_prec_list zero_nat
                  [')', ' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'T', 'R',
                    'U', 'E', ',', ' ', '\n', ' ', ' ', ' ', ' ', ' ', 'b', 'u',
                    't', ' ', 'i', 't', ' ', 'i', 's', ' ']) .
               shows_formula sa (node_invariant a init)));

check_art ::
  forall a b c d e f.
    (Eq b) => Logic_ext a b c () ->
                Art_ext a d b e f () ->
                  Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_art lambda a =
  check (art lambda a)
    (shows_prec_list zero_nat
      ['i', 'l', 'l', '-', 'f', 'o', 'r', 'm', 'e', 'd', ' ', 'i', 'n', 'v',
        'a', 'r', 'i', 'a', 'n', 't']);

check_art_invariants ::
  forall a b c d e f g.
    (Eq a, Showa a, Eq b, Showa b, Default d, Showa d, Eq e, Showa e, Eq f,
      Showa f, Eq g,
      Showa g) => Logic_ext a b c () ->
                    (d -> Formula (Term a (e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (d -> Formula (Term a (Trans_var e, b)) ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                        (Term a (e, b) -> [Prelude.Char] -> [Prelude.Char]) ->
                          (Term a (Trans_var e, b) ->
                            [Prelude.Char] -> [Prelude.Char]) ->
                            Lts_ext a e b f () ->
                              Art_ext a e b f g () ->
                                Hinter_ext (Hint d) f g
                                  (Transition_rule a e b f) () ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_art_invariants t tc tc2 sa sa2 p a h =
  catch_errora
    (bindb (check_art t a)
      (\ _ ->
        bindb (check_initial_cond sa a)
          (\ _ ->
            bindb (check_simulation_cond p a h)
              (\ _ ->
                bindb (check_cover_edges_cond tc sa a h)
                  (\ _ -> check_children_edges_cond tc2 sa2 p a h)))))
    (\ x ->
      Inl (shows_prec_list zero_nat
             ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n', 's',
               'u', 'r', 'e', ' ', 'v', 'a', 'l', 'i', 'd', 'i', 't', 'y', ' ',
               'o', 'f', ' ', 'a', 'r', 't', '-', 'g', 'r', 'a', 'p', 'h', ':',
               '\n'] .
            x));

make_hinter ::
  forall a b c d e f g h i j k l.
    (Eq d, Compare_order j, Eq j,
      Default l) => Lts_impl a b c d e ->
                      Art_impl_ext f g h i j k l () ->
                        Hinter_ext l d j (Transition_rule a b c d) ();
make_hinter pi ai =
  Hinter_ext (art_nodes ai) (succ_transitions pi) (cover_hints ai)
    (transition_hints ai) ();

check_art_invariants_impl ::
  forall a b c d e f g h.
    (Eq a, Showa a, Eq b, Showa b, Default d, Showa d, Eq e, Showa e,
      Compare_order f, Eq f, Showa f, Compare_order g, Eq g, Showa g,
      Compare_order h,
      Showa h) => Logic_ext a b c () ->
                    (d -> Formula (Term a (e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (d -> Formula (Term a (Trans_var e, b)) ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                        (Term a (e, b) -> [Prelude.Char] -> [Prelude.Char]) ->
                          (Term a (Trans_var e, b) ->
                            [Prelude.Char] -> [Prelude.Char]) ->
                            Art_impl_ext a e b f g h (Hint d) () ->
                              Lts_impl a e b f h ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_art_invariants_impl lambda tc tc2 sa sa2 ai pi =
  check_art_invariants lambda tc tc2 sa sa2 (lts_of pi) (art_of pi ai)
    (make_hinter pi ai);

check_unique_names ::
  forall a b c d e f g h.
    (Eq e) => Art_impl_ext a b c d e f g h ->
                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_unique_names ai =
  check (distinct (map name (nodesb ai)))
    (shows_prec_list zero_nat
      ['N', 'o', 'd', 'e', 's', ' ', 'i', 'n', ' ', 'a', 'r', 't', ' ', 'g',
        'r', 'a', 'p', 'h', ' ', 'm', 'u', 's', 't', ' ', 'h', 'a', 'v', 'e',
        ' ', 'u', 'n', 'i', 'q', 'u', 'e', ' ', 'n', 'a', 'm', 'e', 's']);

restrict_invariants ::
  forall a b c d.
    (Eq a) => (a -> Formula (Term b (c, d))) ->
                Set a -> a -> Formula (Term b (c, d));
restrict_invariants i la l = (if member l la then i l else Conjunctiona []);

invariant_proof_checker ::
  forall a b c d e f g h.
    (Eq a, Showa a, Eq b, Showa b, Default d, Showa d, Eq e, Showa e,
      Compare_order f, Eq f, Showa f, Compare_order g, Showa g, Compare_order h,
      Eq h,
      Showa h) => Logic_ext a b c () ->
                    (d -> Formula (Term a (e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (d -> Formula (Term a (Trans_var e, b)) ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                        (Term a (e, b) -> [Prelude.Char] -> [Prelude.Char]) ->
                          (Term a (Trans_var e, b) ->
                            [Prelude.Char] -> [Prelude.Char]) ->
                            Lts_impl a e b f g ->
                              Invariant_proof a e b f h g d ->
                                Sum ([Prelude.Char] -> [Prelude.Char])
                                  (f -> Formula (Term a (e, b)));
invariant_proof_checker lambda tc tc2 sa sa2 pi (Impact ii ai) =
  let {
    i = map_of_default (Conjunctiona []) ii;
  } in (case catch_errora
               (bindb (check_unique_names ai)
                 (\ _ ->
                   bindb (catch_errora
                           (forallM
                             (\ l ->
                               let {
                                 il = i l;
                               } in bindb (check (formula (is_bool lambda) il)
    (shows_prec_list zero_nat
       ['i', 'l', 'l', '-', 'f', 'o', 'r', 'm', 'e', 'd', ' ', 'f', 'o', 'r',
         'm', 'u', 'l', 'a', ' ', 'f', 'o', 'r', ' ', 'l', 'o', 'c', 'a', 't',
         'i', 'o', 'n', ' '] .
      shows_prec zero_nat l))
                                      (\ _ ->
catch_errora
  (check_valid_formula tc sa
    (form_or (form_not (get_disj_invariant (art_of pi ai) l)) il))
  (\ x ->
    Inl (((shows_prec_list zero_nat
             ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'm', 'a', 't',
               'c', 'h', ' ', 'p', 'r', 'o', 'v', 'i', 'd', 'e', 'd', ' ', 'i',
               'n', 'v', 'a', 'r', 'i', 'a', 'n', 't', ' ', 'w', 'i', 't', 'h',
               ' ', 'i', 'n', 'v', 'a', 'r', 'i', 'a', 'n', 't', ' ', 'e', 'x',
               't', 'r', 'a', 'c', 't', 'e', 'd', ' ', 'f', 'r', 'o', 'm', ' ',
               'a', 'r', 't', '-', 'g', 'r', 'a', 'p', 'h', ' ', 'a', 't', ' ',
               'l', 'o', 'c', 'a', 't', 'i', 'o', 'n', ' '] .
            shows_prec zero_nat l) .
           shows_nl) .
          x))))
                             (nodes_lts_impl pi))
                           (\ x -> Inl (snd x)))
                     (\ _ ->
                       check_art_invariants_impl lambda tc tc2 sa sa2 ai pi)))
               (\ x ->
                 Inl ((((shows_prec_list zero_nat
                           ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n',
                             ' ', 'e', 'n', 's', 'u', 'r', 'i', 'n', 'g', ' ',
                             'i', 'n', 'v', 'a', 'r', 'i', 'a', 'n', 't', 's',
                             ' ', 'f', 'o', 'r', ' '] .
                          shows_lts sa sa2 pi) .
                         shows_prec_list zero_nat ['\n', 'v', 'i', 'a', ' ']) .
                        shows_art ai) .
                       x))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (restrict_invariants i (Set (nodes_lts_impl pi)));
       });

lex_less_formula ::
  forall a b c.
    (Showa a, Showa b,
      Showa c) => (Term a (Trans_var b, c) ->
                    Term a (Trans_var b, c) ->
                      Formula (Term a (Trans_var b, c))) ->
                    (Term a (Trans_var b, c) ->
                      Term a (Trans_var b, c) ->
                        Formula (Term a (Trans_var b, c))) ->
                      [Term a (Trans_var b, c)] ->
                        [Term a (Trans_var b, c)] ->
                          [Term a (Trans_var b, c)] ->
                            Formula (Term a (Trans_var b, c));
lex_less_formula less_eq_formula less_formula uu uv [] = Disjunction [];
lex_less_formula less_eq_formula less_formula uu [] uw = Disjunction [];
lex_less_formula less_eq_formula less_formula [] uv uw = Disjunction [];
lex_less_formula less_eq_formula less_formula (b : bs) (v1 : v1s) (v2 : v2s) =
  form_and
    (form_or (less_formula v1 v2)
      (form_and (less_eq_formula v1 v2)
        (lex_less_formula less_eq_formula less_formula bs v1s v2s)))
    (less_formula b v2);

hinter ::
  forall a b c d e f. Transition_removal_info a b c d e f -> e -> Hint f;
hinter (Transition_removal_info x1 x2 x3 x4 x5) = x5;

bound :: forall a b c d e f. Transition_removal_info a b c d e f -> b;
bound (Transition_removal_info x1 x2 x3 x4 x5) = x4;

rank :: forall a b c d e f. Transition_removal_info a b c d e f -> Sharp d -> a;
rank (Transition_removal_info x1 x2 x3 x4 x5) = x1;

check_lex_strict ::
  forall a b c d e f g.
    (Showa a, Eq b, Showa b, Default d, Showa d, Showa e, Compare f, Showa f,
      Showa g) => Logic_ext a b c () ->
                    (d -> Formula (Term a (Trans_var e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (Term a (Trans_var e, b) ->
                        [Prelude.Char] -> [Prelude.Char]) ->
                        (Term a (Trans_var e, b) ->
                          Term a (Trans_var e, b) ->
                            Formula (Term a (Trans_var e, b))) ->
                          (Term a (Trans_var e, b) ->
                            Term a (Trans_var e, b) ->
                              Formula (Term a (Trans_var e, b))) ->
                            (c -> Term a (e, b)) ->
                              Transition_removal_info [Term a (e, b)] [c] b f g
                                d ->
                                Lts_impl a e b (Sharp f) g ->
                                  (g, Transition_rule a e b (Sharp f)) ->
                                    Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_lex_strict lambda check_logic sa less_eq_formula less_formula constant_exp
  info pi (tr, Transition l r phi) =
  let {
    psi = lex_less_formula less_eq_formula less_formula
            (map (rename_vars_exp Pre . constant_exp) (bound info))
            (map (rename_vars_exp Post) (rank info r))
            (map (rename_vars_exp Pre) (rank info l));
  } in bindb (check (formula (is_bool lambda) psi)
               ((shows_prec_list zero_nat
                   ['l', 'e', 'x', '-', 'l', 'e', 's', 's', ' ', 'd', 'o', 'e',
                     's', ' ', 'n', 'o', 't', ' ', 'e', 'n', 'c', 'o', 'd', 'e',
                     ' ', 'v', 'a', 'l', 'i', 'd', ' ', 'f', 'o', 'r', 'm', 'u',
                     'l', 'a'] .
                  shows_nl) .
                 shows_prec_formula zero_nat psi))
         (\ _ ->
           check_formula_hint check_logic sa (hinter info tr)
             (form_or
               (form_not
                 (form_and
                   (form_and
                     (map_formula (rename_vars_exp Pre) (assertion_of pi l))
                     (map_formula (rename_vars_exp Post) (assertion_of pi r)))
                   phi))
               psi));

lex_leq_formula ::
  forall a b c.
    (Showa a, Showa b,
      Showa c) => (Term a (Trans_var b, c) ->
                    Term a (Trans_var b, c) ->
                      Formula (Term a (Trans_var b, c))) ->
                    (Term a (Trans_var b, c) ->
                      Term a (Trans_var b, c) ->
                        Formula (Term a (Trans_var b, c))) ->
                      [Term a (Trans_var b, c)] ->
                        [Term a (Trans_var b, c)] ->
                          Formula (Term a (Trans_var b, c));
lex_leq_formula less_eq_formula less_formula (v : va) [] = Disjunction [];
lex_leq_formula less_eq_formula less_formula [] (v : va) = Disjunction [];
lex_leq_formula less_eq_formula less_formula [] [] = Conjunctiona [];
lex_leq_formula less_eq_formula less_formula (v1 : v1s) (v2 : v2s) =
  form_or (less_formula v1 v2)
    (form_and (less_eq_formula v1 v2)
      (lex_leq_formula less_eq_formula less_formula v1s v2s));

check_lex_weak ::
  forall a b c d e f g.
    (Showa a, Eq b, Showa b, Default d, Showa d, Showa e, Compare f, Showa f,
      Showa g) => Logic_ext a b c () ->
                    (d -> Formula (Term a (Trans_var e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (Term a (Trans_var e, b) ->
                        [Prelude.Char] -> [Prelude.Char]) ->
                        (Term a (Trans_var e, b) ->
                          Term a (Trans_var e, b) ->
                            Formula (Term a (Trans_var e, b))) ->
                          (Term a (Trans_var e, b) ->
                            Term a (Trans_var e, b) ->
                              Formula (Term a (Trans_var e, b))) ->
                            Transition_removal_info [Term a (e, b)] [c] b f g
                              d ->
                              Lts_impl a e b (Sharp f) g ->
                                (g, Transition_rule a e b (Sharp f)) ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_lex_weak lambda check_logic sa less_eq_formula less_formula info pi
  (tr, Transition l r phi) =
  let {
    psi = lex_leq_formula less_eq_formula less_formula
            (map (rename_vars_exp Post) (rank info r))
            (map (rename_vars_exp Pre) (rank info l));
  } in bindb (check (formula (is_bool lambda) psi)
               ((shows_prec_list zero_nat
                   ['l', 'e', 'x', '-', 'l', 'e', 'q', ' ', 'd', 'o', 'e', 's',
                     ' ', 'n', 'o', 't', ' ', 'e', 'n', 'c', 'o', 'd', 'e', ' ',
                     'v', 'a', 'l', 'i', 'd', ' ', 'f', 'o', 'r', 'm', 'u', 'l',
                     'a'] .
                  shows_nl) .
                 shows_prec_formula zero_nat psi))
         (\ _ ->
           check_formula_hint check_logic sa (hinter info tr)
             (form_or
               (form_not
                 (form_and
                   (form_and
                     (map_formula (rename_vars_exp Pre) (assertion_of pi l))
                     (map_formula (rename_vars_exp Post) (assertion_of pi r)))
                   phi))
               psi));

processor ::
  forall a b c d e.
    (Eq a,
      Showa a) => ((a, Transition_rule b c d (Sharp e)) ->
                    Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                    ((a, Transition_rule b c d (Sharp e)) ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      [a] ->
                        Lts_impl b c d (Sharp e) a ->
                          Sum ([Prelude.Char] -> [Prelude.Char])
                            (Lts_impl b c d (Sharp e) a);
processor check_weak check_strict td pi =
  catch_errora
    (bindb
      (catch_errora
        (forallM
          (\ (tr, tau) ->
            (if membera td tr
              then bindb (check (is_sharp (source tau))
                           ((shows_prec_list zero_nat
                               ['n', 'o', 'n', '-', 's', 'h', 'a', 'r', 'p',
                                 ' ', 't', 'r', 'a', 'n', 's', 'i', 't', 'i',
                                 'o', 'n', ' '] .
                              shows_prec zero_nat tr) .
                             shows_prec_list zero_nat
                               [' ', 'c', 'a', 'n', 'n', 'o', 't', ' ', 'b',
                                 'e', ' ', 'r', 'e', 'm', 'o', 'v', 'e', 'd']))
                     (\ _ ->
                       catch_errora (check_strict (tr, tau))
                         (\ x ->
                           Inl (((shows_prec_list zero_nat
                                    ['F', 'a', 'i', 'l', 'e', 'd', ' ', 't',
                                      'o', ' ', 's', 't', 'r', 'i', 'c', 't',
                                      'l', 'y', ' ', 'o', 'r', 'i', 'e', 'n',
                                      't', ' ', 't', 'r', 'a', 'n', 's', 'i',
                                      't', 'i', 'o', 'n', ' '] .
                                   shows_prec zero_nat tr) .
                                  shows_nl) .
                                 x)))
              else (if is_sharp (source tau)
                     then catch_errora (check_weak (tr, tau))
                            (\ x ->
                              Inl (((shows_prec_list zero_nat
                                       ['F', 'a', 'i', 'l', 'e', 'd', ' ', 't',
 'o', ' ', 'w', 'e', 'a', 'k', 'l', 'y', ' ', 'o', 'r', 'i', 'e', 'n', 't', ' ',
 't', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', ' '] .
                                      shows_prec zero_nat tr) .
                                     shows_nl) .
                                    x))
                     else Inr ())))
          (transitions_impl pi))
        (\ x -> Inl (snd x)))
      (\ _ -> Inr (del_transitions_impl pi td)))
    (\ x ->
      Inl (((shows_prec_list zero_nat
               ['F', 'a', 'i', 'l', 'e', 'd', ' ', 't', 'o', ' ', 'e', 'l', 'i',
                 'm', 'i', 'n', 'a', 't', 'e', ' ', 't', 'r', 'a', 'n', 's',
                 'i', 't', 'i', 'o', 'n', 's', ' '] .
              shows_prec_list zero_nat td) .
             shows_prec_list zero_nat [':', '\n']) .
            x));

removed :: forall a b c d e f. Transition_removal_info a b c d e f -> [e];
removed (Transition_removal_info x1 x2 x3 x4 x5) = x2;

lex_processor ::
  forall a b c d e f g.
    (Showa a, Eq b, Showa b, Default d, Showa d, Showa e, Compare f, Eq f,
      Showa f, Eq g,
      Showa g) => Logic_ext a b c () ->
                    (d -> Formula (Term a (Trans_var e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (Term a (Trans_var e, b) ->
                        [Prelude.Char] -> [Prelude.Char]) ->
                        b -> (Term a (Trans_var e, b) ->
                               Term a (Trans_var e, b) ->
                                 Formula (Term a (Trans_var e, b))) ->
                               (Term a (Trans_var e, b) ->
                                 Term a (Trans_var e, b) ->
                                   Formula (Term a (Trans_var e, b))) ->
                                 (c -> Term a (e, b)) ->
                                   Transition_removal_info [Term a (e, b)] [c] b
                                     f g d ->
                                     Lts_impl a e b (Sharp f) g ->
                                       Sum ([Prelude.Char] -> [Prelude.Char])
 (Lts_impl a e b (Sharp f) g);
lex_processor lambda check_logic sa dom_type less_eq_formula less_formula
  constant_exp info pi =
  bindb (catch_errora
          (forallM
            (\ l ->
              catch_errora
                (forallM
                  (\ e ->
                    check (type_of lambda e == Just dom_type)
                      (shows_prec_list zero_nat
                         ['U', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ',
                           't', 'y', 'p', 'e', ' ', 'o', 'f', ' ', 'e', 'x',
                           'p', 'r', 'e', 's', 's', 'i', 'o', 'n', ':', '\n'] .
                        shows_prec_term zero_nat e))
                  (rank info l))
                (\ x -> Inl (snd x)))
            (nodes_lts_impl pi))
          (\ x -> Inl (snd x)))
    (\ _ ->
      bindb (catch_errora
              (forallM
                (\ b ->
                  check (type_of lambda (constant_exp b) == Just dom_type)
                    (shows_prec_list zero_nat
                       ['U', 'n', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ',
                         't', 'y', 'p', 'e', ' ', 'o', 'f', ' ', 'b', 'o', 'u',
                         'n', 'd', ':', ' '] .
                      shows_prec_term zero_nat (constant_exp b)))
                (bound info))
              (\ x -> Inl (snd x)))
        (\ _ ->
          processor
            (check_lex_weak lambda check_logic sa less_eq_formula less_formula
              info pi)
            (check_lex_strict lambda check_logic sa less_eq_formula less_formula
              constant_exp info pi)
            (removed info) pi));

fix_invariants ::
  forall a b c d e.
    (Compare d, Eq d, Showa d,
      Showa e) => Lts_impl a b c (Sharp d) e ->
                    (Sharp d -> Formula (Term a (b, c))) ->
                      Sum ([Prelude.Char] -> [Prelude.Char])
                        (Lts_impl a b c (Sharp d) e);
fix_invariants p i =
  catch_errora
    (let {
       ls = nodes_lts_impl p;
       old = assertion_of p;
     } in Inr (Lts_Impl (initiala p) (transitions_impl p)
                (map (\ l -> (l, form_and (old l) (i l))) ls)))
    (\ x ->
      Inl (shows_prec_list zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ',
               'f', 'i', 'x', 'i', 'n', 'g', ' ', 'i', 'n', 'v', 'a', 'r', 'i',
               'a', 'n', 't', 's', ' ', 'a', 's', ' ', 'a', 's', 's', 'e', 'r',
               't', 'i', 'o', 'n', 's', '\n'] .
            x));

trivial_checker ::
  forall a b c d e.
    (Showa d,
      Showa e) => (Term a (b, c) -> [Prelude.Char] -> [Prelude.Char]) ->
                    (Term a (Trans_var b, c) ->
                      [Prelude.Char] -> [Prelude.Char]) ->
                      Lts_impl a b c (Sharp d) e ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
trivial_checker shows_atom shows_tatom p =
  check (null (filter (\ tau -> is_sharp (source tau))
                (map snd (transitions_impl p))))
    (shows_prec_list zero_nat
       ['t', 'h', 'e', 'r', 'e', ' ', 'a', 'r', 'e', ' ', 'r', 'e', 'm', 'a',
         'i', 'n', 'i', 'n', 'g', ' ', 's', 'h', 'a', 'r', 'p', ' ', 't', 'r',
         'a', 'n', 's', 'i', 't', 'i', 'o', 'n', 's', ' ', 'i', 'n', ' '] .
      shows_lts shows_atom shows_tatom p);

location_addition_outgoing ::
  forall a b c d e f g.
    (Eq a, Showa a, Eq b, Showa b, Default d, Showa d, Eq e, Showa e, Compare f,
      Eq f, Showa f,
      Showa g) => Logic_ext a b c () ->
                    (d -> Formula (Term a (e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (Term a (e, b) -> [Prelude.Char] -> [Prelude.Char]) ->
                        Lts_impl a e b (Sharp f) g ->
                          Location_addition_info a e b (Sharp f) g ->
                            Sum ([Prelude.Char] -> [Prelude.Char])
                              (Lts_impl a e b (Sharp f) g);
location_addition_outgoing lambda logic_checker shows_atom p
  (Location_Addition_Info old new skip_ID skip) =
  bindb (check (not (membera (nodes_lts_impl p) new))
          ((shows_prec_list zero_nat
              ['l', 'o', 'c', 'a', 't', 'i', 'o', 'n', '-', 'i', 'd', ' '] .
             shows_prec_sharp zero_nat new) .
            shows_prec_list zero_nat
              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'f', 'r', 'e', 's',
                'h']))
    (\ _ ->
      bindb (check (is_sharp new)
              ((shows_prec_list zero_nat
                  ['n', 'e', 'w', ' ', 'l', 'o', 'c', 'a', 't', 'i', 'o', 'n',
                    ' '] .
                 shows_prec_sharp zero_nat new) .
                shows_prec_list zero_nat
                  [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 's', 'h', 'a',
                    'r', 'p', ' ', 'l', 'o', 'c', 'a', 't', 'i', 'o', 'n']))
        (\ _ ->
          bindb (check (is_sharp old)
                  ((shows_prec_list zero_nat
                      ['c', 'o', 'p', 'i', 'e', 'd', ' ', 'l', 'o', 'c', 'a',
                        't', 'i', 'o', 'n', ' '] .
                     shows_prec_sharp zero_nat old) .
                    shows_prec_list zero_nat
                      [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 's', 'h',
                        'a', 'r', 'p', ' ', 'l', 'o', 'c', 'a', 't', 'i', 'o',
                        'n']))
            (\ _ ->
              bindb (check (transition_rule lambda skip)
                      ((shows_prec_list zero_nat
                          ['n', 'e', 'w', ' ', 't', 'r', 'a', 'n', 's', 'i',
                            't', 'i', 'o', 'n', ' '] .
                         shows_prec zero_nat skip_ID) .
                        shows_prec_list zero_nat
                          [' ', 's', 'e', 'e', 'm', 's', ' ', 't', 'o', ' ',
                            'b', 'e', ' ', 'i', 'l', 'l', '-', 'f', 'o', 'r',
                            'm', 'e', 'd']))
                (\ _ ->
                  bindb (catch_errora
                          (check_skip_transition logic_checker shows_atom skip)
                          (\ x ->
                            Inl (((shows_prec_list zero_nat
                                     ['n', 'e', 'w', ' ', 't', 'r', 'a', 'n',
                                       's', 'i', 't', 'i', 'o', 'n', ' '] .
                                    shows_prec zero_nat skip_ID) .
                                   shows_prec_list zero_nat
                                     [' ', 'm', 'u', 's', 't', ' ', 'b', 'e',
                                       ' ', 's', 'k', 'i', 'p', ' ', 't', 'r',
                                       'a', 'n', 's', 'i', 't', 'i', 'o', 'n',
                                       '\n']) .
                                  x)))
                    (\ _ ->
                      bindb (check
                              (equal_sharp (source skip) old &&
                                equal_sharp (target skip) new)
                              (((((shows_prec_list zero_nat
                                     ['n', 'e', 'w', ' ', 's', 'k', 'i', 'p',
                                       ' ', 't', 'r', 'a', 'n', 's', 'i', 't',
                                       'i', 'o', 'n', ' '] .
                                    shows_prec zero_nat skip_ID) .
                                   shows_prec_list zero_nat
                                     [' ', 'm', 'u', 's', 't', ' ', 'b', 'e',
                                       ' ', 'f', 'r', 'o', 'm', ' ']) .
                                  shows_prec_sharp zero_nat old) .
                                 shows_prec_list zero_nat
                                   [' ', 't', 'o', ' ']) .
                                shows_prec_sharp zero_nat new))
                        (\ _ ->
                          let {
                            trans = transitions_impl p;
                            (sharp, flat) =
                              partition (\ tau -> is_sharp (source (snd tau)))
                                trans;
                            (sharp_modify, sharp_keep) =
                              partition
                                (\ tau -> equal_sharp (source (snd tau)) old)
                                sharp;
                            q = Lts_Impl (initiala p)
                                  ((skip_ID, skip) :
                                    flat ++
                                      sharp_keep ++
map (\ tau -> (fst tau, change_source new (snd tau))) sharp_modify)
                                  ((new, assertion_of p old) :
                                    assertion_impl p);
                          } in bindb (check
                                       (equal_formula
 (assertion_of p (initial (lts_of p))) (assertion_of q (initial (lts_of p))))
                                       (shows_prec_list zero_nat
 ['l', 'o', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'c', 'o', 'n', 'd', 'i', 't',
   'i', 'o', 'n', ' ', 'o', 'f', ' ', 'i', 'n', 'i', 't', 'i', 'a', 'l', ' ',
   's', 't', 'a', 't', 'e', ' ', 'h', 'a', 's', ' ', 'b', 'e', 'e', 'n', ' ',
   'c', 'h', 'a', 'n', 'g', 'e', 'd']))
                                 (\ _ -> Inr q)))))));

location_addition_incoming ::
  forall a b c d e f g.
    (Eq a, Showa a, Eq b, Showa b, Default d, Showa d, Eq e, Showa e, Compare f,
      Eq f, Showa f,
      Showa g) => Logic_ext a b c () ->
                    (d -> Formula (Term a (e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (Term a (e, b) -> [Prelude.Char] -> [Prelude.Char]) ->
                        Lts_impl a e b (Sharp f) g ->
                          Location_addition_info a e b (Sharp f) g ->
                            Sum ([Prelude.Char] -> [Prelude.Char])
                              (Lts_impl a e b (Sharp f) g);
location_addition_incoming lambda logic_checker shows_atom p
  (Location_Addition_Info new old skip_ID skip) =
  bindb (check (not (membera (nodes_lts_impl p) new))
          ((shows_prec_list zero_nat
              ['l', 'o', 'c', 'a', 't', 'i', 'o', 'n', '-', 'i', 'd', ' '] .
             shows_prec_sharp zero_nat new) .
            shows_prec_list zero_nat
              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'f', 'r', 'e', 's',
                'h']))
    (\ _ ->
      bindb (check (is_sharp new)
              ((shows_prec_list zero_nat
                  ['n', 'e', 'w', ' ', 'l', 'o', 'c', 'a', 't', 'i', 'o', 'n',
                    ' '] .
                 shows_prec_sharp zero_nat new) .
                shows_prec_list zero_nat
                  [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 's', 'h', 'a',
                    'r', 'p', ' ', 'l', 'o', 'c', 'a', 't', 'i', 'o', 'n']))
        (\ _ ->
          bindb (check (is_sharp old)
                  ((shows_prec_list zero_nat
                      ['c', 'o', 'p', 'i', 'e', 'd', ' ', 'l', 'o', 'c', 'a',
                        't', 'i', 'o', 'n', ' '] .
                     shows_prec_sharp zero_nat old) .
                    shows_prec_list zero_nat
                      [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 's', 'h',
                        'a', 'r', 'p', ' ', 'l', 'o', 'c', 'a', 't', 'i', 'o',
                        'n']))
            (\ _ ->
              bindb (check (transition_rule lambda skip)
                      ((shows_prec_list zero_nat
                          ['n', 'e', 'w', ' ', 't', 'r', 'a', 'n', 's', 'i',
                            't', 'i', 'o', 'n', ' '] .
                         shows_prec zero_nat skip_ID) .
                        shows_prec_list zero_nat
                          [' ', 's', 'e', 'e', 'm', 's', ' ', 't', 'o', ' ',
                            'b', 'e', ' ', 'i', 'l', 'l', '-', 'f', 'o', 'r',
                            'm', 'e', 'd']))
                (\ _ ->
                  bindb (catch_errora
                          (check_skip_transition logic_checker shows_atom skip)
                          (\ x ->
                            Inl (((shows_prec_list zero_nat
                                     ['n', 'e', 'w', ' ', 't', 'r', 'a', 'n',
                                       's', 'i', 't', 'i', 'o', 'n', ' '] .
                                    shows_prec zero_nat skip_ID) .
                                   shows_prec_list zero_nat
                                     [' ', 'm', 'u', 's', 't', ' ', 'b', 'e',
                                       ' ', 's', 'k', 'i', 'p', ' ', 't', 'r',
                                       'a', 'n', 's', 'i', 't', 'i', 'o', 'n',
                                       '\n']) .
                                  x)))
                    (\ _ ->
                      bindb (check
                              (equal_sharp (source skip) new &&
                                equal_sharp (target skip) old)
                              (((((shows_prec_list zero_nat
                                     ['n', 'e', 'w', ' ', 's', 'k', 'i', 'p',
                                       ' ', 't', 'r', 'a', 'n', 's', 'i', 't',
                                       'i', 'o', 'n', ' '] .
                                    shows_prec zero_nat skip_ID) .
                                   shows_prec_list zero_nat
                                     [' ', 'm', 'u', 's', 't', ' ', 'b', 'e',
                                       ' ', 'f', 'r', 'o', 'm', ' ']) .
                                  shows_prec_sharp zero_nat new) .
                                 shows_prec_list zero_nat
                                   [' ', 't', 'o', ' ']) .
                                shows_prec_sharp zero_nat old))
                        (\ _ ->
                          let {
                            trans = transitions_impl p;
                            (sharp, flat) =
                              partition (\ tau -> is_sharp (source (snd tau)))
                                trans;
                            (sharp_modify, sharp_keep) =
                              partition
                                (\ tau -> equal_sharp (target (snd tau)) old)
                                sharp;
                            q = Lts_Impl (initiala p)
                                  ((skip_ID, skip) :
                                    flat ++
                                      sharp_keep ++
map (\ tau -> (fst tau, change_target new (snd tau))) sharp_modify)
                                  ((new, assertion_of p old) :
                                    assertion_impl p);
                          } in bindb (check
                                       (equal_formula
 (assertion_of p (initial (lts_of p))) (assertion_of q (initial (lts_of p))))
                                       (shows_prec_list zero_nat
 ['l', 'o', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'c', 'o', 'n', 'd', 'i', 't',
   'i', 'o', 'n', ' ', 'o', 'f', ' ', 'i', 'n', 'i', 't', 'i', 'a', 'l', ' ',
   's', 't', 'a', 't', 'e', ' ', 'h', 'a', 's', ' ', 'b', 'e', 'e', 'n', ' ',
   'c', 'h', 'a', 'n', 'g', 'e', 'd']))
                                 (\ _ -> Inr q)))))));

location_addition ::
  forall a b c d e f g.
    (Eq a, Showa a, Eq b, Showa b, Default d, Showa d, Eq e, Showa e, Compare f,
      Eq f, Showa f,
      Showa g) => Logic_ext a b c () ->
                    (d -> Formula (Term a (e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (Term a (e, b) -> [Prelude.Char] -> [Prelude.Char]) ->
                        Lts_impl a e b (Sharp f) g ->
                          Location_addition_info a e b (Sharp f) g ->
                            Sum ([Prelude.Char] -> [Prelude.Char])
                              (Lts_impl a e b (Sharp f) g);
location_addition lambda logic_checker shows_atom p info =
  let {
    (Location_Addition_Info src _ _ _) = info;
  } in (if not (membera (nodes_lts_impl p) src)
         then location_addition_incoming lambda logic_checker shows_atom p info
         else location_addition_outgoing lambda logic_checker shows_atom p
                info);

call_graph_sharp_impl ::
  forall a b c d e.
    (Eq d) => Lts_impl a b c (Sharp d) e -> [(Sharp d, Sharp d)];
call_graph_sharp_impl r =
  remdups
    (concatMap
      (\ tau ->
        (if is_sharp (source (snd tau))
          then [(source (snd tau), target (snd tau))] else []))
      (transitions_impl r));

scc_decomposition ::
  forall a b c d e.
    (Eq d, Key d,
      Showa d) => Lts_impl a b c (Sharp d) e ->
                    [[Sharp d]] ->
                      Sum ([Prelude.Char] -> [Prelude.Char])
                        [Lts_impl a b c (Sharp d) e];
scc_decomposition cp sccs_info =
  let {
    cg = call_graph_sharp_impl cp;
    sccs = scc_decomp cg;
  } in bindb (catch_errora
               (forallM
                 (\ c ->
                   check (any (\ d -> equal_set (Set c) (Set d)) sccs_info)
                     ((shows_prec_list zero_nat
                         ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'f',
                           'i', 'n', 'd', ' ', 'S', 'C', 'C', ' '] .
                        shows_prec_list zero_nat c) .
                       shows_prec_list zero_nat
                         [' ', 'i', 'n', ' ', 'p', 'r', 'o', 'v', 'i', 'd', 'e',
                           'd', ' ', 'd', 'e', 'c', 'o', 'm', 'p', 'o', 's',
                           'i', 't', 'i', 'o', 'n']))
                 sccs)
               (\ x -> Inl (snd x)))
         (\ _ ->
           let {
             trans = transitions_impl cp;
             (sharp, flat) =
               partition (\ tau -> is_sharp (source (snd tau))) trans;
             cPs = map (\ c ->
                         let {
                           l = Set c;
                         } in Lts_Impl (initiala cp)
                                (flat ++
                                  filter
                                    (\ tau ->
                                      member (source (snd tau)) l &&
member (target (snd tau)) l)
                                    sharp)
                                (assertion_impl cp))
                     sccs_info;
           } in catch_errora (Inr cPs)
                  (\ x ->
                    Inl (((shows_prec_list zero_nat
                             ['e', 'r', 'r', 'o', 'r', ' ', 'i', 's', ' ', 'S',
                               'C', 'C', '-', 'd', 'e', 'c', 'o', 'm', 'p', 'o',
                               's', 'i', 't', 'i', 'o', 'n', ' ', 'w', '.', 'r',
                               '.', 't', '.', ' ', 's', 'c', 'c', 's', '_', 'i',
                               'n', 'f', 'o'] .
                            shows_prec_list zero_nat sccs_info) .
                           shows_nl) .
                          x)));

shows_prec_nat :: Nat -> Nat -> [Prelude.Char] -> [Prelude.Char];
shows_prec_nat = showsp_nat;

cut_transition_split ::
  forall a b c d e.
    (Eq a, Showa a,
      Eq e) => Cut_transition_split_info a ->
                 Lts_impl b c d (Sharp e) a ->
                   Sum ([Prelude.Char] -> [Prelude.Char])
                     [Lts_impl b c d (Sharp e) a];
cut_transition_split (Cut_Transition_Split_Info ct_ids) cp =
  catch_errora
    (let {
       (p, r) =
         partition ((\ tau -> is_sharp (source tau)) . snd)
           (transitions_impl cp);
       (ct, rr) = partition ((is_sharp . target) . snd) r;
       s = Set (map (source . snd) p);
       cT_ids = Set (concat ct_ids);
     } in bindb (check (not (is_sharp (initiala cp)))
                  (shows_prec_list zero_nat
                    ['i', 'n', 'i', 't', 'i', 'a', 'l', ' ', 's', 't', 'a', 't',
                      'e', ' ', 'm', 'u', 's', 't', ' ', 'n', 'o', 't', ' ',
                      'b', 'e', ' ', 's', 'h', 'a', 'r', 'p', 'e', 'd']))
            (\ _ ->
              bindb (catch_errora
                      (forallM
                        (\ (t_id, cta) ->
                          check (if member (target cta) s
                                  then member t_id cT_ids else True)
                            (shows_prec_list zero_nat
                               ['d', 'i', 'd', ' ', 'n', 'o', 't', ' ', 'f',
                                 'i', 'n', 'd', ' ', 'c', 'u', 't', '-', 't',
                                 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n',
                                 ' ', 'i', 'n', ' ', 'p', 'a', 'r', 't', 'i',
                                 't', 'i', 'o', 'n'] .
                              shows_prec zero_nat t_id))
                        ct)
                      (\ x -> Inl (snd x)))
                (\ _ ->
                  let {
                    rrp = rr ++ p;
                  } in Inr (map (\ ct_idsa ->
                                  Lts_Impl (initiala cp)
                                    (filter (\ cta -> membera ct_idsa (fst cta))
                                       ct ++
                                      rrp)
                                    (assertion_impl cp))
                             ct_ids))))
    (\ x ->
      Inl (shows_prec_list zero_nat
             ['e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 's', 'p', 'l', 'i',
               't', 't', 'i', 'n', 'g', ' ', 'c', 'u', 't', ' ', 't', 'r', 'a',
               'n', 's', 'i', 't', 'i', 'o', 'n', 's', '\n'] .
            x));

check_cooperation_proof ::
  forall a b c d e f g.
    (Eq a, Showa a, Eq b, Showa b, Default d, Showa d, Eq e, Showa e, Eq f,
      Key f, Showa f, Compare_order g, Eq g,
      Showa g) => Logic_ext a b c () ->
                    (d -> Formula (Term a (e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (d -> Formula (Term a (Trans_var e, b)) ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                        (Term a (e, b) -> [Prelude.Char] -> [Prelude.Char]) ->
                          (Term a (Trans_var e, b) ->
                            [Prelude.Char] -> [Prelude.Char]) ->
                            (Trans_var e ->
                              b -> Formula (Term a (Trans_var e, b)) ->
                                     Sum ([Prelude.Char] -> [Prelude.Char])
                                       ()) ->
                              b -> (Term a (Trans_var e, b) ->
                                     Term a (Trans_var e, b) ->
                                       Formula (Term a (Trans_var e, b))) ->
                                     (Term a (Trans_var e, b) ->
                                       Term a (Trans_var e, b) ->
 Formula (Term a (Trans_var e, b))) ->
                                       (c -> Term a (e, b)) ->
 ([Prelude.Char] -> [Prelude.Char]) ->
   Lts_impl a e b (Sharp f) g ->
     Cooperation_proof a e b c f g d ->
       Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
  less_eq_formula less_formula constant_exp pre cPi
  (Cut_Transition_Split scc_proofs) =
  bindb (catch_errora
          (cut_transition_split (Cut_Transition_Split_Info (map fst scc_proofs))
            cPi)
          (\ x ->
            Inl ((pre .
                   shows_prec_list zero_nat
                     [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ',
                       'c', 'u', 't', '-', 't', 'r', 'a', 'n', 's', 'i', 't',
                       'i', 'o', 'n', ' ', 's', 'p', 'l', 'i', 't', '\n']) .
                  x)))
    (\ sccs ->
      catch_errora
        (forallM_index
          (\ (scc, prof) j ->
            catch_errora
              (check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
                less_eq_formula less_formula constant_exp
                ((pre . shows_prec_list zero_nat ['.']) .
                  shows_prec_nat zero_nat (suc j))
                scc prof)
              (\ x ->
                Inl ((pre .
                       shows_prec_list zero_nat
                         [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                           'o', 'w', ' ', 'c', 'u', 't', '-', 't', 'r', 'a',
                           'n', 's', 'i', 't', 'i', 'o', 'n', ' ', 's', 'p',
                           'l', 'i', 't', '\n']) .
                      x)))
          (zip sccs (map snd scc_proofs)))
        (\ x -> Inl (snd x)));
check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
  less_eq_formula less_formula constant_exp pre cPi (Scc_Decomp scc_proofs) =
  bindb (catch_errora (scc_decomposition cPi (map fst scc_proofs))
          (\ x ->
            Inl ((pre .
                   shows_prec_list zero_nat
                     [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ',
                       'S', 'c', 'c', ' ', 'd', 'e', 'c', 'o', 'm', 'p', 'o',
                       's', 'i', 't', 'i', 'o', 'n', '\n']) .
                  x)))
    (\ sccs ->
      catch_errora
        (forallM_index
          (\ (scc, prof) j ->
            catch_errora
              (check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
                less_eq_formula less_formula constant_exp
                ((pre . shows_prec_list zero_nat ['.']) .
                  shows_prec_nat zero_nat (suc j))
                scc prof)
              (\ x ->
                Inl ((pre .
                       shows_prec_list zero_nat
                         [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                           'o', 'w', ' ', 'S', 'c', 'c', ' ', 'd', 'e', 'c',
                           'o', 'm', 'p', 'o', 's', 'i', 't', 'i', 'o', 'n',
                           '\n']) .
                      x)))
          (zip sccs (map snd scc_proofs)))
        (\ x -> Inl (snd x)));
check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
  less_eq_formula less_formula constant_exp pre cPi
  (Fresh_Variable_Addition info iproof) =
  bindb (catch_errora (fresh_variable_addition lambda def_checker sa2 cPi info)
          (\ x ->
            Inl ((pre .
                   shows_prec_list zero_nat
                     [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ',
                       'f', 'r', 'e', 's', 'h', ' ', 'v', 'a', 'r', 'i', 'a',
                       'b', 'l', 'e', ' ', 'a', 'd', 'd', 'i', 't', 'i', 'o',
                       'n', '\n']) .
                  x)))
    (\ q ->
      catch_errora
        (check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
          less_eq_formula less_formula constant_exp
          (pre . shows_prec_list zero_nat ['.', '1']) q iproof)
        (\ x ->
          Inl ((pre .
                 shows_prec_list zero_nat
                   [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l', 'o',
                     'w', ' ', 'f', 'r', 'e', 's', 'h', ' ', 'v', 'a', 'r', 'i',
                     'a', 'b', 'l', 'e', ' ', 'a', 'd', 'd', 'i', 't', 'i', 'o',
                     'n', '\n']) .
                x)));
check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
  less_eq_formula less_formula constant_exp pre cPi
  (Location_Addition info iproof) =
  bindb (catch_errora (location_addition lambda tc sa cPi info)
          (\ x ->
            Inl ((pre .
                   shows_prec_list zero_nat
                     [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ',
                       'l', 'o', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'a', 'd',
                       'd', 'i', 't', 'i', 'o', 'n', '\n']) .
                  x)))
    (\ q ->
      catch_errora
        (check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
          less_eq_formula less_formula constant_exp
          (pre . shows_prec_list zero_nat ['.', '1']) q iproof)
        (\ x ->
          Inl ((pre .
                 shows_prec_list zero_nat
                   [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l', 'o',
                     'w', ' ', 'l', 'o', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'a',
                     'd', 'd', 'i', 't', 'i', 'o', 'n', '\n']) .
                x)));
check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
  less_eq_formula less_formula constant_exp pre cPi
  (Transition_Removal info iproof) =
  bindb (catch_errora
          (lex_processor lambda tc2 sa2 dom_type less_eq_formula less_formula
            constant_exp info cPi)
          (\ x ->
            Inl ((pre .
                   shows_prec_list zero_nat
                     [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ',
                       't', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', ' ',
                       'r', 'e', 'm', 'o', 'v', 'a', 'l', '\n']) .
                  x)))
    (\ cPia ->
      catch_errora
        (check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
          less_eq_formula less_formula constant_exp
          (pre . shows_prec_list zero_nat ['.', '1']) cPia iproof)
        (\ x ->
          Inl ((pre .
                 shows_prec_list zero_nat
                   [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l', 'o',
                     'w', ' ', 't', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n',
                     ' ', 'r', 'e', 'm', 'o', 'v', 'a', 'l', '\n']) .
                x)));
check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
  less_eq_formula less_formula constant_exp pre cPi
  (Invariants_Update iproof cproof) =
  bindb (catch_errora (invariant_proof_checker lambda tc tc2 sa sa2 cPi iproof)
          (\ x ->
            Inl ((pre .
                   shows_prec_list zero_nat
                     [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ',
                       'i', 'n', 'v', 'a', 'r', 'i', 'a', 'n', 't', ' ', 'u',
                       'p', 'd', 'a', 't', 'e', '\n']) .
                  x)))
    (\ i ->
      bindb (fix_invariants cPi i)
        (\ q ->
          catch_errora
            (check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
              less_eq_formula less_formula constant_exp
              (pre . shows_prec_list zero_nat ['.', '1']) q cproof)
            (\ x ->
              Inl ((pre .
                     shows_prec_list zero_nat
                       [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                         'o', 'w', ' ', 'i', 'n', 'v', 'a', 'r', 'i', 'a', 'n',
                         't', ' ', 'u', 'p', 'd', 'a', 't', 'e', '\n']) .
                    x))));
check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
  less_eq_formula less_formula constant_exp pre cPi Trivial =
  catch_errora (trivial_checker sa sa2 cPi)
    (\ x ->
      Inl ((pre .
             shows_prec_list zero_nat
               [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 't', 'r',
                 'i', 'v', 'i', 'a', 'l', ' ', 'c', 'o', 'o', 'p', 'e', 'r',
                 'a', 't', 'i', 'o', 'n', ' ', 't', 'e', 'r', 'm', 'i', 'n',
                 'a', 't', 'i', 'o', 'n', ' ', 'c', 'h', 'e', 'c', 'k', 'e',
                 'r', '\n']) .
            x));

check_termination_proof ::
  forall a b c d e f g.
    (Eq a, Showa a, Eq b, Showa b, Default d, Showa d, Eq e, Showa e, Eq f,
      Key f, Showa f, Compare g, Eq g,
      Showa g) => Logic_ext a b c () ->
                    (d -> Formula (Term a (e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (d -> Formula (Term a (Trans_var e, b)) ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                        (Term a (e, b) -> [Prelude.Char] -> [Prelude.Char]) ->
                          (Term a (Trans_var e, b) ->
                            [Prelude.Char] -> [Prelude.Char]) ->
                            (Trans_var e ->
                              b -> Formula (Term a (Trans_var e, b)) ->
                                     Sum ([Prelude.Char] -> [Prelude.Char])
                                       ()) ->
                              b -> (Term a (Trans_var e, b) ->
                                     Term a (Trans_var e, b) ->
                                       Formula (Term a (Trans_var e, b))) ->
                                     (Term a (Trans_var e, b) ->
                                       Term a (Trans_var e, b) ->
 Formula (Term a (Trans_var e, b))) ->
                                       (c -> Term a (e, b)) ->
 ([Prelude.Char] -> [Prelude.Char]) ->
   Lts_impl a e b f g ->
     Termination_proof a e b c f g d ->
       Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_termination_proof lambda tc tc2 sa sa2 def_checker dom_type
  less_eq_formula less_formula constant_exp pre pi (Via_Cooperation cp_proofs) =
  bindb (catch_errora
          (create_initial_cp_prog lambda tc sa pi (map fst cp_proofs))
          (\ x ->
            Inl ((pre .
                   shows_prec_list zero_nat
                     [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ',
                       'c', 'r', 'e', 'a', 't', 'i', 'n', 'g', ' ', 'i', 'n',
                       'i', 't', 'i', 'a', 'l', ' ', 'c', 'o', 'o', 'p', 'e',
                       'r', 'a', 't', 'i', 'o', 'n', ' ', 'p', 'r', 'o', 'g',
                       'r', 'a', 'm', '\n']) .
                  x)))
    (\ cPi ->
      catch_errora
        (forallM_index
          (\ (r, prf) i ->
            catch_errora
              (check_cooperation_proof lambda tc tc2 sa sa2 def_checker dom_type
                less_eq_formula less_formula constant_exp
                ((pre . shows_prec_list zero_nat ['.']) .
                  shows_prec_nat zero_nat (suc i))
                r prf)
              (\ x ->
                Inl ((pre .
                       shows_prec_list zero_nat
                         [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                           'o', 'w', ' ', 's', 'w', 'i', 't', 'c', 'h', 'i',
                           'n', 'g', ' ', 't', 'o', ' ', 'i', 'n', 'i', 't',
                           'i', 'a', 'l', ' ', 'c', 'o', 'o', 'p', 'e', 'r',
                           'a', 't', 'i', 'o', 'n', ' ', 'p', 'r', 'o', 'g',
                           'r', 'a', 'm', '\n']) .
                      x)))
          (zip cPi (map snd cp_proofs)))
        (\ x -> Inl (snd x)));
check_termination_proof lambda tc tc2 sa sa2 def_checker dom_type
  less_eq_formula less_formula constant_exp pre pi Triviala =
  catch_errora
    (check (null (transitions_impl pi))
      (shows_prec_list zero_nat
        ['t', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', ' ', 'r', 'u', 'l',
          'e', 's', ' ', 'r', 'e', 'm', 'a', 'i', 'n', 's', ' ', 'a', 't', ' ',
          't', 'r', 'i', 'v', 'i', 'a', 'l', ' ', 't', 'e', 'r', 'm', 'i', 'n',
          'a', 't', 'i', 'o', 'n', ' ', 'p', 'r', 'o', 'o', 'f']))
    (\ x ->
      Inl ((pre .
             shows_prec_list zero_nat
               [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 't', 'r',
                 'i', 'v', 'i', 'a', 'l', ' ', 't', 'e', 'r', 'm', 'i', 'n',
                 'a', 't', 'i', 'o', 'n', ' ', 'c', 'h', 'e', 'c', 'k', 'e',
                 'r', '\n']) .
            x));

checka ::
  forall a b c d e f g.
    (Eq a, Showa a, Eq b, Showa b, Default d, Showa d, Eq e, Showa e, Eq f,
      Key f, Showa f, Compare g, Eq g,
      Showa g) => Logic_ext a b c () ->
                    (d -> Formula (Term a (e, b)) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (d -> Formula (Term a (Trans_var e, b)) ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                        (Term a (e, b) -> [Prelude.Char] -> [Prelude.Char]) ->
                          (Term a (Trans_var e, b) ->
                            [Prelude.Char] -> [Prelude.Char]) ->
                            (Trans_var e ->
                              b -> Formula (Term a (Trans_var e, b)) ->
                                     Sum ([Prelude.Char] -> [Prelude.Char])
                                       ()) ->
                              b -> (Term a (Trans_var e, b) ->
                                     Term a (Trans_var e, b) ->
                                       Formula (Term a (Trans_var e, b))) ->
                                     (Term a (Trans_var e, b) ->
                                       Term a (Trans_var e, b) ->
 Formula (Term a (Trans_var e, b))) ->
                                       (c -> Term a (e, b)) ->
 Lts_impl a e b f g ->
   Termination_proof a e b c f g d -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
checka lambda tc tc2 sa sa2 def_checker dom_type less_eq_formula less_formula
  constant_exp pi prf =
  bindb (catch_errora (check_lts_impl lambda pi)
          (\ x ->
            Inl (shows_prec_list zero_nat
                   ['i', 'n', 'p', 'u', 't', ' ', 'L', 'T', 'S', ' ', 'i', 's',
                     ' ', 'n', 'o', 't', ' ', 'w', 'e', 'l', 'l', '-', 'f', 'o',
                     'r', 'm', 'e', 'd'] .
                  x)))
    (\ _ ->
      check_termination_proof lambda tc tc2 sa sa2 def_checker dom_type
        less_eq_formula less_formula constant_exp
        (shows_prec_list zero_nat ['1']) pi prf);

check_terminationa ::
  forall a b c.
    (Compare_order a, Eq a, Showa a, Eq b, Key b, Showa b, Compare c, Eq c,
      Showa c) => Lts_impl LIA_op a LIA_type b c ->
                    Termination_proof LIA_op a LIA_type LIA_value b c
                      Lia_hints ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_terminationa =
  checka lia check_lia_clause check_lia_clause show_LIA_exp show_LIA_exp
    def_checker IntegerT (\ s t -> Atom (Fun Lesseq [s, t]))
    (\ s t -> Atom (Fun Less [s, t])) constant_exp;

check_termination :: [Prelude.Char] -> Sum_bot [Prelude.Char] [Prelude.Char];
check_termination input =
  (case doc_of_string input of {
    Inl e ->
      errora
        (['e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 'x', 'm', 'l', ':',
           '\n'] ++
          e);
    Inr xml ->
      binda (catch_error (xmldoc_termination_cert_problem xml)
              (\ e ->
                errora
                  (['e', 'r', 'r', 'o', 'r', ' ', 'p', 'a', 'r', 's', 'i', 'n',
                     'g', ' ', 'i', 'n', 'p', 'u', 't', ':', '\n'] ++
                    e)))
        (\ (Termination_Cert_Problem pi p) ->
          (case check_terminationa pi p of {
            Inl e ->
              errora
                (['e', 'r', 'r', 'o', 'r', ' ', 'e', 'n', 's', 'u', 'r', 'i',
                   'n', 'g', ' ', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i',
                   'o', 'n', ':', '\n'] ++
                  e []);
            Inr _ ->
              returna
                ['e', 'n', 's', 'u', 'r', 'e', 'd', ' ', 't', 'e', 'r', 'm',
                  'i', 'n', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' ', 'l',
                  'i', 'n', 'e', 'a', 'r', ' ', 'I', 'T', 'S'];
          }));
  });

}
